<?php

namespace Teknisa\MAN\Services\AppsIntegrations\Apps;

use Teknisa\MAN\Services\AppsIntegrations\Data\IntegrationData;

class IFood extends AAppService {
    private const IFOOD_ID = 'IFO';
    
    private const START_INTEGRATION_ROUTE = '/createIfoodJob'; 
    private const STOP_INTEGRATION_ROUTE  = '/deleteJob';
    
    // @Override
    public function getStartIntegrationData() {
        return new IntegrationData (
            $this->getStartIntegrationURL(),
            self::START_INTEGRATION_ROUTE,
            $this->getStartIntegrationParams()
        );
    }
    
    // @Override
    public function getStopIntegrationData() {
        return new IntegrationData (
            $this->getStopIntegrationURL(),
            self::STOP_INTEGRATION_ROUTE,
            $this->getStopIntegrationParams()
        );
    }
    
    
    private function getStartIntegrationURL() {
        return $this->getAPIURL();
    }
    
    private function getStartIntegrationParams() {
        $OMInfo = $this->getOMInfo();
        
        $clientName = $OMInfo['NMRAZSOCIALORG'];
        $clientType = $this->getClientId($OMInfo['IDORGSAAS']);
        
        $clientEnv  = $this->environment->getNrOrgTrab();
        
        $authToken  = $this->getAPIToken();
        
        $jobName    = $this->getJobName(self::IFOOD_ID);
        
        return array(
            "clientName"    => $clientName,
            "clientEnv"     => $clientEnv,
            "clientType"    => $clientType,
            "authToken"     => $authToken,
            "jobName"       => $jobName,
        );
    }
    
    private function getStopIntegrationURL() {
        return $this->getAPIURL();
    }
    
    private function getStopIntegrationParams() {
        $OMInfo = $this->getOMInfo();
        
        $authToken  = $this->getAPIToken();
        $jobName    = $this->getJobName(self::IFOOD_ID);
        
        return array(
            "authToken"     => $authToken,
            "jobName"       => $jobName,
        );
    }
}