<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelMTCService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
	}

	private function setParameters($conditions, $unidade) {
    	return array (
            ':DTINI' => $conditions['DTENTRVENDA'][0],
            ':DTFIN' => $conditions['DTENTRVENDA'][1],
            ':CDFILIAL' => $unidade['CDFILIAL'],
            ':MTCBASE' => $unidade['MTCBASE'],
            ':NRORG' => $conditions['NRORG'],
            ':TCDPRODUTO' => $conditions['TCDPRODUTO'],
            ':CDPRODLIST' => $conditions['CDPRODLIST'],
            ':CDARVPRODF' => $conditions['CDARVPRODF'],
            ':CDARVPRODI' => $conditions['CDARVPRODI'],
            ':CDNVPRODUTO' => str_replace('%', '', $conditions['CDNVPRODUTO']),
            ':CDNVPRODUTOAGRUP' => $conditions['CDNVPRODUTOAGRUP'],
            ':PRODNIV' => $conditions['PRODNIV']
        );
    }

    private function paramsToMTCBase($conditions) {
    	return array (
            ':DTINI' => $conditions['DTENTRVENDA'][0],
            ':DTFIN' => $conditions['DTENTRVENDA'][1],
            ':CDFILIAL' => implode('_',$conditions['CDFILIAL']),
            ':TCDFILIAL' => count($conditions['CDFILIAL']) > 0 ? 'N' : 'T',
            ':NRORG' => $conditions['NRORG']
        );

    }

    public function getBase($conditions){
        $paramsBase = self::paramsToMTCBase($conditions);

        $arrayOper = $conditions['CDFILIAL'];
        $base = [];
            $estrutura = array (
                    'CDFILIAL' => null,
                    'MTCBASE' => null);
        foreach ($arrayOper as $oper) {
            $paramsBase['CDFILIAL'] = $oper;
            $retorno = $this->entityManager->getConnection()->fetchAssoc(self::GET_MTCBASE_FILIAL, $paramsBase);
            if(empty($retorno)){
                $base[] = $estrutura;
            } else {
                $base[] = $this->entityManager->getConnection()->fetchAssoc(self::GET_MTCBASE_FILIAL, $paramsBase);
            }
        }
        $resultFinal = [];

        $filialIndex = 0;

        foreach ($base as $unidade) {
            $valueOfResult = self::getData($conditions, $unidade, $filialIndex);
            array_push($resultFinal, $valueOfResult);
            $filialIndex ++;
        }

        return $resultFinal;
    }

    public function getData($conditions, $unidade, $filialIndex){

        $params = self::setParameters($conditions, $unidade);

        $query = self::INI_QUERY_GET_MTC_PROD_FILIAL."FILIAL".$filialIndex.self::FIM_QUERY_GET_MTC_PROD_FILIAL;

        return  $this->entityManager->getConnection()->fetchAll($query, $params);
    }

    const INI_QUERY_GET_MTC_PROD_FILIAL = "SELECT FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, PV.CDARVPROD||' - '||PV.NMPRODUTO AS LABELPRODAVO, P.CDARVPROD||' - '||P.NMPRODUTO AS LABELPROD, P.CDARVPROD, P.SGUNIDADE, I.CDPRODUTO, P.NMPRODUTO, ((SUM(I.QTPRODVEND)/:MTCBASE)*1000) AS ",
          FIM_QUERY_GET_MTC_PROD_FILIAL = "
          FROM ITEMVENDA I
          JOIN PRODUTO P
            ON I.CDPRODUTO = P.CDPRODUTO
           AND I.NRORG = P.NRORG
          JOIN PRODUTO PV
            ON P.NRORG = PV.NRORG
          JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                      FILOCA.NRORG, V.DTENTRVENDA
                 FROM VENDA V
                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                         FROM CAIXA C
                         JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                 FROM LOJA L
                                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                         FROM FILIAL F
                                        WHERE F.CDFILIAL = :CDFILIAL
                                          AND F.NRORG =:NRORG) FI
                                   ON L.CDFILIAL = FI.CDFILIAL
                                  AND L.NRORG = FI.NRORG) FILO
                           ON C.CDFILIAL = FILO.CDFILIAL
                          AND C.CDLOJA = FILO.CDLOJA
                          AND C.NRORG = FILO.NRORG) FILOCA
                   ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                  AND V.NRORG = FILOCA.NRORG
                WHERE V.IDSITUVENDA = 'O'
                  AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN) FILOCAVE
            ON I.CDFILIAL = FILOCAVE.CDFILIAL
           AND I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
           AND I.CDCAIXA = FILOCAVE.CDCAIXA
           AND I.NRORG = FILOCAVE.NRORG
         WHERE I.NRORG = :NRORG
           AND P.CDARVPROD LIKE PV.CDARVPROD||'%'
           AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
           AND ((((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 ) OR (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ))) OR (P.CDARVPROD LIKE :PRODNIV) OR (:TCDPRODUTO = 'T'))
         GROUP BY  FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, P.CDARVPROD, I.CDPRODUTO, P.NMPRODUTO, PV.CDARVPROD, PV.NMPRODUTO, P.SGUNIDADE
    ";

    const GET_MTCBASE_FILIAL = "
        SELECT V.CDFILIAL, COUNT(V.NRSEQVENDA) AS MTCBASE
            FROM VENDA V
            WHERE V.IDSITUVENDA = 'O'
               AND V.DTENTRVENDA BETWEEN :DTINI AND :DTFIN
               AND V.NRORG = :NRORG
               AND ( ( INSTR( :CDFILIAL, V.CDFILIAL ) <> 0 ) OR ( :TCDFILIAL = 'T' ) )
            GROUP BY V.CDFILIAL
    ";
}