<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;

class MapaParam extends \Teknisa\MAN\Controllers\TeknisaCrud {

   public function __construct ($crudService, Manager $dataSourceManager) {
        $this->crudService              = $crudService;
        $this->dataSourceManager        = $dataSourceManager;
   }

    public function getMapa(DTO\Request\Filter $request, DTO\Response $response) {
        $data = array(
            (object) array(
                "ID"     => "1",
                "NAME"   => "Cadastro de Loja",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "1.1",
                "NAME"   => "Parametrização",
                "PATH"   => "Cadastro de Loja->Parametrização",
                "PARENT" => "1"
            ),
            (object) array(
                "ID"     => "1.1.1",
                "NAME"   => "Frente de Caixa",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa",
                "PARENT" => "1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1",
                "NAME"   => "Frente de Caixa(1)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)",
                "PARENT" => "1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.1",
                "NAME"   => "Cobra Taxa de Serviço",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Taxa de Serviços",
                "COLLUMN"=> "IDCOMISVENDA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.2",
                "NAME"   => "Percentual",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Taxa de Serviços",
                "COLLUMN"=> "VRCOMISVENDA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.3",
                "NAME"   => "Percentual 2",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Taxa de Serviços",
                "COLLUMN"=> "VRCOMISVENDA2",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.4",
                "NAME"   => "Percentual 3",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Taxa de Serviços",
                "COLLUMN"=> "VRCOMISVENDA3",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.5",
                "NAME"   => "Taxa de Serviço",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Tratamento da Taxa de Serviço",
                "COLLUMN"=> "IDTRATTAXASERV",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.6",
                "NAME"   => "Produto",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Tratamento da Taxa de Serviço",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.7",
                "NAME"   => "Taxa de Entrega",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Tratamento da Taxa de Entrega (Delivery)",
                "COLLUMN"=> "IDTRATTAXAENTR",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.8",
                "NAME"   => "Produto",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Tratamento da Taxa de Entrega (Delivery)",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.9",
                "NAME"   => "Cobra Couver Artístico",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Couver Artístico",
                "COLLUMN"=> "IDCOUVERART",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.9.1",
                "NAME"   => "Produto do Couver Artístico",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Couver Artístico",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.10",
                "NAME"   => "Utiliza Consumação Mínima",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Consumação Mínima",
                "COLLUMN"=> "IDCONSUMAMIN",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.10.1",
                "NAME"   => "Produto para Consumação Masculina",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Consumação Mínima",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.10.2",
                "NAME"   => "Produto para Consumação Feminina",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Consumação Mínima",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.1.11",
                "NAME"   => "Utiliza Garçom Padrão",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Garçom Padrão",
                "COLLUMN"=> "IDUTIVENDPAD",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.12",
                "NAME"   => "Garçom",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Garçom Padrão",
                "COLLUMN"=> "NMRAZSOCVEN",
                "TABLE"  => "VENDEDOR",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.13",
                "NAME"   => "Utiliza Tela de Controle de Produção (Delivery)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Outros",
                "COLLUMN"=> "IDCONTROPROD",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.14",
                "NAME"   => "Imprime CPF/CNPJ do Cliente no Cupom Fiscal",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Outros",
                "COLLUMN"=> "IDIMPCNPJCLIE",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.15",
                "NAME"   => "Emite Cupom Troca de Marcadoria somente para Vendas Comanda e Restaurante (Mesas)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Outros",
                "COLLUMN"=> "IDIMPCUPTROCA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.16",
                "NAME"   => "Prazo para troca (dias)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Outros",
                "COLLUMN"=> "NRDIASCUPTROCA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.17",
                "NAME"   => "Imprime o desconto dos produtos na parcial da conta",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(1)->Outros",
                "COLLUMN"=> "IDMOSTRADESPARC",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.2",
                "NAME"   => "Frente de Caixa(2)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)",
                "PARENT" => "1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.2.1",
                "NAME"   => "Solicita Observação na realização de um pedido",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação na realização de um pedido",
                "COLLUMN"=> "IDSOLOBSPED",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.10",
                "NAME"   => "Grupo Pedido",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação na realização de um pedido",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.11",
                "NAME"   => "Ordem da impressão da observação do pedido",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação na realização de um pedido",
                "COLLUMN"=> "IDPOSOBSPED",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.2",
                "NAME"   => "Solicita observação no cancelamento de um produto",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação no cancelamento de um produto",
                "COLLUMN"=> "IDSOLOBSCAN",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.3",
                "NAME"   => "Grupo Cancelamento Produto",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação no cancelamento de um produto",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.4",
                "NAME"   => "Solicita observação no cancelamento de um cupom",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação no cancelamento de um cupom",
                "COLLUMN"=> "IDSOLOBSCANCUP",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.5",
                "NAME"   => "Grupo Cancelamento Cupom",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação no cancelamento de um cupom",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.6",
                "NAME"   => "Solicita observação no desconto da venda",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação no desconto da venda",
                "COLLUMN"=> "IDSOLOBSDESC",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.7",
                "NAME"   => "Grupo Desconto",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Observação no desconto da venda",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.8",
                "NAME"   => "Grupo Mensagem Produção",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Grupo de observações para envio de mensagens para produção",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.2.9",
                "NAME"   => "Obriga observação no cancelamento de Produto/Cupom",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(2)->Grupo de observações para envio de mensagens para produção",
                "COLLUMN"=> "IDOBRIGAOBSCAN",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.1.3",
                "NAME"   => "Frente de Caixa(3)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)",
                "PARENT" => "1.1.1"
            ),
            (object) array(
                "ID"     => "1.1.1.3.1",
                "NAME"   => "Sinaliza pedidos da Tela de Controle de Pedidos com mais de (minutos)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)",
                "COLLUMN"=> "QTMAXPEDFOS",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.2",
                "NAME"   => "Sinaliza mesa sem pedir a mais de (minutos)",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)",
                "COLLUMN"=> "NRMINSEMCONS",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.3",
                "NAME"   => "Cobra o preço do produto mais caro nas vendas de produtos combinados",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)",
                "COLLUMN"=> "IDTIPCOBRA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.4",
                "NAME"   => "Utiliza Controle de Posição na venda do tipo Mesa",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)",
                "COLLUMN"=> "IDLUGARMESA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.5",
                "NAME"   => "Utiliza 'Corte' do acompanhamento do pedido por posição",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)",
                "COLLUMN"=> "IDUTLCORTEPED",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.6",
                "NAME"   => "Utiliza posição nomeada",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Controle de Mesa",
                "COLLUMN"=> "IDUTLNMCONSMESA",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.7",
                "NAME"   => "Solicita mensagem iniciando venda sugestiva para o operador",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Mensagem iniciando venda sugestiva para o operador",
                "COLLUMN"=> "IDEXIBEMENSOP",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.8",
                "NAME"   => "Quantidade máxima permitida de venda por produto por vez",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Limitador de quantidade vendida",
                "COLLUMN"=> "QTMAXPERVNDPROD",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.9",
                "NAME"   => "Exibe Ticket Médio e Cupoms Concluídos no Frente de Caixa",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Limitador de quantidade vendida",
                "COLLUMN"=> "IDEXIBTICCUP",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.10",
                "NAME"   => "Desbloqueio automático dos produtos no Frente De Caixa",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Limitador de quantidade vendida",
                "COLLUMN"=> "IDDESBLOPRODAUT",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.11",
                "NAME"   => "Percentual máximo de desconto",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Limitador de quantidade vendida",
                "COLLUMN"=> "VRMAXDESCONTO",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.12",
                "NAME"   => "Mesa/Comanda",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Limitador de quantidade vendida",
                "COLLUMN"=> "IDUTLSENHAOPER",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.13",
                "NAME"   => "Permite alterar o valor da Taxa de Serviço no Recebimento de Venda",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Taxa de Serviço",
                "COLLUMN"=> "IDALTTXSERV",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.1.3.14",
                "NAME"   => "Obriga fechamento de pedidos Delivery abertos a mais de 24 horas",
                "PATH"   => "Cadastro de Loja->Parametrização->Frente de Caixa->Frente de Caixa(3)->Taxa de Serviço",
                "COLLUMN"=> "IDOBRFECHDLV",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.2",
                "NAME"   => "Parametrização da Comanda",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda",
                "PARENT" => "1.1"
            ),
            (object) array(
                "ID"     => "1.1.2.1",
                "NAME"   => "Solicita a informação do número da mesa na abertura da comanda",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Abertura de comanda",
                "COLLUMN"=> "IDINFMESACOM",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.2",
                "NAME"   => "Solicita a informação do garçom na abertura da comanda",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Abertura de comanda",
                "COLLUMN"=> "IDINFVENDCOM",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.3",
                "NAME"   => "Solicita a informação do consumidor na abertura da comanda",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Abertura de comanda",
                "COLLUMN"=> "IDINFCONSCOM",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.4",
                "NAME"   => "Gera número da comanda automaticamente",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Abertura de comanda",
                "COLLUMN"=> "IDCOMANDAAUT",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.5",
                "NAME"   => "Mesa Padrão",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Abertura de comanda",
                "COLLUMN"=> "NMMESA",
                "TABLE"  => "MESA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.6",
                "NAME"   => "Permite bloqueio da comanda após emissão da parcial da conta",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Abertura de comanda",
                "COLLUMN"=> "IDBLOQCOMPARC",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.7",
                "NAME"   => "Reutilização de Comanda",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Reutilização de Comanda",
                "COLLUMN"=> "IDREUTILIZACMD",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.2.8",
                "NAME"   => "Agrupar pedidos de comandas distintas",
                "PATH"   => "Cadastro de Loja->Parametrização->Parametrização da Comanda->Pedidos",
                "COLLUMN"=> "IDAGRUPAPEDCOM",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.2"
            ),
            (object) array(
                "ID"     => "1.1.3",
                "NAME"   => "Gestão de Vendas",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas",
                "PARENT" => "1.1"
            ),
            (object) array(
                "ID"     => "1.1.3.1",
                "NAME"   => "Tabela Preço",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas->Tabela de Preço utilizada pela loja na venda de produtos",
                "COLLUMN"=> "NMTABEPREC",
                "TABLE"  => "TABEPREC",
                "PARENT" => "1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.3.2",
                "NAME"   => "Almoxarifado",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas->Estoque Padrão utilizado pela loja na consolidação de vendas",
                "COLLUMN"=> "DSALMOXARIFE",
                "TABLE"  => "ALMOXARIFADO",
                "PARENT" => "1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.3.3",
                "NAME"   => "Localização",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas->Estoque Padrão utilizado pela loja na consolidação de vendas",
                "COLLUMN"=> "CDLOCALESTOQ",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.3.4",
                "NAME"   => "Tipo de Operação",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas->Tipo de Operação utilizado pela loja na consolidação de vendas",
                "COLLUMN"=> "NMTIPOOPER",
                "TABLE"  => "TIPOOPERAC",
                "PARENT" => "1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.3.5",
                "NAME"   => "Ip Primário",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas->Conexão no Caixa (IpServer)",
                "COLLUMN"=> "IPSERVPRI",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.3.6",
                "NAME"   => "Ip Secundário",
                "PATH"   => "Cadastro de Loja->Parametrização->Gestão de Vendas->Conexão no Caixa (IpServer)",
                "COLLUMN"=> "IPSERVSEC",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.3"
            ),
            (object) array(
                "ID"     => "1.1.4",
                "NAME"   => "TEF",
                "PATH"   => "Cadastro de Loja->Parametrização->TEF",
                "PARENT" => "1.1"
            ),
            (object) array(
                "ID"     => "1.1.4.1",
                "NAME"   => "Imprime cupom TEF reduzido",
                "PATH"   => "Cadastro de Loja->Parametrização->TEF->Parametrização TEF",
                "COLLUMN"=> "IDIMPRCUPTEFRED",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.4"
            ),
            (object) array(
                "ID"     => "1.1.4.2",
                "NAME"   => "Habilita TEF para exibir tela de forma de pagamento",
                "PATH"   => "Cadastro de Loja->Parametrização->TEF->Parametrização TEF",
                "COLLUMN"=> "IDHABFORMTEF",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.4"
            ),
            (object) array(
                "ID"     => "1.1.4.3",
                "NAME"   => "Imprime via do Consumidor",
                "PATH"   => "Cadastro de Loja->Parametrização->TEF->Parametrização TEF",
                "COLLUMN"=> "IDIMPRVIACONSTEF",
                "TABLE"  => "LOJA",
                "PARENT" => "1.1.4"
            ),
            (object) array(
                "ID"     => "1.2",
                "NAME"   => "Produtos por Loja",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "PARENT" => "1"
            ),
            (object) array(
                "ID"     => "1.2.1",
                "NAME"   => "Setor de Produção",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "NMSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "1.2"
            ),
            (object) array(
                "ID"     => "1.2.2",
                "NAME"   => "Impressora do Puxa",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "NMIMPRLOJA",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.2"
            ),
            (object) array(
                "ID"     => "1.2.3",
                "NAME"   => "Impressora de Produção",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "NMIMPRLOJA",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.2"
            ),
            (object) array(
                "ID"     => "1.2.4",
                "NAME"   => "Impressora de Produção (2)",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "NMIMPRLOJA",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.2"
            ),
            (object) array(
                "ID"     => "1.2.5",
                "NAME"   => "Imprime cancelamento de Pedido",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "IDIMPCANITEM",
                "TABLE"  => "PRODLOJA",
                "PARENT" => "1.2"
            ),
            (object) array(
                "ID"     => "1.3",
                "NAME"   => "Impressoras por Loja",
                "PATH"   => "Cadastro de Loja->Impressoras por Loja",
                "PARENT" => "1"
            ),
            (object) array(
                "ID"     => "1.3.1",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "NMIMPRESSORA",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "1.3"
            ),
            (object) array(
                "ID"     => "1.3.2",
                "NAME"   => "Nome Impressora",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "NMIMPRLOJA",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.3"
            ),
            (object) array(
                "ID"     => "1.3.3",
                "NAME"   => "Porta de Impressão",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.3"
            ),
            (object) array(
                "ID"     => "1.3.4",
                "NAME"   => "Endereço de IP da Impressora",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "DSIPIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.3"
            ),
            (object) array(
                "ID"     => "1.3.5",
                "NAME"   => "Endereço do servidor de periféricos",
                "PATH"   => "Cadastro de Loja->Produtos por Loja",
                "COLLUMN"=> "DSIPPONTE",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.3"
            ),
            (object) array(
                "ID"     => "1.4",
                "NAME"   => "Mapeamento de Portas",
                "PATH"   => "Cadastro de Loja->Mapeamento de Portas",
                "PARENT" => "1"
            ),
            (object) array(
                "ID"     => "1.4.1",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Loja->Mapeamento de Portas",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "1.4"
            ),
            (object) array(
                "ID"     => "1.4.2",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Loja->Mapeamento de Portas",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "1.4"
            ),
            (object) array(
                "ID"     => "2",
                "NAME"   => "Cadastro de Caixa",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "2.1",
                "NAME"   => "Parâmetros",
                "PATH"   => "Cadastro de Caixa->Parâmetros",
                "PARENT" => "2"
            ),
            (object) array(
                "ID"     => "2.1.1",
                "NAME"   => "TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->TEF",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.1.1",
                "NAME"   => "Utilização TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "IDUTILTEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.2",
                "NAME"   => "Solicita Consulta Eletrônica de Cheque no Recebimento da Venda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "IDUTILCHEQ",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.3",
                "NAME"   => "Bloqueia Digitação do Número do Cartão",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "IDBLOQIDCART",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.4",
                "NAME"   => "Solicita Parcelamento do cartão de crédito(Cappta)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "IDPARCREDCAP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.5",
                "NAME"   => "Tipo do TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "IDTPTEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.6",
                "NAME"   => "Porta de Comunicação do TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "CDPORTATEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.7",
                "NAME"   => "Estabelecimento do TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "CDESTTEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.8",
                "NAME"   => "Código da Loja TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "CDLOJATEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.9",
                "NAME"   => "Código do Terminal TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "CDTERTEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.1.10",
                "NAME"   => "Endereço IP do TEF",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Parametrização TEF",
                "COLLUMN"=> "DSENDIPSITEF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.1"
            ),
            (object) array(
                "ID"     => "2.1.2",
                "NAME"   => "Frente de Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1",
                "NAME"   => "Frente de Caixa(1)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa",
                "PARENT" => "2.1.2"
            ),
            (object) array(
                "ID"     => "2.1.2.1.1",
                "NAME"   => "Solicita confirmação para impressão do comprovante não fiscal",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Vendas Débito Consumidor",
                "COLLUMN"=> "IDSOLCONICNFIS",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.2",
                "NAME"   => "Imprime comprovante da venda débito consumidor após emissão de cupom fiscal",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Vendas Débito Consumidor",
                "COLLUMN"=> "IDIMPVENDCON",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.3",
                "NAME"   => "Solicita digitação de observação a ser impressa no rodapé do comprovante da venda débito consumidor",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Vendas Débito Consumidor",
                "COLLUMN"=> "IDSOLDIGOBSDC",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.4",
                "NAME"   => "Imprime comprovante da venda crédito pessoal após emissão de cupom fiscal",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Vendas Crédito Pessoal",
                "COLLUMN"=> "IDIMPCOMPVCP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.5",
                "NAME"   => "Solicita vendedor em venda do tipo balcão",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Venda Balcão",
                "COLLUMN"=> "IDINFVENBAL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.6",
                "NAME"   => "Solicita CPF ou CNPJ na venda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Informa CPF/CNPJ",
                "COLLUMN"=> "IDSOLICITACPF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.7",
                "NAME"   => "Mensagem a ser exibida no rodapé do cupom no caso da informação do CPF/CNPJ",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Informa CPF/CNPJ",
                "COLLUMN"=> "DSMENSCPFCUP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.8",
                "NAME"   => "Imprime Código de Barras com o Número do Cupom",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Impressão de Código de Barras após emissão do Cupom",
                "COLLUMN"=> "IDIMPBARRCUP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.9",
                "NAME"   => "Padrão",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Impressão de Código de Barras após emissão do Cupom",
                "COLLUMN"=> "NMPADBARRCUP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.10",
                "NAME"   => "Permite Complemento nas Vendas do Tipo (Crédito Pessoal / Débito Consumidor)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Permite Complemento de Venda",
                "COLLUMN"=> "IDPERCOMVENCPDC",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.1.11",
                "NAME"   => "Tipo da Tela de Venda de Produtos",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(1)->Tipo da Tela de Venda de Produtos",
                "COLLUMN"=> "IDTPTELAVE",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.1"
            ),
            (object) array(
                "ID"     => "2.1.2.2",
                "NAME"   => "Frente de Caixa(2)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa",
                "PARENT" => "2.1.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.1",
                "NAME"   => "Controla repique",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Controle de Repique",
                "COLLUMN"=> "IDTPCONTRREPIQ",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.2",
                "NAME"   => "Percentual máximo de repique sobre a venda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Controle de Repique",
                "COLLUMN"=> "VRPEMAXREPIQVND",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.3",
                "NAME"   => "Texto para ser impresso no rodapé do cupom fiscal",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Texto para ser impresso no rodapé do cupom fiscal",
                "COLLUMN"=> "DSOBSCUPFIS",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.4",
                "NAME"   => "Permite abertura de comanda caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Abertura de Comanda",
                "COLLUMN"=> "IDPERABERCOMCXA",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.5",
                "NAME"   => "Gera LOG de Processos no frente de caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Gera LOG de Processos",
                "COLLUMN"=> "IDGERALOGFOS",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.6",
                "NAME"   => "Frequência Limpeza vendas",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Limpeza das Vendas no MSDE",
                "COLLUMN"=> "IDFREQLIMPVENDA",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.7",
                "NAME"   => "Manter as vendas por x dias MSDE",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Limpeza das Vendas no MSDE",
                "COLLUMN"=> "NRDIASVENDAMSDE",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.8",
                "NAME"   => "Gera backup MSDE",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Limpeza das Vendas no MSDE",
                "COLLUMN"=> "IDGERBKPMSDE",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.9",
                "NAME"   => "Baixar as vendas dos ultimos dias",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Recuperação das Vendas (Banco de Dados Principal -> MSDE)",
                "COLLUMN"=> "NRDIASBXVNDMSDE",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.10",
                "NAME"   => "Solicita tipo de sangria no momento da sangria de caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Sangria de Caixa",
                "COLLUMN"=> "IDSOLTPSANGRIACX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.11",
                "NAME"   => "Solicita nome do consumidor na venda balcão para emissão de etiqueta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Solicita Nome do Consumidor",
                "COLLUMN"=> "IDSOLDIGCONS",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.12",
                "NAME"   => "Imprime Pedido no setor de Produção",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Imprime Pedido na Produção",
                "COLLUMN"=> "IDIMPPEDPROD",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.2.13",
                "NAME"   => "Utiliza bina em vendas delivery",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(2)->Bina->Utiliza bina em vendas delivery",
                "COLLUMN"=> "IDUTILBINADEL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.2"
            ),
            (object) array(
                "ID"     => "2.1.2.3",
                "NAME"   => "Frente de Caixa(3)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa",
                "PARENT" => "2.1.2"
            ),
            (object) array(
                "ID"     => "2.1.2.3.1",
                "NAME"   => "Senha Cupom Fiscal/Pedido",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Senha Cupom Fiscal/Pedido",
                "COLLUMN"=> "IDSENHACUP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.2",
                "NAME"   => "Obriga fechamento do caixa às 00hrs",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Obriga Fechamento do Dia",
                "COLLUMN"=> "IDOBRIGFECHCAIX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.3",
                "NAME"   => "Número de Série NFCe a ser utilizado pelo Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Número Série NFCe",
                "COLLUMN"=> "CDSERIECX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.4",
                "NAME"   => "Utiliza SAT compartilhado",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Utiliza SAT Compartilhado",
                "COLLUMN"=> "IDUTILSATCOMP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.5",
                "NAME"   => "Endereço (Servidor SAT)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Utiliza SAT Compartilhado",
                "COLLUMN"=> "CDURLWSSAT",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.6",
                "NAME"   => "Permite agrupar/desagrupar comandas no Auto Pagamento Comanda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Agrupamento de Comanda no Auto Pagamento Comanda",
                "COLLUMN"=> "IDAGRUPACMDAPC",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.7",
                "NAME"   => "Realiza sincronização com Delivery Centralizado",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Sincronização com Delivery",
                "COLLUMN"=> "IDSINCCAIXADLV",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.8",
                "NAME"   => "Imprime automaticamente Controle de Entrega",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Sincronização com Delivery",
                "COLLUMN"=> "IDIMPAUTENTREG",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.9",
                "NAME"   => "Imprimir Cupom Fiscal automaticamente ao realizar expedição do pedido no KDS",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Impressão Cupom Fiscal na expedição do pedido no KDS",
                "COLLUMN"=> "IDIMPAUTCUPEXP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.10",
                "NAME"   => "Realizar impressão cupom fiscal via Leitura QR-Code",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Impressão Cupom Fiscal via leitura QR-Code",
                "COLLUMN"=> "IDLEITURAQRCODE",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.11",
                "NAME"   => "Imprime nota fiscal após finalizar a venda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Imprime nota fiscal após finalizar a venda",
                "COLLUMN"=> "IDIMPRIMENOTA",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.12",
                "NAME"   => "Solicita email para envio da nota fiscal após finalizar a venda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Solicita email para envio da nota fiscal após finalizar a venda",
                "COLLUMN"=> "IDENVIAEMAIL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.13",
                "NAME"   => "Visualiza tela de Pedido (2º Monitor)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Visualiza Tela de Pedido",
                "COLLUMN"=> "IDVISTELPED",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.14",
                "NAME"   => "Finaliza pedido automático após expedição vendas Delivery",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Finaliza Pedido Automático Delivery",
                "COLLUMN"=> "IDFINPEDAUTDLV",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.15",
                "NAME"   => "Utiliza caixa integrado com catraca na venda comanda",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Catraca OnLine->Utiliza caixa integrado com catraca na venda comanda",
                "COLLUMN"=> "IDUTILFOSCAT",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.16",
                "NAME"   => "Definição Local Impressão do Controle de Entrega",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Definição Local Impressão do Controle de Entrega",
                "COLLUMN"=> "IDLOCIMPENT",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.17",
                "NAME"   => "Endereço dos Periféricos para SAT",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Configurações para ultilização do SAT",
                "COLLUMN"=> "DSSATHOST",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.2.3.18",
                "NAME"   => "Código de ativação do SAT",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Frente de Caixa->Frente de Caixa(3)->Configurações para ultilização do SAT",
                "COLLUMN"=> "CDCODATIVASAT",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.2.3"
            ),
            (object) array(
                "ID"     => "2.1.3",
                "NAME"   => "Abertura do Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.3.1",
                "NAME"   => "Verifica/solicita a cotação da moeda estrangeira na abertura do caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Abertura de Caixa",
                "COLLUMN"=> "IDVERIFCOTA",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.3.2",
                "NAME"   => "Atualiza os arquivos dos periféricos do ForSale na abertura do caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Abertura de Caixa",
                "COLLUMN"=> "IDBAIXAPERIF",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.3.3",
                "NAME"   => "Obriga a digitação das reduções Z não gravadas no sistema na abertura do caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Abertura de Caixa",
                "COLLUMN"=> "IDINFREDZNCAD",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.3.4",
                "NAME"   => "Permite alteração do fundo de troco na abertura do caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Abertura de Caixa",
                "COLLUMN"=> "IDPALFUTRABRCXA",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.3.5",
                "NAME"   => "Valor Padrão para Fundo de Troco",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Abertura de Caixa",
                "COLLUMN"=> "VRABERCAIX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.3.6",
                "NAME"   => "Tipo de Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Tipo de Caixa",
                "COLLUMN"=> "IDCOLETOR",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.3.7",
                "NAME"   => "Atualização dos dados das tabelas no cache local na inicialização do sistema",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Abertura do Caixa->Atualização dos dados das tabelas no cache local na inicialização do sistema",
                "COLLUMN"=> "IDAUTOIMPTAB",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.3"
            ),
            (object) array(
                "ID"     => "2.1.4",
                "NAME"   => "Fechamento do Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.4.1",
                "NAME"   => "Exibe mensagem de confirmação da emissão de Relatório de Produtos",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Relatório de Produto",
                "COLLUMN"=> "IDEMIRELPROD",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.2",
                "NAME"   => "Exibe Tributação no Relatório de Produtos",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Relatório de Produto",
                "COLLUMN"=> "IDTRIBRELPRO",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.3",
                "NAME"   => "Imprime Redução Z no Fechamento do Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Emissão da Redução Z no Fechamento do Caixa",
                "COLLUMN"=> "IDIMPREDZ",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.4",
                "NAME"   => "Gera memória fita detalhe da impressora fiscal (Impressora Fiscal Sweda Térmica)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Gera memória fita detalhe da impressora fiscal em arquivo (CAT-52)",
                "COLLUMN"=> "IDGRAVAMFD",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.5",
                "NAME"   => "Imprime Leitura X no Fechamento do Caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Emissão da Leitura X no Fechamento do Caixa",
                "COLLUMN"=> "IDIMPLEITURAX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.6",
                "NAME"   => "Solicita número de depósito no fechamento do caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Informa o número de depósito no Fechamento do Caixa",
                "COLLUMN"=> "IDSOLNUMDEPFC",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.7",
                "NAME"   => "Gera Arquivo de vendas diarimente na emissão na emissão da redução",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Gera Arquivo de Vendas Ato Cotepe 17/04 - Rio de Janeiro",
                "COLLUMN"=> "IDGERAARQVNDRIO",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.8",
                "NAME"   => "Realiza fechamento cego do caixa",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Fechamento cego do Caixa",
                "COLLUMN"=> "IDUTILFECHCEGO",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.4.9",
                "NAME"   => "Exibe mensagem de confirmação da emissão do Recibo de Sangria",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Fechamento do Caixa->Impressão do Recibo de Sangria no Fechamento de Caixa",
                "COLLUMN"=> "IDEMIRECSANG",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.4"
            ),
            (object) array(
                "ID"     => "2.1.5",
                "NAME"   => "Caixas Associados",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Caixas Associados",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.5.1",
                "NAME"   => "Exportação de Vendas",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Caixas Associados",
                "PARENT" => "2.1.5"
            ),
            (object) array(
                "ID"     => "2.1.5.2",
                "NAME"   => "Importação de Tabelas",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Caixas Associados",
                "PARENT" => "2.1.5"
            ),
            (object) array(
                "ID"     => "2.1.6",
                "NAME"   => "Periféricos",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1",
                "NAME"   => "Periféricos(1)",
                "PATH"   => "Cadastro de Caixa->Parâmetros",
                "PARENT" => "2.1.6"
            ),
            (object) array(
                "ID"     => "2.1.6.1.1",
                "NAME"   => "Gerar Arquivo de Debug (arquivo com informações das vendas realizadas na impressora fiscal)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Arquivo de Debug",
                "COLLUMN"=> "IDGERADEBUG",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.2",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Acompanhamento do Pedido)",
                "COLLUMN"=> "NRSEQIMPRLOJA1",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.3",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Acompanhamento do Pedido)",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.4",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Acompanhamento do Pedido)",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.5",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Acompanhamento do Pedido)",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.6",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Impressora do Puxa)",
                "COLLUMN"=> "NRSEQIMPRLOJA2",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.7",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Impressora do Puxa)",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.8",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Impressora do Puxa)",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.9",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Impressora do Puxa)",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.10",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (NFCe/SAT)",
                "COLLUMN"=> "NRSEQIMPRLOJA3",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.11",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (NFCe/SAT)",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.12",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (NFCe/SAT)",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.13",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (NFCe/SAT)",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.14",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Senha do Pedido)",
                "COLLUMN"=> "NRSEQIMPRLOJA4",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.15",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Senha do Pedido)",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.16",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Senha do Pedido)",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.17",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Senha do Pedido)",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.18",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Controle de Entrega)",
                "COLLUMN"=> "NRSEQIMPRLOJA5",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.19",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Controle de Entrega)",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.20",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Controle de Entrega)",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.21",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Impressora Não Fiscal (Controle de Entrega)",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.22",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Acompanhamento de pedido (2)",
                "COLLUMN"=> "NRSEQIMPRLOJA6",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.23",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Acompanhamento de pedido (2)",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.24",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Acompanhamento de pedido (2)",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.25",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Acompanhamento de pedido (2)",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.26",
                "NAME"   => "Impressora",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Pedidos Expedição KDS",
                "COLLUMN"=> "NRSEQIMPRLOJA7",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.27",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Pedidos Expedição KDS",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE"  => "IMPRESSORA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.28",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Pedidos Expedição KDS",
                "COLLUMN"=> "CDPORTAIMPR",
                "TABLE"  => "IMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.1.29",
                "NAME"   => "Endereço de Mapeamento",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(1)->Pedidos Expedição KDS",
                "COLLUMN"=> "DSENDPORTA",
                "TABLE"  => "MAPIMPRLOJA",
                "PARENT" => "2.1.6.1"
            ),
            (object) array(
                "ID"     => "2.1.6.2",
                "NAME"   => "Periféricos(2)",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos",
                "PARENT" => "2.1.6"
            ),
            (object) array(
                "ID"     => "2.1.6.2.1",
                "NAME"   => "Tipo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Balança",
                "COLLUMN"=> "IDTIPOBAL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.2",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Balança",
                "COLLUMN"=> "CDPORTABAL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.3",
                "NAME"   => "Baund Rate",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Balança",
                "COLLUMN"=> "NRVELOCBAL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.4",
                "NAME"   => "Tipo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Display",
                "COLLUMN"=> "IDTIPODISP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.5",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Display",
                "COLLUMN"=> "CDPORTADISP",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.6",
                "NAME"   => "Tipo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Gaveta",
                "COLLUMN"=> "IDTIPOGAVETA",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.7",
                "NAME"   => "Tipo",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Leitor de Proximidade",
                "COLLUMN"=> "IDTIPOPROX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.8",
                "NAME"   => "Porta",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Leitor de Proximidade",
                "COLLUMN"=> "CDPORTAPROX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.9",
                "NAME"   => "Baund Rate",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Leitor de Proximidade",
                "COLLUMN"=> "NRVELOCPROX",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.10",
                "NAME"   => "Leitura do código de barra para etiquetas da balança Toledo Prix IV",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Configurações para a balança Toledo Prix IV",
                "COLLUMN"=> "IDLCDBARBALATOL",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.11",
                "NAME"   => "Código de barras - De - até",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Configurações para a balança Toledo Prix IV",
                "COLLUMN"=> "NRPOSINICODBARR & NRPOSFINCODBARR",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.13",
                "NAME"   => "Quantidade - De - até",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Configurações para a balança Toledo Prix IV",
                "COLLUMN"=> "NRPOSINIQTCDBAR & NRPOSFINQTCDBAR",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.6.2.15",
                "NAME"   => "Valor - De - até",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Periféricos->Periféricos(2)->Configurações para a balança Toledo Prix IV",
                "COLLUMN"=> "NRPOSINIVRCDBAR & NRPOSFINVRCDBAR",
                "TABLE"  => "CAIXA",
                "PARENT" => "2.1.6.2"
            ),
            (object) array(
                "ID"     => "2.1.7",
                "NAME"   => "Vendedores Associados",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Vendedores Associados",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.7.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Vendedores Associados->Código",
                "COLLUMN"=> "CDVENDEDOR",
                "TABLE"  => "VENDEDOR",
                "PARENT" => "2.1.7"
            ),
            (object) array(
                "ID"     => "2.1.7.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Vendedores Associados->Nome",
                "COLLUMN"=> "NMRAZSOCVEN",
                "TABLE"  => "VENDEDOR",
                "PARENT" => "2.1.7"
            ),
            (object) array(
                "ID"     => "2.1.7.3",
                "NAME"   => "Número de Inscrição",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Vendedores Associados->Número de Inscrição",
                "COLLUMN"=> "NRINSJURVEN",
                "TABLE"  => "VENDEDOR",
                "PARENT" => "2.1.7"
            ),
            (object) array(
                "ID"     => "2.1.8",
                "NAME"   => "Dispositivo SSL",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Dispositivo SSL",
                "PARENT" => "2.1"
            ),
            (object) array(
                "ID"     => "2.1.8.1",
                "NAME"   => "Código SSL",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Dispositivo SSL->Código SSL",
                "COLLUMN"=> "IDCODSSL",
                "TABLE"  => "RELACCODSSL",
                "PARENT" => "2.1.8"
            ),
            (object) array(
                "ID"     => "2.1.8.2",
                "NAME"   => "Serial",
                "PATH"   => "Cadastro de Caixa->Parâmetros->Dispositivo SSL->Serial",
                "COLLUMN"=> "IDSERIALDISP",
                "TABLE"  => "RELACCODSSL",
                "PARENT" => "2.1.8"
            ),
            (object) array(
                "ID"     => "3",
                "NAME"   => "Parâmetros Gerais",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "3.1",
                "NAME"   => "Gerais",
                "PATH"   => "Parâmetros Gerais->Gerais",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.1.1",
                "NAME"   => "Geral",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral",
                "PARENT" => "3.1"
            ),
            (object) array(
                "ID"     => "3.1.1.1",
                "NAME"   => "Permite cadastrar produtos de compra na composição dos produtos",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Composição de Produtos",
                "COLLUMN"=> "IDCADPRODCMP",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.2",
                "NAME"   => "Mensagem Enviada ao usuário quando a previsão está fora do limite de Aprovação",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Mensagem enviada ao Usuário",
                "COLLUMN"=> "DSPREVCONSPDV",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.3",
                "NAME"   => "Diretório (Já existente no servidor de aplicação)",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Diretório Destino dos arquivos da CAT-52 no servidor",
                "COLLUMN"=> "DSDIRSALVCAT",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.4",
                "NAME"   => "Diretório (Já existente no servidor de aplicação)",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Diretório Destino dos arquivos TC no servidor( Geração em arquivos - Fechamento do dia )",
                "COLLUMN"=> "DSDIRDESTARQTC",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.5",
                "NAME"   => "Utiliza tabela de preço de cliente somente para vendas do tipo crédito consumidor",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Tabela de Preço utilizada pelo Cliente",
                "COLLUMN"=> "IDUTTABPRECLVDC",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.6",
                "NAME"   => "Bloqueia venda de produtos sem incidência de imposto",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Impostos do produto",
                "COLLUMN"=> "IDBLOQSEMIMP",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.7",
                "NAME"   => "Diretório (Já existente no servidor de aplicação)",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Diretório destino dos arquivos NFC-e no servidor",
                "COLLUMN"=> "DSDIRARQXMLNFCE",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.8",
                "NAME"   => "Atualiza somente produtos ativos para a unidade",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Atualização de produtos na base local",
                "COLLUMN"=> "IDATUPRODATIVFI",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.9",
                "NAME"   => "Utiliza controle de produtos produzidos no cancelamento de produto",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Cancelamento de Produto",
                "COLLUMN"=> "IDINFPRODPRODUZ",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.10",
                "NAME"   => "Mostrar somente consumidores ativos na pesquisa de consumidor no frente de caixa",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Pesquisa de Consumidor",
                "COLLUMN"=> "IDEXCONSATGER",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.11",
                "NAME"   => "Token AudTax",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->AudTax",
                "COLLUMN"=> "CDTOKENAUDTAX",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.12",
                "NAME"   => "Key AudTax",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->AudTax",
                "COLLUMN"=> "CDKEYAUDTAX",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.13",
                "NAME"   => "Proxy AudTax",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->AudTax",
                "COLLUMN"=> "PROXYAUDTAX",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.14",
                "NAME"   => "Porta AudTax",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->AudTax",
                "COLLUMN"=> "PORTAUDTAX",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.15",
                "NAME"   => "Mensagem exibida no rodapé inicial (Auto Atendimento)",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Mensagem exibida no rodapé inicial (Auto Atendimento)",
                "COLLUMN"=> "DSMENSRODAPETAA",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.16",
                "NAME"   => "Texto exibido na ajuda do campo “Nota fiscal Paulista” do SnackTeck",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Texto exibido na ajuda do campo “Nota fiscal Paulista” do SnackTeck",
                "COLLUMN"=> "TXHELPNFPSITE",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.17",
                "NAME"   => "Texto exibido na ajuda do campo “Refeição Extra” do SnackTech",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Texto exibido na ajuda do campo “Refeição Extra” do SnackTech",
                "COLLUMN"=> "TXHELPREFEXSITE",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.18",
                "NAME"   => "Tipo de recebimento para QrCode",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Tipo de recebimento QrCode",
                "COLLUMN"=> "CDTIPORECEQRCODE",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.19",
                "NAME"   => "Link do servidor de imagens",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Link do servidor de imagens",
                "COLLUMN"=> "FILESERVERURL",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.20",
                "NAME"   => "Gerar Código Operador",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Gerar Código Operador",
                "COLLUMN"=> "IDGERACDOPERADOR",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.21",
                "NAME"   => "Habilita Utilização De Cupom de Desconto ?",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Habilita Utilização De Cupom de Desconto ?",
                "COLLUMN"=> "IDUTCUPOMDESC",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.22",
                "NAME"   => "Obrigatoriedade CPF Cadastro Operador",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Obrigatoriedade CPF Cadastro Operador",
                "COLLUMN"=> "IDCPFREQUIRED",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.23",
                "NAME"   => "Link da API de criação dos Jobs das Integrações",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->API de Integração com a Jenkins Interface",
                "COLLUMN"=> "JENKINSINTERFACEURL",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.24",
                "NAME"   => "Token da API de criação dos Jobs das Integrações",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->API de Integração com a Jenkins Interface",
                "COLLUMN"=> "JENKINSINTERFACETOKEN",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.25",
                "NAME"   => "Atualiza os itens adicionais de modalidade To Go na base local",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Atualiza os itens adicionais de modalidade To Go na base local",
                "COLLUMN"=> "IDATUPRODADIC",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.26",
                "NAME"   => "O FosExt deverá ser executado a cada (minutos)",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Tempo de execução FosExt",
                "COLLUMN"=> "NRMINFOSEXT",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.27",
                "NAME"   => "Tipo de exibição do Painel de controle (Dashboard)",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Painel de controle (Dashboard)",
                "COLLUMN"=> "IDDASHBOARD",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.28",
                "NAME"   => "Quantidade de dias por padrão.",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Habilita valor default para sincronização do caixa com banco de dados para novas filiais",
                "COLLUMN"=> "NRDIASDEFSINBC",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.1.29",
                "NAME"   => "Disponibiliza custo sem existência de Cardápio Planejado",
                "PATH"   => "Parâmetros Gerais->Gerais->Geral->Custo de lista de Preços – Suprimentos",
                "COLLUMN"=> "IDCUSSUPFILIVEN",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.1"
            ),
            (object) array(
                "ID"     => "3.1.2",
                "NAME"   => "Fiscal",
                "PATH"   => "Parâmetros Gerais->Gerais->Fiscal",
                "PARENT" => "3.1"
            ),
            (object) array(
                "ID"     => "3.1.2.1",
                "NAME"   => "Diretório para geração",
                "PATH"   => "Parâmetros Gerais->Gerais->Fiscal->Parâmetro para Geração do Arquivo Magnético(SINTEGRA)",
                "COLLUMN"=> "DSDIRARQMAG",
                "TABLE"  => "PARAMFISCAL",
                "PARENT" => "3.1.2"
            ),
            (object) array(
                "ID"     => "3.1.4",
                "NAME"   => "Configurações de Email",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email",
                "PARENT" => "3.1"
            ),
            (object) array(
                "ID"     => "3.1.4.1",
                "NAME"   => "Endereço do servidor SMTP",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "COLLUMN"=> "DSSMTPAUTVND",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.2",
                "NAME"   => "Porta do servidor SMTP",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "COLLUMN"=> "NRPORTAAUTVND",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.3",
                "NAME"   => "Email para envio de mensagens",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "COLLUMN"=> "DSEMAILAUVND",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.4",
                "NAME"   => "Forma de Autenticação",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "COLLUMN"=> "IDTPAUTHSMTP",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.5",
                "NAME"   => "Senha do email para envio de mensagens",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "COLLUMN"=> "CDSENHAAUTVNDWEB",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.6",
                "NAME"   => "Tipo de Criptografia",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "COLLUMN"=> "DSSMTPCRIPT",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.7",
                "NAME"   => "Testar conexão SMTP",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do SMTP",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.8",
                "NAME"   => "Endereço de email do \"fale conosco\"",
                "PATH"   => "Parâmetros Gerais->Gerais->Configurações de Email->Dados do \"fale conosco\"",
                "COLLUMN"=> "DSEMAILCLUSO",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.9",
                "NAME"   => "Habilita Utilização de Cupom de Desconto",
                "PATH"   => "Parâmetros Gerais->Gerais->Parâmetros Gerais Produto->Habilita Utilização de Cupom de Desconto",
                "COLLUMN"=> "IDUTCUPOMDESC",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.10",
                "NAME"   => "Obrigatoriedade CPF Cadastro Operador",
                "PATH"   => "Parâmetros Gerais->Gerais->Parâmetros Gerais Produto->Obrigatoriedade CPF Cadastro Operador",
                "COLLUMN"=> "IDCPFREQUIRED",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.11",
                "NAME"   => "Link da API de criação dos Jobs das Integrações",
                "PATH"   => "Parâmetros Gerais->Gerais->Parâmetros Gerais Produto->Link da API de criação dos Jobs das Integrações",
                "COLLUMN"=> "JENKINSINTERFACEURL",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.4.12",
                "NAME"   => "Token da API de criação dos Jobs das Integrações",
                "PATH"   => "Parâmetros Gerais->Gerais->Parâmetros Gerais Produto->Token da API de criação dos Jobs das Integrações",
                "COLLUMN"=> "JENKINSINTERFACETOKEN",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.1.4"
            ),
            (object) array(
                "ID"     => "3.1.5",
                "NAME"   => "Contrato/Termo Adesão",
                "PATH"   => "Parâmetros Gerais->Gerais",
                "PARENT" => "3.1"
            ),
            (object) array(
                "ID"     => "3.2",
                "NAME"   => "Produto",
                "PATH"   => "Parâmetros Gerais->Produto",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.2.1",
                "NAME"   => "Parâmetros Gerais Produto",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto",
                "PARENT" => "3.2"
            ),
            (object) array(
                "ID"     => "3.2.1.23",
                "NAME"   => "Ativo",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Ativo",
                "COLLUMN"=> "IDPRODATIVPR",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.24",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Código",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.24",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Nome",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.25",
                "NAME"   => "UN",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->UN",
                "COLLUMN"=> "SGUNIDADE",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.1",
                "NAME"   => "Pesa Produto",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Pesa Produto",
                "COLLUMN"=> "IDPESAPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.26",
                "NAME"   => "Tara do Produto",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Tara do Produto",
                "COLLUMN"=> "QTTARAPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.2",
                "NAME"   => "Código de Barras",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Código de Barras",
                "COLLUMN"=> "CDBARPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.3",
                "NAME"   => "Nome Abreviado",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Nome Abreviado",
                "COLLUMN"=> "NMPRODIMPFIS",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.4",
                "NAME"   => "Cobra TxServiço",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Cobra TxServiço",
                "COLLUMN"=> "IDCOBTXSERV",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.5",
                "NAME"   => "Controla Refil",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Controla Refil",
                "COLLUMN"=> "IDCONTROLAREFIL",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.6",
                "NAME"   => "Tipo prod. deb. Consumidor",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Tipo prod. deb. Consumidor",
                "COLLUMN"=> "IDTPPRODDEBCONS",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.7",
                "NAME"   => "Grupo Prod.Combinado",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Grupo Prod.Combinado",
                "COLLUMN"=> "IDTIPOPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.8",
                "NAME"   => "Código (Teclado)",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Código (Teclado)",
                "COLLUMN"=> "CDPROTECLADO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.9",
                "NAME"   => "Imprime Produto",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Imprime Produto",
                "COLLUMN"=> "IDIMPPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.10",
                "NAME"   => "Imprime Produção",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Imprime Produção",
                "COLLUMN"=> "IDIMPRODUVEZ",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.11",
                "NAME"   => "Solicita Local de Impressão",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Solicita Local de Impressão",
                "COLLUMN"=> "IDSOLLOCIMP",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.12",
                "NAME"   => "Dados do Fornecedor",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Dados do Fornecedor",
                "COLLUMN"=> "DSDADOSFORNVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.13",
                "NAME"   => "Dias Validade",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Dias Validade",
                "COLLUMN"=> "QTDIAVALPRODVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.14",
                "NAME"   => "Informações Adicionais",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Informações Adicionais",
                "COLLUMN"=> "DSINFADIPRODVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.15",
                "NAME"   => "Qtde. Porção",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Qtde. Porção",
                "COLLUMN"=> "QTPORCAOVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.16",
                "NAME"   => "Valor min. cons. deb. consumidor",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Valor min. cons. deb. consumidor",
                "COLLUMN"=> "VRMINCONSUMODEB",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.17",
                "NAME"   => "Unidade de Porção",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Unidade de Porção",
                "COLLUMN"=> "IDUNPORCAOVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.18",
                "NAME"   => "Parte Inteira da Medida",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Parte Inteira da Medida",
                "COLLUMN"=> "QTMEDCASVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.19",
                "NAME"   => "Parte Decimal da Medida",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Parte Decimal da Medida",
                "COLLUMN"=> "IDPADEMEDCASVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.20",
                "NAME"   => "Medida Caseira",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Medida Caseira",
                "COLLUMN"=> "IDTIPOMEDCASVND",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.21",
                "NAME"   => "Tipo Produção",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Tipo Produção",
                "COLLUMN"=> "IDORIGPRODPR",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.1.22",
                "NAME"   => "Descrição do Produto para Venda",
                "PATH"   => "Parâmetros Gerais->Produto->Parâmetros Gerais Produto->Descrição do Produto para Venda",
                "COLLUMN"=> "DSPRODVENDA",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.1"
            ),
            (object) array(
                "ID"     => "3.2.2",
                "NAME"   => "Percentual para Cálculo do Preço do Produto",
                "PATH"   => "Parâmetros Gerais->Produto->Percentual para Cálculo do Preço do Produto",
                "PARENT" => "3.2"
            ),
            (object) array(
                "ID"     => "3.2.2.3",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Produto->Percentual para Cálculo do Preço do Produto->Produto",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.2"
            ),
            (object) array(
                "ID"     => "3.2.2.1",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Produto->Percentual para Cálculo do Preço do Produto->Nome",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "3.2.2"
            ),
            (object) array(
                "ID"     => "3.2.2.2",
                "NAME"   => "Percentual",
                "PATH"   => "Parâmetros Gerais->Produto->Percentual para Cálculo do Preço do Produto->Percentual",
                "COLLUMN"=> "VRPERCPREPRO",
                "TABLE"  => "PERCACRPROD",
                "PARENT" => "3.2.2"
            ),
            (object) array(
                "ID"     => "3.3",
                "NAME"   => "Fidelidade",
                "PATH"   => "Parâmetros Gerais->Fidelidade",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.3.1",
                "NAME"   => "Cliente fidelidade",
                "PATH"   => "Parâmetros Gerais->Fidelidade->Cliente fidelidade",
                "COLLUMN"=> "NMRAZSOCCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.3"
            ),
            (object) array(
                "ID"     => "3.3.2",
                "NAME"   => "Centro de custo fidelidade",
                "PATH"   => "Parâmetros Gerais->Fidelidade->Centro de custo fidelidade",
                "COLLUMN"=> "NMCCUSCLIE",
                "TABLE"  => "CCUSCLIE",
                "PARENT" => "3.3"
            ),
            (object) array(
                "ID"     => "3.3.3",
                "NAME"   => "Tipo de consumidor fidelidade",
                "PATH"   => "Parâmetros Gerais->Fidelidade->Tipo de consumidor fidelidade",
                "COLLUMN"=> "NMTIPOCONS",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.3"
            ),
            (object) array(
                "ID"     => "3.4",
                "NAME"   => "Banco",
                "PATH"   => "Parâmetros Gerais->Banco",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.4.1",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Banco->Código de Inscrição da Empresa no Banco para Crédito das Vendas Realizadas via Site",
                "COLLUMN"=> "DSINSCEMPVND",
                "TABLE"  => "BANCO",
                "PARENT" => "3.4"
            ),
            (object) array(
                "ID"     => "3.4.2",
                "NAME"   => "Chave",
                "PATH"   => "Parâmetros Gerais->Banco->Chave de Criptografia para Transações de Venda via Site",
                "COLLUMN"=> "DSKEYCRIPVND",
                "TABLE"  => "BANCO",
                "PARENT" => "3.4"
            ),
            (object) array(
                "ID"     => "3.4.3",
                "NAME"   => "URL",
                "PATH"   => "Parâmetros Gerais->Banco->URL Acessada pelos Bancos em Resposta nas Transações de Venda via Site",
                "COLLUMN"=> "DSURLRETVND",
                "TABLE"  => "BANCO",
                "PARENT" => "3.4"
            ),
            (object) array(
                "ID"     => "3.5",
                "NAME"   => "Cliente",
                "PATH"   => "Parâmetros Gerais->Cliente",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.5.1",
                "NAME"   => "Cliente",
                "PATH"   => "Parâmetros Gerais->Cliente",
                "PARENT" => "3.5"
            ),
            (object) array(
                "ID"     => "3.5.1.5",
                "NAME"   => "Inscrição Jurídica",
                "PATH"   => "Parâmetros Gerais-> Cliente ->Inscrição Jurídica",
                "COLLUMN"=> "NRINSJURCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.5.1"
            ),
            (object) array(
                "ID"     => "3.5.1.6",
                "NAME"   => "Nome Fantasia",
                "PATH"   => "Parâmetros Gerais->Cliente->Nome Fantasia",
                "COLLUMN"=> "NMFANTCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.5.1"
            ),
            (object) array(
                "ID"     => "3.5.1.7",
                "NAME"   => "Razão Social",
                "PATH"   => "Parâmetros Gerais->Cliente->Razão Social",
                "COLLUMN"=> "NMRAZSOCCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.5.1"
            ),
            (object) array(
                "ID"     => "3.5.1.8",
                "NAME"   => "Utiliza criptografia no crachá",
                "PATH"   => "Parâmetros Gerais->Cliente->Utiliza criptografia no crachá",
                "COLLUMN"=> "IDUTCRIPTCRACHA",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.1.1",
                "NAME"   => "Tabela de Preço",
                "PATH"   => "Parâmetros Gerais->Cliente->Tabela de Preço",
                "COLLUMN"=> "CDTABEPREC & NMTABEPREC",
                "TABLE"  => "CLIENTE & TABEPREC respectivamente",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.1.2",
                "NAME"   => "Unidade da Tabela de Preço",
                "PATH"   => "Parâmetros Gerais->Cliente->Unidade da Tabela de Preço",
                "COLLUMN"=> "CDFILTABPREC & NMFILIAL",
                "TABLE"  => "CLIENTE & FILIAL respectivamente",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.1.3",
                "NAME"   => "Zera Saldo Mensalmente",
                "PATH"   => "Parâmetros Gerais->Cliente->Zera Saldo Mensalmente",
                "COLLUMN"=> "IDZERSALDCON",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.1.4",
                "NAME"   => "Nome da Instituição (Site)",
                "PATH"   => "Parâmetros Gerais->Cliente->Nome da Instituição (Site)",
                "COLLUMN"=> "IDEXBTPNOMECLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.1.5",
                "NAME"   => "Recálculo de Saldo Automático",
                "PATH"   => "Parâmetros Gerais->Cliente->Recálculo de Saldo Automático",
                "COLLUMN"=> "IDULTRECSALDAUT",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.1.6",
                "NAME"   => "Hora Recálculo",
                "PATH"   => "Parâmetros Gerais->Cliente->Hora Recálculo",
                "COLLUMN"=> "HRRECSALDAUT",
                "TABLE"  => "CLIENTE",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.5.2",
                "NAME"   => "Tabelas de Preço",
                "PATH"   => "Parâmetros Gerais->Cliente",
                "PARENT" => "3.6"
            ),
            (object) array(
                "ID"     => "3.5.2.1",
                "NAME"   => "Unidade",
                "PATH"   => "Parâmetros Gerais->Cliente->Tabelas de Preço->Unidade",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "FILIAL",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.5.2.2",
                "NAME"   => "Tabela de Preço",
                "PATH"   => "Parâmetros Gerais->Cliente->Tabelas de Preço->Tabela de Preço",
                "COLLUMN"=> "CDTABEPREC, NMTABEPREC, CDTABEPREC, NMTABEPREC",
                "TABLE"  => "CLIENFILIAL, TABEPREC, CLIENFILIAL e TABEPREC respectivamente",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.5.2.3",
                "NAME"   => "Unidade da Tabela de Preço",
                "PATH"   => "Parâmetros Gerais->Cliente->Tabelas de Preço->Unidade da Tabela de Preço",
                "COLLUMN"=> "CDCFILTABPRE & NMFILIAL",
                "TABLE"  => "CLIENFILIAL & FILIAL respectivamente",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.6",
                "NAME"   => "Pagamento Online",
                "PATH"   => "Parâmetros Gerais->Pagamento Online",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.6.1",
                "NAME"   => "Geral",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral",
                "PARENT" => "3.6"
            ),
            (object) array(
                "ID"     => "3.6.1.1",
                "NAME"   => "Nome da loja e-SiTef",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Integração e-SiTef Software Express",
                "COLLUMN"=> "IDLOJAESITEF",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.6.1.2",
                "NAME"   => "Código da loja e-SiTef",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Integração e-SiTef Software Express",
                "COLLUMN"=> "CDLOJAESITEF",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "3.6.1"
            ),
            (object) array(
                "ID"     => "3.6.2",
                "NAME"   => "Unidade",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Unidade",
                "PARENT" => "3.6"
            ),
            (object) array(
                "ID"     => "3.6.2.3",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Unidade->Código",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.6.2.4",
                "NAME"   => "Unidade",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Unidade->Unidade",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "FILIAL",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.6.2.1",
                "NAME"   => "Nome da loja e-SiTef",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Unidade->Nome da loja e-SiTef",
                "COLLUMN"=> "IDLOJAESITEFFIL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.6.2.2",
                "NAME"   => "Código da loja e-SiTef",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Unidade->Código da loja e-SiTef",
                "COLLUMN"=> "CDLOJAESITEFFIL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "3.6.2"
            ),
            (object) array(
                "ID"     => "3.6.3",
                "NAME"   => "Bandeiras e-SiTef",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Bandeiras e-SiTef",
                "PARENT" => "3.6"
            ),
            (object) array(
                "ID"     => "3.6.3.1",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Bandeiras e-SiTef->Nome",
                "COLLUMN"=> "NMBANDEIRA",
                "TABLE"  => "BANDESITEFFIL",
                "PARENT" => "3.6.3"
            ),
            (object) array(
                "ID"     => "3.6.3.2",
                "NAME"   => "Identificador e-SiTef",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Bandeiras e-SiTef->Identificador e-SiTef",
                "COLLUMN"=> "IDESITEF",
                "TABLE"  => "BANDESITEFFIL",
                "PARENT" => "3.6.3"
            ),
            (object) array(
                "ID"     => "3.6.3.3",
                "NAME"   => "Tipo de recebimento",
                "PATH"   => "Parâmetros Gerais->Pagamento Online->Geral->Bandeiras e-SiTef->Tipo de recebimento",
                "COLLUMN"=> "CDTIPORECE",
                "TABLE"  => "BANDESITEFFIL",
                "PARENT" => "3.6.3"
            ),
            (object) array(
                "ID"     => "3.7",
                "NAME"   => "Tipo de Consumidor",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.7.1",
                "NAME"   => "Tipo de Consumidor",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor",
                "PARENT" => "3.7"
            ),
            (object) array(
                "ID"     => "3.7.1.4",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Código",
                "COLLUMN"=> "CDTIPOCONS",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.5",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Nome",
                "COLLUMN"=> "NMTIPOCONS",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.1",
                "NAME"   => "Permite marcaçao de dados em catraca",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Importação de dados da catraca",
                "COLLUMN"=> "IDREGDUPCATR",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.2",
                "NAME"   => "Emitir Extrato Simplificado (Sem exibir as transferências de crédito/débito)",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Tipo de Extrato - Vendas Crédito Pessoal",
                "COLLUMN"=> "IDEMISEXTRSIMPL",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.3",
                "NAME"   => "Desabilita o teclado para digitação/pesquisa do crachá do consumidor, permitindo apenas a ultilização do código de barras",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Desabilita Teclado",
                "COLLUMN"=> "IDDESABPESQCON",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.4",
                "NAME"   => "Solicitar senha do consumidor",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Senha Consumidor",
                "COLLUMN"=> "IDSOLSENHCONS",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.5",
                "NAME"   => "Permite transferência de saldo de cartão (Crédito Pessoal)",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Transferência de Saldo",
                "COLLUMN"=> "IDPERTRANSALD",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.1.6",
                "NAME"   => "Inativar consumidor na rotina de Importação de Consumidor",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor->Importação de Consumidor",
                "COLLUMN"=> "IDINACONSIMPARQ",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "3.7.1"
            ),
            (object) array(
                "ID"     => "3.7.2",
                "NAME"   => "Tipo de Consumidor por Unidade",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade",
                "PARENT" => "3.7"
            ),
            (object) array(
                "ID"     => "3.7.2.1",
                "NAME"   => "Controle de acesso ao site - Snack Tech",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech",
                "PARENT" => "3.7.2"
            ),
            (object) array(
                "ID"     => "3.7.2.1.1",
                "NAME"   => "Consultar o Saldo",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Consultar Extrato",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.2",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Consultar Extrato",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.3",
                "NAME"   => "Consutar Extrato",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Consutar Extrato",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.4",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Consutar Extrato",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.5",
                "NAME"   => "Carregar Cartão",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Carregar Cartão",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.6",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Carregar Cartão",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.7",
                "NAME"   => "Bloquear Cartão",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Bloquear Cartão",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.8",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Bloquear Cartão",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.9",
                "NAME"   => "Fale Conosco",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Fale Conosco",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.10",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Fale Conosco",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.11",
                "NAME"   => "Restrição Alimentar",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Restrição Alimentar",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.12",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Restrição Alimentar",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.13",
                "NAME"   => "Atualizar Cadastro",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Atualizar Cadastro",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.14",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Atualizar Cadastro",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.15",
                "NAME"   => "Trocar Senha",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Trocar Senha",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.16",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Trocar Senha",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.17",
                "NAME"   => "Tabela de Preço",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Tabela de Preço",
                "COLLUMN"=> "DSACESSOSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.1.18",
                "NAME"   => "Posição",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Controle de acesso ao site - Snack Tech->Tabela de Preço",
                "COLLUMN"=> "DSPOSMNUSITE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.1"
            ),
            (object) array(
                "ID"     => "3.7.2.2",
                "NAME"   => "Bônus Carga de Crédito",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito",
                "PARENT" => "3.7.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.1",
                "NAME"   => "Recebe bônus na realização de carga de crédito",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->Recebe bônus na realização de carga de crédito",
                "COLLUMN"=> "IDRECEBEBONUS",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.2",
                "NAME"   => "A cada (R$)",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->A cada (R$)",
                "COLLUMN"=> "VRCARGACREDITO",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.3",
                "NAME"   => "Recebe bônus (R$)",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->Recebe bônus (R$)",
                "COLLUMN"=> "VRBONUSCREDITO",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.4",
                "NAME"   => "Para recebimento do bônus, o saldo deve ser menor ou igual a",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->Para recebimento do bônus, o saldo deve ser menor ou igual a",
                "COLLUMN"=> "VRSALDCONSBONUS",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.5",
                "NAME"   => "Periodicidade para efetuar carga/receber bônus",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->Periodicidade para efetuar carga/receber bônus",
                "COLLUMN"=> "IDPERIODOBONUS",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.6",
                "NAME"   => "Quantidade de recargas permitidas por mês",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->Quantidade de recargas permitidas por mês",
                "COLLUMN"=> "QTRECARGASMES",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.7.2.2.7",
                "NAME"   => "Tipo Recebimento Bônus",
                "PATH"   => "Parâmetros Gerais->Tipo de Consumidor->Tipo de Consumidor por Unidade->Bônus Carga de Crédito->Tipo Recebimento Bônus",
                "COLLUMN"=> "CDTIPORECE",
                "TABLE"  => "TIPOCONSFILI",
                "PARENT" => "3.7.2.2"
            ),
            (object) array(
                "ID"     => "3.8",
                "NAME"   => "Integrações",
                "PATH"   => "Parâmetros Gerais->Integrações",
                "PARENT" => "3"
            ),
            (object) array(
                "ID"     => "3.8.1",
                "NAME"   => "Operador",
                "PATH"   => "Parâmetros Gerais->Integrações->Operador",
                "PARENT" => "3.8"
            ),
            (object) array(
                "ID"     => "3.8.1.1",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Integrações->Operador",
                "COLLUMN"=> "CDOPERADOR",
                "TABLE"  => "OPERADOR",
                "PARENT" => "3.8.1"
            ),
            (object) array(
                "ID"     => "3.8.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Integrações->Operador",
                "COLLUMN"=> "NMOPERADOR",
                "TABLE"  => "OPERADOR",
                "PARENT" => "3.8.1"
            ),
            (object) array(
                "ID"     => "3.8.1.3",
                "NAME"   => "Código Externo",
                "PATH"   => "Parâmetros Gerais->Integrações->Operador",
                "COLLUMN"=> "CDEXTOPER",
                "TABLE"  => "OPERADOR",
                "PARENT" => "3.8.1"
            ),
            (object) array(
                "ID"     => "3.8.2",
                "NAME"   => "Imposto",
                "PATH"   => "Parâmetros Gerais->Integrações->Imposto",
                "PARENT" => "3.8"
            ),
            (object) array(
                "ID"     => "3.8.2.1",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Integrações->Imposto",
                "COLLUMN"=> "CDIMPOSTO",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "3.8.2"
            ),
            (object) array(
                "ID"     => "3.8.2.2",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Integrações->Imposto",
                "COLLUMN"=> "NMIMPOSTO",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "3.8.2"
            ),
            (object) array(
                "ID"     => "3.8.2.3",
                "NAME"   => "Código Externo",
                "PATH"   => "Parâmetros Gerais->Integrações->Imposto",
                "COLLUMN"=> "CDEXTIMPOS",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "3.8.2"
            ),
            (object) array(
                "ID"     => "3.8.3",
                "NAME"   => "Tipo de Recebimento",
                "PATH"   => "Parâmetros Gerais->Integrações->",
                "PARENT" => "3.8"
            ),
            (object) array(
                "ID"     => "3.8.3.1",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Integrações->Tipo de Recebimento",
                "COLLUMN"=> "CDTIPORECE",
                "TABLE"  => "TIPORECE",
                "PARENT" => "3.8.3"
            ),
            (object) array(
                "ID"     => "3.8.3.2",
                "NAME"   => "Nome",
                "PATH"   => "Parâmetros Gerais->Integrações->Tipo de Recebimento",
                "COLLUMN"=> "NMTIPORECE",
                "TABLE"  => "TIPORECE",
                "PARENT" => "3.8.3"
            ),
            (object) array(
                "ID"     => "3.8.3.3",
                "NAME"   => "Código Externo",
                "PATH"   => "Parâmetros Gerais->Integrações->Tipo de Recebimento",
                "COLLUMN"=> "CDEXTTIPORECE",
                "TABLE"  => "TIPORECE",
                "PARENT" => "3.8.3"
            ),
            (object) array(
                "ID"     => "3.8.4",
                "NAME"   => "Alíquotas",
                "PATH"   => "Parâmetros Gerais->Integrações->",
                "PARENT" => "3.8"
            ),
            (object) array(
                "ID"     => "3.8.4.1",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Gerais->Integrações->Alíquotas",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "PRODFILI",
                "PARENT" => "3.8.4"
            ),
            (object) array(
                "ID"     => "3.8.4.2",
                "NAME"   => "Unidade",
                "PATH"   => "Parâmetros Gerais->Integrações->Alíquotas",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "PRODFILI",
                "PARENT" => "3.8.4"
            ),
            (object) array(
                "ID"     => "3.8.4.3",
                "NAME"   => "Código Imposto",
                "PATH"   => "Parâmetros Gerais->Integrações->Alíquotas",
                "COLLUMN"=> "CDIMPOSTO",
                "TABLE"  => "PRODFILI",
                "PARENT" => "3.8.4"
            ),
            (object) array(
                "ID"     => "3.8.4.4",
                "NAME"   => "Imposto",
                "PATH"   => "Parâmetros Gerais->Integrações->Alíquotas",
                "COLLUMN"=> "NMIMPOSTO",
                "TABLE"  => "PRODFILI",
                "PARENT" => "3.8.4"
            ),
            (object) array(
                "ID"     => "3.8.4.5",
                "NAME"   => "Alíquota",
                "PATH"   => "Parâmetros Gerais->Integrações->Alíquotas",
                "COLLUMN"=> "VRPEALIMPFIS",
                "TABLE"  => "PRODFILI",
                "PARENT" => "3.8.4"
            ),
            (object) array(
                "ID"     => "3.8.4.6",
                "NAME"   => "Código externo por alíquota",
                "PATH"   => "Parâmetros Gerais->Integrações->Alíquotas",
                "COLLUMN"=> "CDIMPEXT",
                "TABLE"  => "PRODFILI",
                "PARENT" => "3.8.4"
            ),
            (object) array(
                "ID"     => "4",
                "NAME"   => "Parâmetros da Unidade",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "4.1",
                "NAME"   => "Frente de Caixa",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "4.1.1",
                "NAME"   => "Definições de Padrão",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão",
                "PARENT" => "4.1"
            ),
            (object) array(
                "ID"     => "4.1.1.1",
                "NAME"   => "Operador",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Operador padrão utilizado na abertura do caixa no Auto Atendimento",
                "COLLUMN"=> "NMOPERADOR",
                "TABLE"  => "OPERADOR",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.2",
                "NAME"   => "Cliente",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Cliente padrão utilizado na inclusão das vendas a vista",
                "COLLUMN"=> "NMRAZSOCCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.3",
                "NAME"   => "Centro de Custo",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Parâmetros utilizados na inclusão automática de consumidor",
                "COLLUMN"=> "NMCCUSCLIE",
                "TABLE"  => "CCUSCLIE",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.4",
                "NAME"   => "Tipo Consumidor",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Parâmetros utilizados na inclusão automática de consumidor",
                "COLLUMN"=> "NMTIPOCONS",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.5",
                "NAME"   => "Indica que os dados da venda catraca não serão carregados no MSDE",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Parâmetro utilizado para carregar dados da catraca no MSDE",
                "COLLUMN"=> "IDATUIDVCAT",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.6",
                "NAME"   => "ID - Parceiro",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->DOTZ",
                "COLLUMN"=> "CDINTEGRADOTZ",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.7",
                "NAME"   => "Diretório do arquivo DOTZ",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->DOTZ",
                "COLLUMN"=> "DSDIRARQDOTZ",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.8",
                "NAME"   => "Dia do Fechamento",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Definição do dia de Fechamento da Folha de Pagamento da Filial(utilizado para Venda Débito Consumidor)",
                "COLLUMN"=> "NRDIAFECHAFOLHA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.9",
                "NAME"   => "Número Máximo",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Número máximo de pessoas na mesa",
                "COLLUMN"=> "NRMAXPESMES",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.10",
                "NAME"   => "Utiliza concessão de crédito distrito federal lei nº4.159/08",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Parâmetro utilizado para Concessão de Crédito Distrito Federal",
                "COLLUMN"=> "IDCONCREDDF",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.1.11",
                "NAME"   => "Utiliza Integração com Hotel",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Parâmetro utilizado para identificar integração com Hotel",
                "COLLUMN"=> "IDINTHOTEL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"=>"4.1.1.12",
                "NAME"   => "Porcentagem usada no relatório de Custo da Composição do Produto",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Frete e Logística",
                "COLLUMN"=> "VRPERCCUSTPROD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"=>"4.1.1.13",
                "NAME"   => "Tipo SSL",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Parâmetro para conexões TEF",
                "COLLUMN"=> "IDUTLSSL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"=>"4.1.1.14",
                "NAME"   => "Utiliza Integração Fidelidade UDS",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Padrão->Integração Fidelidade UDS",
                "COLLUMN"=> "IDUTILFIDUDS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.1"
            ),
            (object) array(
                "ID"     => "4.1.2",
                "NAME"   => "Definições NFC-e/SAT",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT",
                "PARENT" => "4.1"
            ),
            (object) array(
                "ID"     => "4.1.2.1",
                "NAME"   => "Imprime logotipo salvo na memória NV da Impressora Não Fiscal",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Imprime Logotipo nas vendas NFCe/SAT",
                "COLLUMN"=> "IDIMPLOGONF",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.2",
                "NAME"   => "Posição na memória NV - Bematech",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Imprime Logotipo nas vendas NFCe/SAT",
                "COLLUMN"=> "NRPOSNVBEMA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.3",
                "NAME"   => "Posição na memória NV - Epson 1",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Imprime Logotipo nas vendas NFCe/SAT",
                "COLLUMN"=> "NRPOSNV1EPSON",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.4",
                "NAME"   => "Posição na memória NV - Epson 2",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Imprime Logotipo nas vendas NFCe/SAT",
                "COLLUMN"=> "NRPOSNV2EPSON",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.5",
                "NAME"   => "Envia código de barras para XML(SAT/NFC-e)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Geração XML (SAT/NFC-e)",
                "COLLUMN"=> "IDENVIACDBARXML",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.6",
                "NAME"   => "Código de vinculação (Disponível na página Teknisa)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Código de vinculação do SAT",
                "COLLUMN"=> "CDVINCSAT",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.7",
                "NAME"   => "Chave de acesso",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização TEF/POS MFe",
                "COLLUMN"=> "CDCHAVACESVALI",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.8",
                "NAME"   => "Chave de requisição",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização TEF/POS MFe",
                "COLLUMN"=> "CDCHAVEREQUI",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.9",
                "NAME"   => "Ambiente de Trabalho",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização de Nota Fiscal Eletrônica para Consumidor Final",
                "COLLUMN"=> "IDAMBTRABNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.10",
                "NAME"   => "Nome do arquivo de certificado do NFCE",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização de Nota Fiscal Eletrônica para Consumidor Final",
                "COLLUMN"=> "NMARQCERTNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.11",
                "NAME"   => "Senha do certificado do NFCE",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização de Nota Fiscal Eletrônica para Consumidor Final",
                "COLLUMN"=> "DSSENHACERTNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.12",
                "NAME"   => "Certificado Digital (NFC-e)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização de Nota Fiscal Eletrônica para Consumidor Final",
                "COLLUMN"=> "NRCERTDIGNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.13",
                "NAME"   => "Permite cancelamento extemporâneo NFC-e",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização de Nota Fiscal Eletrônica para Consumidor Final",
                "COLLUMN"=> "IDCANCEXTNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.14",
                "NAME"   => "Gera log dos processos de transmissão, atualização e cancelamento de NFC-e",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Parametrização de Nota Fiscal Eletrônica para Consumidor Final",
                "COLLUMN"=> "IDGERALOGNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
             (object) array(
                "ID"     => "4.1.2.29",
                "NAME"   => "Diretório",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT/Parametrização de Nota Fiscal Eletrônica para Consumidor Final (NFC-e)",
                "COLLUMN"=> "DSDIRARQLOGNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.15",
                "NAME"   => "CSC - Homologação",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Código de Segurança do Contribuinte - CSC (NFC-e)",
                "COLLUMN"=> "CDCODSCONSHOMO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.16",
                "NAME"   => "CSC - Produção",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Código de Segurança do Contribuinte - CSC (NFC-e)",
                "COLLUMN"=> "CDCODSCONSPROD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.17",
                "NAME"   => "Código ID Token Homologação",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Código de Segurança do Contribuinte - CSC (NFC-e)",
                "COLLUMN"=> "CDIDTOKENHOMO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.18",
                "NAME"   => "Código ID Token Produção",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Código de Segurança do Contribuinte - CSC (NFC-e)",
                "COLLUMN"=> "CDIDTOKENPROD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.19",
                "NAME"   => "Versão XML (NFC-e)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Versão XML",
                "COLLUMN"=> "CDVERSAOXMLNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.20",
                "NAME"   => "Versão",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Versão QRCode",
                "COLLUMN"=> "CDVERSAOQRCNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.21",
                "NAME"   => "Tempo (em segundos)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->TimeOut Transmissão NFCe",
                "COLLUMN"=> "NRTIMEOUTNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.22",
                "NAME"   => "Endereço (Servidor de Aplicação)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Endereço do NFC-e Service",
                "COLLUMN"=> "CDURLWSNFC",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.23",
                "NAME"   => "Justificativa do Cancelamento",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Endereço do NFC-e Service",
                "COLLUMN"=> "DSJUSTCANCNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.24",
                "NAME"   => "Utiliza Transmissão Automática",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Transmissão Automática (NFC-e)",
                "COLLUMN"=> "IDTRANSAUTONFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
             (object) array(
                "ID"     => "4.1.2.30",
                "NAME"   => "Horários",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT/Transmissão Automática(NFC-e)",
                "COLLUMN"=> "IDHRTRANSAUTO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.25",
                "NAME"   => "Hora",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Transmissão Automática (NFC-e)",
                "COLLUMN"=> "HRTRANSAUTO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.31",
                "NAME"   => "Instalação do php.exe",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT/Transmissão Automática(NFC-e)",
                "COLLUMN"=> "DSDIRINSTALPHP",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.32",
                "NAME"   => "Arquivos PHP no servidor",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT/Transmissão Automática(NFC-e)",
                "COLLUMN"=> "DSDIRARQPHP",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.26",
                "NAME"   => "Bloquear abertura de caixa sem número de série do caixa",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Bloqueio de Caixa sem Número de Série",
                "COLLUMN"=> "IDBLOQCXSSERIE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.27",
                "NAME"   => "Emite somente 1 via Danfe NFC-e em contigência",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Emissão Danfe Contingência (NFC-e)",
                "COLLUMN"=> "IDUMAVIANFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.28",
                "NAME"   => "Envia responsável técnico no XML (NFCe)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT->Geração XML (SAT/NFC-e)",
                "COLLUMN"=> "IDRESPTECNFCE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.2.33",
                "NAME"   => "Chave de Segurança (SAT)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições NFC-e/SAT/Consulta XML(SAT)",
                "COLLUMN"=> "CDCHAVESEGSAT",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.2"
            ),
            (object) array(
                "ID"     => "4.1.3",
                "NAME"   => "Controle de Caixa",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa",
                "PARENT" => "4.1"
            ),
            (object) array(
                "ID"     => "4.1.3.1",
                "NAME"   => "Valor Percentual (%)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Percentual maximo permitido para troco em Ticket",
                "COLLUMN"=> "VRPEEMITROCO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.2",
                "NAME"   => "Utiliza geração aquivo XML (Integração Comanda)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Gera arquivo XML ( Integração Comanda)",
                "COLLUMN"=> "IDGERAARQXMLINT",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.17",
                "NAME"   => "Diretório para geração do arquivo XML (Integração Comanda)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Gera arquivo XML ( Integração Comanda)",
                "COLLUMN"=> "DSDIRARQXMLINT",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.18",
                "NAME"   => "Quantidade de dígitos da comanda",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Gera arquivo XML ( Integração Comanda)",
                "COLLUMN"=> "NRTAMARQXML",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.3",
                "NAME"   => "Solicita NSU/DOC nas vendas crédito e venda débito",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Solicita NSU/DOC nas vendas crédito e venda débito",
                "COLLUMN"=> "IDSOLICITANSU",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.4",
                "NAME"   => "Qtde. de dígitos máximo do NSU/DOC",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Solicita NSU/DOC nas vendas crédito e venda débito",
                "COLLUMN"=> "QTDMAXDIGNSU",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.5",
                "NAME"   => "Solicita DOTZ na venda ( Integração com TEF dedicado )",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->DOTZ",
                "COLLUMN"=> "IDSOLICITADOTZ",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.20",
                "NAME"   => "Digita CPF no Pin-Pad DOTZ",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->DOTZ",
                "COLLUMN"=> "IDCPFPINPAD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.6",
                "NAME"   => "Valor Minimo",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Controla Valor de sangria",
                "COLLUMN"=> "VRMINSANGRIA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.7",
                "NAME"   => "Valor Máximo",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Controla Valor de sangria",
                "COLLUMN"=> "VRMAXSANGRIA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.8",
                "NAME"   => "Quantidade máxima de dias sem conexão com o banco de dados principal",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Sincronização com Banco de dados",
                "COLLUMN"=> "NRDIAVALTURCAIX",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.9",
                "NAME"   => "Vendas serão exportadas a cada(Minutos)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Sincronização com Banco de dados",
                "COLLUMN"=> "NRMINEXPVENDA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.10",
                "NAME"   => "Timer Limpeza do Auto-Atendimento (Seg)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Limpeza do Auto-Atendimento",
                "COLLUMN"=> "NRSEGLIMPEZATAA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.11",
                "NAME"   => "Adicionar imposto no preço de venda do produto",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Venda de Produtos",
                "COLLUMN"=> "IDACRIMPOSTO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.12",
                "NAME"   => "Imprime o valor da Taxa de Serviço na Parcial da Conta",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Impressão Taxa de Serviço",
                "COLLUMN"=> "IDIMPTXSERV",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.13",
                "NAME"   => "Envia pedido para KDS na venda balcão pelo frente de caixa",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de Caixa->Envia pedido para KDS na venda balcão pelo frente de caixa",
                "COLLUMN"=> "IDENVIAPEDKDS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.14",
                "NAME"   => "Impressora Zebra",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Impressora Zebra",
                "COLLUMN"=> "IDETIQZEBRA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.15",
                "NAME"   => "Informações de cheque no recebimento da venda",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Informações de cheque no recebimento da venda",
                "COLLUMN"=> "IDIMPCUPFIS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.16",
                "NAME"   => "Considera valor de desconto manual no Cálculo do valor da taxa serviço",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Taxa de Serviço",
                "COLLUMN"=> "IDCONDESCTXSERV",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.19",
                "NAME"   => "Utiliza controle de pedidos para viagem nas vendas mesa e balcão",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Controle de Pedidos para Viagem",
                "COLLUMN"=> "IDCTRLPEDVIAGEM",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.20",
                "NAME"   => "Tempo(hrs) definido para participação no rodízio",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Duração do Rodízio",
                "COLLUMN"=> "HRTEMPOROD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.21",
                "NAME"   => "Quantidade máxima de dias para realizar correção cadastro de imposto filial",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Quantidade máxima de dias para realizar correção cadastro de imposto filial",
                "COLLUMN"=> "NRDIAVALIMPPROD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.22",
                "NAME"   => "Utiliza integração com Wibx",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Wibx",
                "COLLUMN"=> "IDUTLWIBX",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.3.23",
                "NAME"   => "Realiza rotina de limpeza mesa POS",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Controle de caixa->Rotina de limpeza mesa POS",
                "COLLUMN"=> "IDLIMPMESAPOS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.3"
            ),
            (object) array(
                "ID"     => "4.1.4",
                "NAME"   => "Definições de Consumidor",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor",
                "PARENT" => "4.1"
            ),
            (object) array(
                "ID"     => "4.1.4.1",
                "NAME"   => "Consumidor padrão utilizado nos sistemas",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Consumidor padrão utilizado nos sistemas",
                "COLLUMN"=> "NMCONSUMIDOR",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.2",
                "NAME"   => "Permite cadastrar consumidor no frente do caixa",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Permite cadastrar consumidor no frente do caixa",
                "COLLUMN"=> "IDPERCADCONSFCXA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.3",
                "NAME"   => "Mostrar somente consumidores ativos na pesquisa de consumidores na frente do caixa",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Mostrar somente consumidores ativos na pesquise de consumidores na frente do caixa",
                "COLLUMN"=> "IDEXCONSATFIL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.4",
                "NAME"   => "Criptografia do Crachá do Consumidor",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Criptografia do Crachá do Consumidor",
                "COLLUMN"=> "IDCRIPTOCONS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.5",
                "NAME"   => "Desabilita teclado para digitação/pesquisa do consumidor, permitindo apenas utilização do leitor de código de barras.",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Parâmetro utilizado nas vendas que solicitam o consumidor",
                "COLLUMN"=> "IDPERDIGCONS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.6",
                "NAME"   => "Qtde. de Dígitos verificadores",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Formatação do crachá do consumidor",
                "COLLUMN"=> "QTDIGCDIDCON",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.7",
                "NAME"   => "Posição inicial para leitura",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Formatação do crachá do consumidor",
                "COLLUMN"=> "NRPOSINICONS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.8",
                "NAME"   => "Posição final para leitura",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Formatação do crachá do consumidor",
                "COLLUMN"=> "NRPOSFINCONS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.9",
                "NAME"   => "Digita CPF no Pin-Pad",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->CPF do Consumidor na Venda",
                "COLLUMN"=> "IDINFOCPFPINPAD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.10",
                "NAME"   => "Consulta Dados do Consumidor da Campanha de Fidelidade (Mecánica de Benefícios)",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Parâmetro Utilizado para Consultar Dados da Campanha Fidelidade",
                "COLLUMN"=> "IDCONSCAMPFIDEL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.11",
                "NAME"   => "Parametrização Imprime Limite - Venda Débito Consumidor",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Parametrização Imprime Limite - Venda Débito Consumidor",
                "COLLUMN"=> "IDPARIMPRLIMVDC",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.12",
                "NAME"   => "Define que a unidade utiliza Controle de Confirmação de Cadastro do consumidor para a liberação do consumo",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Confirmação do cadastro do Consumidor",
                "COLLUMN"=> "IDUTCONFCADCONS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.12",
                "NAME"   => "Parametrização Imprime Saldo - Venda Crédito Pessoal / Débito Consumidor",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Parametrização Imprime Saldo - Venda Crédito Pessoal / Débito Consumidor",
                "COLLUMN"=> "IDIMPSALDOCUPOM",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.1.4.13",
                "NAME"   => "Utiliza Consulta de Consumidor Online",
                "PATH"   => "Parâmetros da Unidade->Frente de Caixa->Definições de Consumidor->Consumidor online",
                "COLLUMN"=> "IDUTICONSONLINE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.1.4"
            ),
            (object) array(
                "ID"     => "4.2",
                "NAME"   => "Regras de Preços",
                "PATH"   => "Parâmetros da Unidade->Regras de Preços",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "4.2.1",
                "NAME"   => "Tabela de preço Utilizada pela Unidade",
                "PATH"   => "Parâmetros da Unidade->Regras de Preços->Tabela de Preço",
                "COLLUMN"=> "NMTABEPREC",
                "TABLE"  => "TABEPREC",
                "PARENT" => "4.2"
            ),
            (object) array(
                "ID"     => "4.2.2",
                "NAME"   => "Permite informar preço na composição de um produto",
                "PATH"   => "Parâmetros da Unidade->Regras de Preços->Composição de Produto",
                "COLLUMN"=> "IDPRECDIFCOM",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.2"
            ),
            (object) array(
                "ID"     => "4.2.3",
                "NAME"   => "Permite alterar preço do produto na Manutenção da venda",
                "PATH"   => "Parâmetros da Unidade->Regras de Preços->Manutenção da Venda",
                "COLLUMN"=> "IDALTPRECO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.2"
            ),
            (object) array(
                "ID"     => "4.2.4",
                "NAME"   => "Utiliza Preço calculado com base no custo do produto",
                "PATH"   => "Parâmetros da Unidade->Regras de Preços->Formação do Preço de Venda dos Produtos",
                "COLLUMN"=> "IDFORMAPRECO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.2"
            ),
            (object) array(
                "ID"     => "4.2.5",
                "NAME"   => "Custo de Formação de preço",
                "PATH"   => "Parâmetros da Unidade->Regras de Preços->Formação do Preço de Venda dos Produtos",
                "COLLUMN"=> "IDCUSFOPRECO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.2"
            ),
            (object) array(
                "ID"     => "4.3",
                "NAME"   => "Consolidação de Vendas",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "4.3.1",
                "NAME"   => "Não Permite consolidar vendas caso existam datas não consolidadas anteriormente",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Restrição de Datas",
                "COLLUMN"=> "IDCONSUMIOBR",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.2",
                "NAME"   => "A partir de:",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Restrição de Datas",
                "COLLUMN"=> "DTINITESCONS",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.3",
                "NAME"   => "Tipo de Atualização do estoque utilizado na Consolidação de venda",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "IDATUEST",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.4",
                "NAME"   => "Série de saída padrão Utilizada na consolidação de Vendas",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "DSSERIE",
                "TABLE"  => "SERIENF",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.5",
                "NAME"   => "Tipo de retirada padrão Utilizada na consolidação de Vendas",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "NMTIPORETI",
                "TABLE"  => "TIPORETI",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.6",
                "NAME"   => "Setor Padrão utilizado na consolidação de vendas",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "NMSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.7",
                "NAME"   => "Permite consolidar vendas para lançamentos que geram valores negativos em estoque",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "IDPERCONVESTNEG",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.8",
                "NAME"   => "Permite visualizar os produtos que ficarão irregulares no estoque",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "IDVISUPRODNEG",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.9",
                "NAME"   => "Habilita pesquisa de produto para gerar nota fiscal de venda por produto",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "IDGERANFVENPROD",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.10",
                "NAME"   => "Gera contábil?",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "IDUTILCONTAB",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.3.11",
                "NAME"   => "Bloqueia Consolidação de vendas / Geração de nota fiscal para produtos inativos ou cadastrados para a unidade",
                "PATH"   => "Parâmetros da Unidade->Consolidação de vendas->Padões da consolidação",
                "COLLUMN"=> "IDBLOQCONSOLIDA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.3"
            ),
            (object) array(
                "ID"     => "4.4",
                "NAME"   => "Integração",
                "PATH"   => "Parâmetros da Unidade->Integração",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "4.4.1",
                "NAME"   => "Opção de pagamento usadas pela Unidade",
                "PATH"   => "Parâmetros da Unidade->Integração",
                "PARENT" => "4.4"
            ),
            (object) array(
                "ID"     => "4.4.1.1",
                "NAME"   => "Boleto Bancário",
                "PATH"   => "Parâmetros da Unidade->Integração->Opção de pagamento usadas pela Unidade",
                "COLLUMN"=> "IDRECBOLETBANC",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.1"
            ),
            (object) array(
                "ID"     => "4.4.1.2",
                "NAME"   => "Banco Itaú",
                "PATH"   => "Parâmetros da Unidade->Integração->Opção de pagamento usadas pela Unidade",
                "COLLUMN"=> "IDRECBANCOITAU",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.1"
            ),
            (object) array(
                "ID"     => "4.4.1.3",
                "NAME"   => "Banco Bradesco",
                "PATH"   => "Parâmetros da Unidade->Integração->Opção de pagamento usadas pela Unidade",
                "COLLUMN"=> "IDRECBANCOBRADE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.1"
            ),
            (object) array(
                "ID"     => "4.4.2",
                "NAME"   => "Integração com site",
                "PATH"   => "Parâmetros da Unidade->Integração",
                "PARENT" => "4.4"
            ),
            (object) array(
                "ID"     => "4.4.2.1",
                "NAME"   => "Define que a unidade utiliza integração com Site",
                "PATH"   => "Parâmetros da Unidade->Integração->Integração com site",
                "COLLUMN"=> "IDFILUTSITE",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.2"
            ),
            (object) array(
                "ID"     => "4.4.2.2",
                "NAME"   => "Define que a unidade enviará e-mail quando Saldo Negativo",
                "PATH"   => "Parâmetros da Unidade->Integração->Integração com Site",
                "COLLUMN"=> "IDFILENVEMAIL",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.2"
            ),
            (object) array(
                "ID"     => "4.4.2.3",
                "NAME"   => "Intervalo para envios de e-mails em caso de Saldo Negativo (Horas)",
                "PATH"   => "Parâmetros da Unidade->Integração->Integração com Site",
                "COLLUMN"=> "NRDIASPERSLDNEG",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.2"
            ),
            (object) array(
                "ID"     => "4.4.2.4",
                "NAME"   => "Texto padrão para e-mail de Saldo Negativo",
                "PATH"   => "Parâmetros da Unidade->Integração->Integração com Site",
                "COLLUMN"=> "DSEMAILSLDNEGATIVO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.2"
            ),
            (object) array(
                "ID"     => "4.4.3",
                "NAME"   => "Integração Delivery",
                "PATH"   => "Parâmetros da Unidade->Integração",
                "PARENT" => "4.4"
            ),
            (object) array(
                "ID"     => "4.4.3.1",
                "NAME"   => "ID Ifood",
                "PATH"   => "Parâmetros da Unidade->Integração->Integração Delivery",
                "COLLUMN"=> "CDFILIALEXT",
                "TABLE"  => "FILIAL",
                "PARENT" => "4.4.3"
            ),
            (object) array(
                "ID"     => "4.4.3.1",
                "NAME"   => "ID Spoon",
                "PATH"   => "Parâmetros da Unidade->Integração->Integração Delivery",
                "COLLUMN"=> "CDFILIALEXTSPOON",
                "TABLE"  => "FILIAL",
                "PARENT" => "4.4.3"
            ),
            (object) array(
                "ID"     => "4.4.4",
                "NAME"   => "Integração AME",
                "PATH"   => "Parâmetros da Unidade->Integração",
                "PARENT" => "4.4"
            ),
            (object) array(
                "ID"     => "4.4.4.1",
                "NAME"   => "Ambiente de trabalho",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Integração->Integração AME",
                "COLLUMN"=> "IDAMBIENTEAME",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.4"
            ),
            (object) array(
                "ID"     => "4.4.4.2",
                "NAME"   => "% De Cashback",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Integração->Integração AME",
                "COLLUMN"=> "VRCASHBACK",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.4.4"
            ),
            (object) array(
                "ID"     => "4.5",
                "NAME"   => "Gestão de Vendas",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "4.5.1",
                "NAME"   => "Geral",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas",
                "PARENT" => "4.5"
            ),
            (object) array(
                "ID"     => "4.5.1.1",
                "NAME"   => "Grupo de produto para venda",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.1.1",
                "NAME"   => "Grupo de Produto para Venda",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Grupo de produto para venda",
                "COLLUMN"=> "NMGRUPPROD",
                "TABLE"  => "GRUPPROD",
                "PARENT" => "4.5.1.1"
            ),
            (object) array(
                "ID"     => "4.5.1.1.2",
                "NAME"   => "Utiliza importação de vendas de outros sistemas",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Grupo de produto para venda",
                "COLLUMN"=> "IDORIGVENDA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.1"
            ),
            (object) array(
                "ID"     => "4.5.1.1.3",
                "NAME"   => "Nº Dias p/ Cálculo da média de vendas",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Grupo de produto para venda",
                "COLLUMN"=> "NRDIASVENDA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.1"
            ),
            (object) array(
                "ID"     => "4.5.1.1.4",
                "NAME"   => "Dias para Faturamento",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Grupo de produto para venda",
                "COLLUMN"=> "NRDIAFATVEND",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.1"
            ),
            (object) array(
                "ID"     => "4.5.1.2",
                "NAME"   => "Mapa Resumo ECF",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.2.1",
                "NAME"   => "Consistir Redução Z no relatório mapa resumo ECF",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Mapa Resumo ECF",
                "COLLUMN"=> "IDCONSREDZMECF",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.2"
            ),
            (object) array(
                "ID"     => "4.5.1.2.1",
                "NAME"   => "Tipo de Geração do sequencial no relatório mapa resumo ECF",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Mapa Resumo ECF",
                "COLLUMN"=> "IDTIPMAPRESU",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.2"
            ),
            (object) array(
                "ID"     => "4.5.1.3",
                "NAME"   => "Geração TC",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.3.1",
                "NAME"   => "Gera TC no fechamento do dia",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Geração TC",
                "COLLUMN"=> "IDCONSTCFECDIA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.3"
            ),
            (object) array(
                "ID"     => "4.5.1.3.1",
                "NAME"   => "Exporta dados em:",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Geração TC",
                "COLLUMN"=> "IDGERACAOTC",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.3"
            ),
            (object) array(
                "ID"     => "4.5.1.4",
                "NAME"   => "Outros",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.4.1",
                "NAME"   => "Permite marcação duplicada em catraca",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Outros",
                "COLLUMN"=> "IDPERMARCDUP",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.4"
            ),
            (object) array(
                "ID"     => "4.5.1.4.2",
                "NAME"   => "Tipo de geração da previsão de consumo",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Outros",
                "COLLUMN"=> "IDPREVCONSPDV",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.4"
            ),
            (object) array(
                "ID"     => "4.5.1.4.3",
                "NAME"   => "Realiza importação do campo \"Bloquear lançamentos quando o saldo for inferior a\" sempre com valor negativo",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Outros",
                "COLLUMN"=> "IDIMPBLOLANCNEG",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.4"
            ),
            (object) array(
                "ID"     => "4.5.1.4.4",
                "NAME"   => "Consiste Consolidação de vendas no fechamento do dia",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Outros",
                "COLLUMN"=> "IDCONSISTECONSO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.4"
            ),
            (object) array(
                "ID"     => "4.5.1.5",
                "NAME"   => "Parâmetros do Waiter",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.4.1",
                "NAME"   => "Solicita Quantidade ao Fazer Pedido",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Parâmetros do Waiter",
                "COLLUMN"=> "IDUTLQTDPED",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.1.5"
            ),
            (object) array(
                "ID"     => "4.5.1.6",
                "NAME"   => "Tipo de recebimento QRCode",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.6.1",
                "NAME"   => "Tipo de recebimento QRCode",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Tipo de recebimento QRCode",
                "COLLUMN"=> "NMTIPORECEQRCODE",
                "TABLE"  => "GRUPPROD",
                "PARENT" => "4.5.1.6"
            ),
            (object) array(
                "ID"     => "4.5.1.7",
                "NAME"   => "Utiliza Composição de Base de Cálculo do PIS/COFINS",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral",
                "PARENT" => "4.5.1"
            ),
            (object) array(
                "ID"     => "4.5.1.7.1",
                "NAME"   => "Utiliza Composição de Base de Cálculo do PIS/COFINS",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Geral->Utiliza Composição de Base de Cálculo do PIS/COFINS",
                "COLLUMN"=> "IDCOMPPISCOFINS",
                "TABLE"  => "GRUPPROD",
                "PARENT" => "4.5.1.7"
            ),
            (object) array(
                "ID"     => "4.5.2",
                "NAME"   => "Datas e Restrições",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas",
                "PARENT" => "4.5"
            ),
            (object) array(
                "ID"     => "4.5.2.1",
                "NAME"   => "Data de Processamento",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Data de Processamento",
                "COLLUMN"=> "DTPROCVND",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.2"
            ),
            (object) array(
                "ID"     => "4.5.2.2",
                "NAME"   => "Permite lançamentos Anteriores à data de Processamento:",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Antes do Processamento",
                "COLLUMN"=> "IDPERLANCANTDP",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.2"
            ),
            (object) array(
                "ID"     => "4.5.2.3",
                "NAME"   => "Dias para lançamentos",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Antes do Processamento",
                "COLLUMN"=> "NRDIAANTLANC",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.2"
            ),
            (object) array(
                "ID"     => "4.5.2.4",
                "NAME"   => "Permite lançamentos Posteriores à data de Processamento:",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Depois do Processamento",
                "COLLUMN"=> "IDPERLANCPOSDP",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.2"
            ),
            (object) array(
                "ID"     => "4.5.2.5",
                "NAME"   => "Dias para lançamentos",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Depois do Processamento",
                "COLLUMN"=> "NRDIAPOSLANC",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.2"
            ),
            (object) array(
                "ID"     => "4.5.2.6",
                "NAME"   => "Permite realizar manutenção de vendas:",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Manutenção de Venda",
                "COLLUMN"=> "IDPERMANUTVEN",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.2"
            ),
            (object) array(
                "ID"     => "4.5.3",
                "NAME"   => "Day Part",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas",
                "PARENT" => "4.5"
            ),
            (object) array(
                "ID"     => "4.5.3.1",
                "NAME"   => "1ºPeríodo Inicio",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRINI1DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.2",
                "NAME"   => "1ºPeríodo Fim",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRFIN1DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.3",
                "NAME"   => "2ºPeríodo Inicio",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRINI2DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.4",
                "NAME"   => "2ºPeríodo Fim",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRFIN2DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.5",
                "NAME"   => "3ºPeríodo Inicio",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRINI3DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.6",
                "NAME"   => "3ºPeríodo Fim",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRFIN3DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.7",
                "NAME"   => "4ºPeríodo Inicio",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRINI4DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
            (object) array(
                "ID"     => "4.5.3.8",
                "NAME"   => "4ºPeríodo Fim",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->Day Part",
                "COLLUMN"=> "HRFIN4DAYPART",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5.3"
            ),
             (object) array(
                "ID"     => "4.6",
                "NAME"   => "E-mail dos Gerentes",
                "PATH"   => "Parâmetros da Unidade->Gestão de Vendas->E-mail dos Gerentes",
                "COLLUMN"=> "emailGerentes",
                "TABLE"  => "PARAVEND",
                "PARENT" => "4.5"
            ),
            (object) array(
                "ID"     => "4.7",
                "NAME"   => "Produtos por Unidade",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "4.7.1",
                "NAME"   => "Util. Prod. Solicitado Obrigatório",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade->Util. Prod. Solicitado Obrigatório",
                "COLLUMN"=> "IDUTPRORIGOBRIG",
                "TABLE"  => "PRODFILI",
                "PARENT" => "4.7"
            ),
            (object) array(
                "ID"     => "4.7.2",
                "NAME"   => "(%) Tolerancia para Quantidade",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade->(%) Tolerancia para Quantidade",
                "COLLUMN"=> "VRPTOLQTITAF",
                "TABLE"  => "PRODFILI",
                "PARENT" => "4.7"
            ),
            (object) array(
                "ID"     => "4.7.3",
                "NAME"   => "(%) Tolerancia para Valor",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade->(%) Tolerancia para Valor",
                "COLLUMN"=> "VRPTOLVRITAF",
                "TABLE"  => "PRODFILI",
                "PARENT" => "4.7"
            ),
            (object) array(
                "ID"     => "4.7.4",
                "NAME"   => "Taxa Administrativa",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade->Taxa Administrativa",
                "COLLUMN"=> "VRTXADMPROD",
                "TABLE"  => "PRODFILI",
                "PARENT" => "4.7"
            ),
            (object) array(
                "ID"     => "4.7.5",
                "NAME"   => "(%) de Rejeição no empenho de AF",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade->(%) de Rejeição no empenho de AF",
                "COLLUMN"=> "VRMINEMPENHOAF",
                "TABLE"  => "PRODFILI",
                "PARENT" => "4.7"
            ),
            (object) array(
                "ID"     => "4.7.6",
                "NAME"   => "(%) de Rejeição no empenho de OL",
                "PATH"   => "Parâmetros da Unidade->Produtos por Unidade->(%) de Rejeição no empenho de OL",
                "COLLUMN"=> "VRMINEMPENHOOL",
                "TABLE"  => "PRODFILI",
                "PARENT" => "4.7"
            ),
            (object) array(
                "ID"     => "4.8",
                "NAME"   => "Código Externo do Produto",
                "PATH"   => "Parâmetros da Unidade->Código externo do produto",
                "PARENT" => "4"
            ),
            (object) array(
                "ID"     => "5",
                "NAME"   => "KDS",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "5.1",
                "NAME"   => "Unidade",
                "PATH"   => "KDS->Unidade",
                "PARENT" => "5"
            ),
            (object) array(
                "ID"     => "5.1.1",
                "NAME"   => "Unidade",
                "PATH"   => "KDS->Unidade->Unidade",
                "PARENT" => "5.1"
            ),
            (object) array(
                "ID"     => "5.1.1.1",
                "NAME"   => "Atraso padrão para produção do item no KDS ( Minutos )",
                "PATH"   => "KDS->Unidade->Unidade->Atraso padrão para produção do item no KDS ( Minutos )",
                "COLLUMN"=> "NRATRAPADRAO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "5.1.1"
            ),
            (object) array(
                "ID"     => "5.1.2",
                "NAME"   => "Setores por Unidade",
                "PATH"   => "KDS->Unidade->Setores por Unidade",
                "PARENT" => "5.1"
            ),
            (object) array(
                "ID"     => "5.1.2.1",
                "NAME"   => "Concluir a produção com somente um enter?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Concluir a produção com somente um enter?",
                "COLLUMN"=> "IDCONCDIRETO",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.2",
                "NAME"   => "Habilita aviso sonoro contínuo até inicio da produção?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Habilita aviso sonoro contínuo até inicio da produção?",
                "COLLUMN"=> "IDCONTSOMKDS",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.3",
                "NAME"   => "Habilita pré exibição dos itens?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Habilita pré exibição dos itens?",
                "COLLUMN"=> "IDHABPREENVIO",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.4",
                "NAME"   => "Exibe origem do pedido?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Exibe origem do pedido?",
                "COLLUMN"=> "IDMOSTRAORIGEM",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.5",
                "NAME"   => "Utiliza integração com painel de senhas?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Utiliza integração com painel de senhas?",
                "COLLUMN"=> "IDUTLINTPAINEL",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.6",
                "NAME"   => "Habilita função desfazer?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Função desfazer",
                "COLLUMN"=> "IDHABROLLBKDS",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.7",
                "NAME"   => "Tempo para desfazer (segundos)",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Função desfazer",
                "COLLUMN"=> "NRROLLBTIME",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.8",
                "NAME"   => "Habilita o timer de produção?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Timer de produção",
                "COLLUMN"=> "IDHABTIMERPROD",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.9",
                "NAME"   => "Habilita aviso sonoro contínuo até a conclusão do item?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Timer de produção",
                "COLLUMN"=> "IDHABCONTSOMPROD",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.10",
                "NAME"   => "Habilita aviso sonoro na conclusão da produção?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Timer de produção",
                "COLLUMN"=> "IDHABSOMPROD",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.11",
                "NAME"   => "Tempo de atraso para aviso sonoro na conclusão da produção (segundos)",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Timer de produção",
                "COLLUMN"=> "NRPRODATRAINISOM",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.12",
                "NAME"   => "Impede a conclusão do item até que acabe o tempo de produção?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Timer de produção",
                "COLLUMN"=> "IDBLOQPRODKDS",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.13",
                "NAME"   => "Habilita aviso sonoro ao chegar pedido?",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Chegada do pedido",
                "COLLUMN"=> "IDHABSOMKDS",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.14",
                "NAME"   => "Tempo de atraso para aviso sonoro ao chegar pedido (segundos)",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Chegada do pedido",
                "COLLUMN"=> "NRATRASOSOMPROD",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.15",
                "NAME"   => "Aviso Sonoro ao Chegar Pedido",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Chegada do pedido",
                "COLLUMN"=> "ARQUIVO",
                "TABLE"  => "ARQUIVOS",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.16",
                "NAME"   => "Arquivos Do Servidor",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Chegada do pedido",
                "COLLUMN"=> "NMARQUIVO",
                "TABLE"  => "ARQUIVOS",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.17",
                "NAME"   => "Habilita agrupamento de itens por pedido",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Habilita agrupamento de itens por pedido",
                "COLLUMN"=> "IDHABAGRUPPROD",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.18",
                "NAME"   => "Cor de observação para viagem",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Cor de observação para viagem",
                "COLLUMN"=> "NRCORVGM",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.2.19",
                "NAME"   => "Condicionar Liberação ao Pagamento",
                "PATH"   => "KDS->Unidade->Setores por Unidade->Condicionar Liberação ao Pagamento",
                "COLLUMN"=> "IDLIBCONDPG",
                "TABLE"  => "SETORFILIAL",
                "PARENT" => "5.1.2"
            ),
            (object) array(
                "ID"     => "5.1.3",
                "NAME"   => "Lojas",
                "PATH"   => "KDS->Unidade->Lojas",
                "PARENT" => "5.1"
            ),
            (object) array(
                "ID"     => "5.1.3.1",
                "NAME"   => "Setores por Loja",
                "PATH"   => "KDS->Unidade->Lojas->Setores por Loja",
                "PARENT" => "5.1.3"
            ),
            (object) array(
                "ID"     => "5.1.3.1.1",
                "NAME"   => "Código",
                "PATH"   => "KDS->Unidade->Lojas->Setores por Loja->Código",
                "COLLUMN"=> "CDSETOR",
                "TABLE"  => "SETORLOJA",
                "PARENT" => "5.1.3.1"
            ),
            (object) array(
                "ID"     => "5.1.3.1.2",
                "NAME"   => "Setor",
                "PATH"   => "KDS->Unidade->Lojas->Setores por Loja->Setor",
                "COLLUMN"=> "NMSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.1.3.1"
            ),
            (object) array(
                "ID"     => "5.1.3.1.3",
                "NAME"   => "Sigla",
                "PATH"   => "KDS->Unidade->Lojas->Setores por Loja->Sigla",
                "COLLUMN"=> "SGSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.1.3.1"
            ),
            (object) array(
                "ID"     => "5.1.3.1.4",
                "NAME"   => "Tipo",
                "PATH"   => "KDS->Unidade->Lojas->Setores por Loja->Tipo",
                "COLLUMN"=> "IDTIPOSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.1.3.1"
            ),
            (object) array(
                "ID"     => "5.2",
                "NAME"   => "Setor",
                "PATH"   => "KDS->Setor",
                "PARENT" => "5"
            ),
            (object) array(
                "ID"     => "5.2.1",
                "NAME"   => "Setor",
                "PATH"   => "KDS->Setor->Setor",
                "PARENT" => "5.2"
            ),
            (object) array(
                "ID"     => "5.2.1.1",
                "NAME"   => "Código",
                "PATH"   => "KDS->Setor->Setor->Código",
                "COLLUMN"=> "CDSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.2.1"
            ),
            (object) array(
                "ID"     => "5.2.1.2",
                "NAME"   => "Sigla",
                "PATH"   => "KDS->Setor->Setor->Sigla",
                "COLLUMN"=> "SGSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.2.1"
            ),
            (object) array(
                "ID"     => "5.2.1.3",
                "NAME"   => "Nome",
                "PATH"   => "KDS->Setor->Setor->Nome",
                "COLLUMN"=> "NMSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.2.1"
            ),
            (object) array(
                "ID"     => "5.2.1.4",
                "NAME"   => "Tipo",
                "PATH"   => "KDS->Setor->Setor->Tipo",
                "COLLUMN"=> "IDTIPOSETOR",
                "TABLE"  => "SETOR",
                "PARENT" => "5.2.1"
            ),
            (object) array(
                "ID"     => "5.2.2",
                "NAME"   => "Produtos do Setor",
                "PATH"   => "KDS->Setor->Produtos do Setor",
                "PARENT" => "5.2"
            ),
            (object) array(
                "ID"     => "5.2.2.1",
                "NAME"   => "Produtos do Setor",
                "PATH"   => "KDS->Setor->Produtos do Setor->Produtos do Setor",
                "PARENT" => "5.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.1.1",
                "NAME"   => "Exibição do resumo de produção",
                "PATH"   => "KDS->Setor->Produtos do Setor->Produtos do Setor->Exibição do resumo de produção",
                "COLLUMN"=> "IDRESUMOPRODKDS",
                "TABLE"  => "SETORPRODUTO",
                "PARENT" => "5.2.2.1"
            ),
            (object) array(
                "ID"     => "5.2.2.1.2",
                "NAME"   => "Origem do Pedido",
                "PATH"   => "KDS->Setor->Produtos do Setor->Produtos do Setor->Origem do Pedido",
                "COLLUMN"=> "IDRESTRICAOORIGEM",
                "TABLE"  => "SETORPRODUTO",
                "PARENT" => "5.2.2.1"
            ),
            (object) array(
                "ID"     => "5.2.2.1.3",
                "NAME"   => "Apelido para Resumo",
                "PATH"   => "KDS->Setor->Produtos do Setor->Produtos do Setor->Apelido para Resumo",
                "COLLUMN"=> "DSAPELIDORESUMO",
                "TABLE"  => "SETORPRODUTO",
                "PARENT" => "5.2.2.1"
            ),
            (object) array(
                "ID"     => "5.2.2.2",
                "NAME"   => "Observações",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações",
                "PARENT" => "5.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.2.1",
                "NAME"   => "Código Grupo",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações->Código Grupo",
                "COLLUMN"=> "CDGRPOCOR",
                "TABLE"  => "SETORPRODOBS",
                "PARENT" => "5.2.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.2.2",
                "NAME"   => "Grupo",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações->Grupo",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "5.2.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.2.3",
                "NAME"   => "Código Observação",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações->Código observação",
                "COLLUMN"=> "CDOCORR",
                "TABLE"  => "SETORPRODOBS",
                "PARENT" => "5.2.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.2.4",
                "NAME"   => "Observação",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações->Observação",
                "COLLUMN"=> "DSOCORR",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "5.2.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.2.5",
                "NAME"   => "Alteração no tempo de produção",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações->Alteração no tempo de produção",
                "COLLUMN"=> "NRTEMPOPROD",
                "TABLE"  => "SETORPRODOBS",
                "PARENT" => "5.2.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.2.6",
                "NAME"   => "Tempo da Alteração (segundos)",
                "PATH"   => "KDS->Setor->Produtos do Setor->Observações->Tempo da Alteração (segundos)",
                "COLLUMN"=> "NRTEMPOPROD",
                "TABLE"  => "SETORPRODOBS",
                "PARENT" => "5.2.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.3",
                "NAME"   => "Intervalos",
                "PATH"   => "KDS->Setor->Produtos do Setor->Intervalos",
                "PARENT" => "5.2.2"
            ),
            (object) array(
                "ID"     => "5.2.2.3.1",
                "NAME"   => "Sequência Intervalo",
                "PATH"   => "KDS->Setor->Produtos do Setor->Intervalos->Sequência Intervalo",
                "COLLUMN"=> "NRSEQINTERVALO",
                "TABLE"  => "SETORPRODINTER",
                "PARENT" => "5.2.2.3"
            ),
            (object) array(
                "ID"     => "5.2.2.3.2",
                "NAME"   => "Tempo do Intervalo (segundos)",
                "PATH"   => "KDS->Setor->Produtos do Setor->Intervalos->Tempo do Intervalo (segundos)",
                "COLLUMN"=> "NRTEMPOINTER",
                "TABLE"  => "SETORPRODINTER",
                "PARENT" => "5.2.2.3"
            ),
            (object) array(
                "ID"     => "5.3",
                "NAME"   => "Cores do Pedido",
                "PATH"   => "KDS->Cores do Pedido",
                "PARENT" => "5"
            ),
            (object) array(
                "ID"     => "5.3.1",
                "NAME"   => "Atraso de (segundos)",
                "PATH"   => "KDS->Cores do Pedido->Atraso de (segundos)",
                "COLLUMN"=> "NRINICIOCOR",
                "TABLE"  => "CORPEDIDO",
                "PARENT" => "5.3"
            ),
            (object) array(
                "ID"     => "5.3.2",
                "NAME"   => "Até (segundos)",
                "PATH"   => "KDS->Cores do Pedido->Até (segundos)",
                "COLLUMN"=> "NRFINALCOR",
                "TABLE"  => "CORPEDIDO",
                "PARENT" => "5.3"
            ),
            (object) array(
                "ID"     => "5.3.3",
                "NAME"   => "Cor Indicativa (hexadecimal)",
                "PATH"   => "KDS->Cores do Pedido->Cor Indicativa (hexadecimal)",
                "COLLUMN"=> "NRCORPEDIDO",
                "TABLE"  => "CORPEDIDO",
                "PARENT" => "5.3"
            ),
            (object) array(
                "ID"     => "5.3.4",
                "NAME"   => "Piscar",
                "PATH"   => "KDS->Cores do Pedido->Piscar",
                "COLLUMN"=> "IDPISCAPED",
                "TABLE"  => "CORPEDIDO",
                "PARENT" => "5.3"
            ),
            (object) array(
                "ID"     => "5.4",
                "NAME"   => "Mapeamento de Teclas",
                "PATH"   => "KDS->Mapeamento de Teclas",
                "PARENT" => "5"
            ),
            (object) array(
                "ID"     => "5.4.1",
                "NAME"   => "Código",
                "PATH"   => "KDS->Mapeamento de Teclas->Código",
                "COLLUMN"=> "NRKEY",
                "TABLE"  => "LAYOUTTECLAKDS",
                "PARENT" => "5.4"
            ),
            (object) array(
                "ID"     => "5.4.2",
                "NAME"   => "Função",
                "PATH"   => "KDS->Mapeamento de Teclas->Função",
                "COLLUMN"=> "IDFUNCAO",
                "TABLE"  => "LAYOUTTECLAKDS",
                "PARENT" => "5.4"
            ),
            (object) array(
                "ID"     => "5.4.3",
                "NAME"   => "Tecla",
                "PATH"   => "KDS->Mapeamento de Teclas->Tecla",
                "COLLUMN"=> "IDKEY",
                "TABLE"  => "LAYOUTTECLAKDS",
                "PARENT" => "5.4"
            ),
            (object) array(
                "ID"     => "6",
                "NAME"   => "Cadastro de Observação",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "6.2",
                "NAME"   => "Observações",
                "PATH"   => "Cadastro de Observação->Observações",
                "PARENT" => "6"
            ),
            (object) array(
                "ID"     => "6.1",
                "NAME"   => "Observação por produto",
                "PATH"   => "Cadastro de Observação->Observação por produto",
                "PARENT" => "6"
            ),
            (object) array(
                "ID"     => "6.3",
                "NAME"   => "Grupo de Observações Obrigatórias",
                "PATH"   => "Cadastro de Observação->Grupo de Observações Obrigatórias",
                "PARENT" => "6"
            ),
            (object) array(
                "ID"     => "6.1.1",
                "NAME"   => "Quantidade Mínima de Observações",
                "PATH"   => "Cadastro de Observação->Observação por produto->Quantidade Mínima de Observações",
                "COLLUMN"=> "NRQTDMINOBS",
                "TABLE"  => "PRODUTO",
                "PARENT" => "6.1"
            ),
            (object) array(
                "ID"     => "6.1.2",
                "NAME"   => "Observações",
                "PATH"   => "Cadastro de Observação->Observação por produto->Observações",
                "PARENT" => "6.1"
            ),
            (object) array(
                "ID"     => "6.1.2.1",
                "NAME"   => "Observações do Produto",
                "PATH"   => "Cadastro de Observação->Observação por produto->Observações->Observações do Produto",
                "PARENT" => "6.1"
            ),
            (object) array(
                "ID"     => "6.2.1",
                "NAME"   => "Observações",
                "PATH"   => "Cadastro de Observação->Observações->Observações",
                "PARENT" => "6.2"
            ),
            (object) array(
                "ID"     => "6.2.2",
                "NAME"   => "Produtos",
                "PATH"   => "Cadastro de Observação->Observações->Produtos",
                "PARENT" => "6.2"
            ),
            (object) array(
                "ID"     => "6.2.1.1",
                "NAME"   => "Código Externo da Observação",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Código Externo da Observação",
                "COLLUMN"=> "CDEXTOBSPROD",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.2",
                "NAME"   => "Tipo de Obs.",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Tipo de Obs.",
                "COLLUMN"=> "IDCONTROLAOBS",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.3",
                "NAME"   => "Apelido da Observação no aplicativo do consumidor",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Apelido da Observação no aplicativo do consumidor",
                "COLLUMN"=> "DSAPELIDOOBS",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.4",
                "NAME"   => "Exibe observação no aplicativo do consumidor",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Exibe observação no aplicativo do consumidor",
                "COLLUMN"=> "IDEXIOBSAPPCONS",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.5",
                "NAME"   => "Produto",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Produto",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.6",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Nome",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.7",
                "NAME"   => "Destaca no KDS",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Destaca no KDS",
                "COLLUMN"=> "IDSINAL",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.1.8",
                "NAME"   => "Imagem da Observação",
                "PATH"   => "Cadastro de Observação->Observações->Observações->Imagem da Observação",
                "COLLUMN"=> "DSENDEIMGOCORR",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "6.2.1"
            ),
            (object) array(
                "ID"     => "6.2.2.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Observação->Observações->Produto->Código",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "6.2.2"
            ),
            (object) array(
                "ID"     => "6.2.2.2",
                "NAME"   => "Produto",
                "PATH"   => "Cadastro de Observação->Observações->Produto->Nome",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "6.2.2"
            ),
            (object) array(
                "ID"     => "7",
                "NAME"   => "Delivery",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "7.1",
                "NAME"   => "Geral",
                "PATH"   => "Delivery->Geral",
                "PARENT" => "7"
            ),
            (object) array(
                "ID"     => "7.1.1",
                "NAME"   => "Modo do Delivery",
                "PATH"   => "Delivery->Geral->Modo do Delivery",
                "COLLUMN"=> "IDMODODLV",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "7.1"
            ),
            (object) array(
                "ID"     => "7.1.2",
                "NAME"   => "Cliente Padrão",
                "PATH"   => "Delivery->Geral->Cliente Padrão",
                "COLLUMN"=> "NMRAZSOCCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "7.1"
            ),
            (object) array(
                "ID"     => "7.1.3",
                "NAME"   => "Preço Mínimo do Pedido (R$)",
                "PATH"   => "Delivery->Geral->Preço Mínimo do Pedido (R$)",
                "COLLUMN"=> "VRMINPEDIDO",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "7.1"
            ),
            (object) array(
                "ID"     => "7.1.4",
                "NAME"   => "Código da loja do E-sitef",
                "PATH"   => "Delivery->Geral->Código da loja do E-sitef",
                "COLLUMN"=> "CDLOJAESITEF",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "7.1"
            ),
            (object) array(
                "ID"     => "7.1.5",
                "NAME"   => "Vendedor",
                "PATH"   => "Delivery->Geral->Vendedor",
                "COLLUMN"=> "NMRAZSOCVEN",
                "TABLE"  => "VENDEDOR",
                "PARENT" => "7.1"
            ),
            (object) array(
                "ID"     => "7.1.6",
                "NAME"   => "Tipo de Validação",
                "PATH"   => "Delivery->Geral->Tipo de Validação",
                "COLLUMN"=> "IDVALIDAATEN",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "7.1"
            ),
            (object) array(
                "ID"     => "7.2",
                "NAME"   => "Unidade",
                "PATH"   => "Delivery->Unidade",
                "PARENT" => "7"
            ),
            (object) array(
                "ID"     => "7.2.1",
                "NAME"   => "Parâmetros",
                "PATH"   => "Delivery->Unidade->Parâmetros",
                "PARENT" => "7.2"
            ),
            (object) array(
                "ID"     => "7.2.1.1",
                "NAME"   => "Cliente Padrão",
                "PATH"   => "Delivery->Unidade->Parâmetros->Cliente Padrão",
                "COLLUMN"=> "CDCLIENTE & NMRAZSOCCLIE",
                "TABLE"  => "PARAVEND & CLIENTE respectivamente",
                "PARENT" => "7.2.1"
            ),
            (object) array(
                "ID"     => "7.2.1.2",
                "NAME"   => "Vendedor Padrão",
                "PATH"   => "Delivery->Unidade->Parâmetros->Vendedor Padrão",
                "COLLUMN"=> "CDVENDEDOR & NMFANVEN",
                "TABLE"  => "PARAVEND & VENDEDOR",
                "PARENT" => "7.2.1"
            ),
            (object) array(
                "ID"     => "7.2.1.3",
                "NAME"   => "Tempo de Entrega Limite (minutos)",
                "PATH"   => "Delivery->Unidade->Parâmetros->Tempo de Entrega Limite",
                "COLLUMN"=> "NRTEMPMAXENTR",
                "TABLE"  => "PARAVEND",
                "PARENT" => "7.2.1"
            ),
            (object) array(
                "ID"     => "7.2.1.4",
                "NAME"   => "Taxa de Entrega (R$)",
                "PATH"   => "Delivery->Unidade->Parâmetros->Taxa de Entrega",
                "COLLUMN"=> "VRTXENTREGA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "7.2.1"
            ),
            (object) array(
                "ID"     => "7.2.1.5",
                "NAME"   => "Preço Mínimo do Pedido (R$)",
                "PATH"   => "Delivery->Unidade->Parâmetros->Preço Mínimo do Pedido (R$)",
                "COLLUMN"=> "VRMINPEDIDO",
                "TABLE"  => "PARAVEND",
                "PARENT" => "7.2.1"
            ),
            (object) array(
                "ID"     => "7.2.1.6",
                "NAME"   => "Distância da área de atendimento (Km)",
                "PATH"   => "Delivery->Unidade->Parâmetros->Distância da área de atendimento(Km)",
                "COLLUMN"=> "NRDISTANCIAATEND",
                "TABLE"  => "PARAVEND",
                "PARENT" => "7.2.1"
            ),
            (object) array(
                "ID"     => "7.2.2",
                "NAME"   => "Loja",
                "PATH"   => "Delivery->Unidade->Loja",
                "PARENT" => "7.2"
            ),
            (object) array(
                "ID"     => "7.2.2.1",
                "NAME"   => "Delivery Tempo",
                "PATH"   => "Delivery->Unidade->Loja->Delivery Tempo",
                "PARENT" => "7.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.1.1",
                "NAME"   => "Tempo de entrega (Minutos)",
                "PATH"   => "Delivery->Unidade->Loja->Delivery Tempo->Tempo de entrega (Minutos)",
                "COLLUMN"=> "HRTEMPOENTREGA",
                "TABLE"  => "LOJA",
                "PARENT" => "7.2.2.1"
            ),
            (object) array(
                "ID"     => "7.2.2.1.2",
                "NAME"   => "Tempo de produção (Minutos)",
                "PATH"   => "Delivery->Unidade->Loja->Delivery Tempo->Tempo de produção (Minutos)",
                "COLLUMN"=> "NRTEMPOPRODUCAO",
                "TABLE"  => "LOJA",
                "PARENT" => "7.2.2.1"
            ),
            (object) array(
                "ID"     => "7.2.2.2",
                "NAME"   => "Horários de Agendamento",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Agendamento",
                "PARENT" => "7.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.2.1",
                "NAME"   => "Dia da Semana",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Agendamento->Dia da Semana",
                "COLLUMN"=> "NRDIAATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.2.2",
                "NAME"   => "Horário inicial",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Agendamento->Horário inicial",
                "COLLUMN"=> "HRINIATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.2.3",
                "NAME"   => "Horário Final",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Agendamento->Horário Final",
                "COLLUMN"=> "HRFIMATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.2.4",
                "NAME"   => "Situação",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Agendamento->Situação",
                "COLLUMN"=> "IDATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.3",
                "NAME"   => "Horários de Funcionamento",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Funcionamento",
                "PARENT" => "7.2.2"
            ),
            (object) array(
                "ID"     => "7.2.2.3.1",
                "NAME"   => "Dia da Semana",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Funcionamento->Dia da Semana",
                "COLLUMN"=> "NRDIAATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.3"
            ),
            (object) array(
                "ID"     => "7.2.2.2.2",
                "NAME"   => "Horário inicial",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Funcionamento->Horário inicial",
                "COLLUMN"=> "HRINIATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.3"
            ),
            (object) array(
                "ID"     => "7.2.2.2.3",
                "NAME"   => "Horário Final",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Funcionamento->Horário Final",
                "COLLUMN"=> "HRFIMATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.3"
            ),
            (object) array(
                "ID"     => "7.2.2.2.4",
                "NAME"   => "Situação",
                "PATH"   => "Delivery->Unidade->Loja->Horários de Funcionamento->Situação",
                "COLLUMN"=> "IDATENDELOJA",
                "TABLE"  => "ATENDELOJA",
                "PARENT" => "7.2.2.3"
            ),
            (object) array(
                "ID"     => "7.4",
                "NAME"   => "Bloqueio de Cartões de Crédito",
                "PATH"   => "Delivery->Bloqueio de Cartões de Crédito",
                "PARENT" => "7"
            ),
            (object) array(
                "ID"     => "7.4.1",
                "NAME"   => "Sequencial",
                "PATH"   => "Delivery->Bloqueio de Cartões de Crédito->Sequencial",
                "COLLUMN"=> "NRSEQCARTAOBLOQ",
                "TABLE"  => "CARTAOBLOQ",
                "PARENT" => "7.4"
            ),
            (object) array(
                "ID"     => "7.4.2",
                "NAME"   => "Cod. Cartão",
                "PATH"   => "Delivery->Bloqueio de Cartões de Crédito->Cod. Cartão",
                "COLLUMN"=> "NRPRIMEIROS & NRULTIMOS",
                "TABLE"  => "CARTAOBLOQ",
                "PARENT" => "7.4"
            ),
            (object) array(
                "ID"     => "7.4.3",
                "NAME"   => "6 primeiros digitos",
                "PATH"   => "Delivery->Bloqueio de Cartões de Crédito->6 primeiros digitos",
                "COLLUMN"=> "NRPRIMEIROS",
                "TABLE"  => "CARTAOBLOQ",
                "PARENT" => "7.4"
            ),
            (object) array(
                "ID"     => "7.4.4",
                "NAME"   => "2 últimos digitos",
                "PATH"   => "Delivery->Bloqueio de Cartões de Crédito->2 últimos digitos",
                "COLLUMN"=> "NRULTIMOS",
                "TABLE"  => "CARTAOBLOQ",
                "PARENT" => "7.4"
            ),
            (object) array(
                "ID"     => "7.4.5",
                "NAME"   => "Descrição",
                "PATH"   => "Delivery->Bloqueio de Cartões de Crédito->Descrição",
                "COLLUMN"=> "DESCCARTAO",
                "TABLE"  => "CARTAOBLOQ",
                "PARENT" => "7.4"
            ),
            (object) array(
                "ID"     => "7.3",
                "NAME"   => "Área de Atendimento",
                "PATH"   => "Delivery->Área de Atendimento",
                "PARENT" => "7"
            ),
            (object) array(
                "ID"     => "7.3.1",
                "NAME"   => "Nome",
                "PATH"   => "Delivery->Área de Atendimento",
                "COLLUMN"=> "NMAREA",
                "TABLE"  => "AREAATEND",
                "PARENT" => "7.3"
            ),
            (object) array(
                "ID"     => "7.3.2",
                "NAME"   => "Descrição",
                "PATH"   => "Delivery->Área de Atendimento->Descrição da Área",
                "COLLUMN"=> "DSAREA",
                "TABLE"  => "AREAATEND",
                "PARENT" => "7.3"
            ),
            (object) array(
                "ID"     => "7.3.3",
                "NAME"   => "Prioridade",
                "PATH"   => "Delivery->Área de Atendimento->Prioridade",
                "COLLUMN"=> "NRORDATEND",
                "TABLE"  => "FILIALAREA",
                "PARENT" => "7.3"
            ),
            (object) array(
                "ID"     => "7.3.4",
                "NAME"   => "Taxa de Entrega (R$)",
                "PATH"   => "Delivery->Área de Atendimento->Taxa de Entrega (R$)",
                "COLLUMN"=> "VRTXENTRFILIAR",
                "TABLE"  => "FILIALAREA",
                "PARENT" => "7.3"
            ),
            (object) array(
                "ID"     => "8",
                "NAME"   => "Imposto do Produto",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "8.1",
                "NAME"   => "Impostos",
                "PATH"   => "Imposto do Produto->Impostos",
                "PARENT" => "8"
            ),
            (object) array(
                "ID"     => "8.1.1",
                "NAME"   => "Código",
                "PATH"   => "Imposto do Produto->Impostos->Código",
                "COLLUMN"=> "CDIMPOSTO",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "8.1"
            ),
            (object) array(
                "ID"     => "8.1.2",
                "NAME"   => "Sigla",
                "PATH"   => "Imposto do Produto->Impostos->Sigla",
                "COLLUMN"=> "SGIMPOSTO",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "8.1"
            ),
            (object) array(
                "ID"     => "8.1.3",
                "NAME"   => "Nome",
                "PATH"   => "Imposto do Produto->Impostos->Nome",
                "COLLUMN"=> "NMIMPOSTO",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "8.1"
            ),
            (object) array(
                "ID"     => "8.1.4",
                "NAME"   => "Tipo",
                "PATH"   => "Imposto do Produto->Impostos->Tipo",
                "COLLUMN"=> "IDTPIMPOSFIS",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "8.1"
            ),
            (object) array(
                "ID"     => "8.2",
                "NAME"   => "Impostos do Produto",
                "PATH"   => "Imposto do Produto->Impostos do Produto",
                "PARENT" => "8"
            ),
            (object) array(
                "ID"     => "8.2.1",
                "NAME"   => "Código do Produto",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Código do Produto",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "PRODUTO",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.2",
                "NAME"   => "Nome",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Nome",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.3",
                "NAME"   => "Código de Barra",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Código de Barra",
                "COLLUMN"=> "CDBARPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.4",
                "NAME"   => "Imposto do Produto",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Imposto do Produto",
                "COLLUMN"=> "NMIMPOSTO",
                "TABLE"  => "IMPOSTO",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.5",
                "NAME"   => "Alíquota",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Alíquota",
                "COLLUMN"=> "VRPEALIMPFIS",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.6",
                "NAME"   => "Percentual Redução",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Percentual Redução",
                "COLLUMN"=> "VRPERCREDUCAO",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.7",
                "NAME"   => "Modalidade Base Cálculo",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Modalidade Base Cálculo",
                "COLLUMN"=> "IDMODALBASECALC",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.8",
                "NAME"   => "Incide PIS/COFINS",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Incide PIS/COFINS",
                "COLLUMN"=> "IDINCIDEPISCOF",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.9",
                "NAME"   => "Alíquota IBPT (Federal)",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Alíquota IBPT (Federal)",
                "COLLUMN"=> "VRALIQIBPT",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.10",
                "NAME"   => "Alíquota IBPT (Estadual)",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Alíquota IBPT (Estadual)",
                "COLLUMN"=> "VRALIQIBPTES",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.11",
                "NAME"   => "Código CFOP",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Código CFOP",
                "COLLUMN"=> "CDCFOPPFIS",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.12",
                "NAME"   => "Código CST/CSOSN (ICMS)",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Código CST/CSOSN (ICMS)",
                "COLLUMN"=> "CDCSTICMS",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.13",
                "NAME"   => "Código CST (PIS/COFINS)",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Código CST (PIS/COFINS)",
                "COLLUMN"=> "CDCSTPISCOF",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.14",
                "NAME"   => "Alíquota PIS",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Alíquota PIS",
                "COLLUMN"=> "VRALIQPIS",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "8.2.15",
                "NAME"   => "Alíquota COFINS",
                "PATH"   => "Imposto do Produto->Impostos do Produto->Alíquota COFINS",
                "COLLUMN"=> "VRALIQCOFINS",
                "TABLE"  => "ALIQIMPFIS",
                "PARENT" => "8.2"
            ),
            (object) array(
                "ID"     => "9",
                "NAME"   => "No Cash",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "9.1",
                "NAME"   => "Permissões NoCash App",
                "PATH"   => "Geral->Permissões NoCash App",
                "PARENT" => "9"
            ),
            (object) array(
                "ID"     => "9.1.1",
                "NAME"   => "Consulta Saldo",
                "PATH"   => "Geral->Permissões NoCash App->Consulta Saldo",
                "COLLUMN"=> "CONSULTASALDO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.2",
                "NAME"   => "Consulta Extrato",
                "PATH"   => "Geral->Permissões NoCash App->Consulta Extrato",
                "COLLUMN"=> "CONSULTAEXTRATO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.3",
                "NAME"   => "Recarrega Cartão",
                "PATH"   => "Geral->Permissões NoCash App->Recarrega Cartão",
                "COLLUMN"=> "RECARREGACARTAO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.4",
                "NAME"   => "Bloqueia Cartão",
                "PATH"   => "Geral->Permissões NoCash App->Bloqueia Cartão",
                "COLLUMN"=> "BLOQUEACARTAO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.5",
                "NAME"   => "Restrição Alimentar",
                "PATH"   => "Geral->Permissões NoCash App->Restrição Alimentar",
                "COLLUMN"=> "RESTRICAOALIMENTAR",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.6",
                "NAME"   => "Atualiza Cadastro",
                "PATH"   => "Geral->Permissões NoCash App->Atualiza Cadastro",
                "COLLUMN"=> "ATUALIZACADASTRO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.7",
                "NAME"   => "Altera Senha",
                "PATH"   => "Geral->Permissões NoCash App->Altera Senha",
                "COLLUMN"=> "TROCASENHA",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.8",
                "NAME"   => "Visualiza Cardápio",
                "PATH"   => "Geral->Permissões NoCash App->Visualiza Cardápio",
                "COLLUMN"=> "VISUALIZACARDAPIO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.9",
                "NAME"   => "Limita Valor",
                "PATH"   => "Geral->Permissões NoCash App->Limita Valor",
                "COLLUMN"=> "RESTRICAOVALOR",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.10",
                "NAME"   => "Fale Conosco",
                "PATH"   => "Geral->Permissões NoCash App->Fale Conosco",
                "COLLUMN"=> "FALECONOSCO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.11",
                "NAME"   => "Recarga Automática de Cartão",
                "PATH"   => "Geral->Permissões NoCash App->Recarga Automática de Cartão",
                "COLLUMN"=> "RECARGAAUTOCARTAO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.12",
                "NAME"   => "Edita/Cadastra Cartão",
                "PATH"   => "Geral->Permissões NoCash App->Edita/Cadastra Cartão",
                "COLLUMN"=> "EDITACARTAO",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.13",
                "NAME"   => "Realiza login utilizando Cliente",
                "PATH"   => "Geral->Permissões NoCash App->Realiza login utilizando",
                "COLLUMN"=> "LOGINCLIENTE",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.1.14",
                "NAME"   => "Notificações no aplicativo No Cash",
                "PATH"   => "Geral->Permissões NoCash App->Notificações no aplicativo No Cash",
                "COLLUMN"=> "NOTIFICACAOAPP",
                "TABLE"  => "PARAMNOCASH",
                "PARENT" => "9.1"
            ),
            (object) array(
                "ID"     => "9.2",
                "NAME"   => "Unidade",
                "PATH"   => "Unidade",
                "PARENT" => "9"
            ),
            (object) array(
                "ID"     => "9.2.1",
                "NAME"   => "Recomendações Nutricionais",
                "PATH"   => "Unidade->Recomendações Nutricionais",
                "COLLUMN"=> "DSRECOMENDNUTRI",
                "TABLE"  => "PARAVEND",
                "PARENT" => "9.2"
            ),
            (object) array(
                "ID"     => "9.2.2",
                "NAME"   => "Tipos de Consumidor relacionados",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados",
                "PARENT" => "9.2"
            ),
            (object) array(
                "ID"     => "9.2.2.1",
                "NAME"   => "Consulta Saldo",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Consulta Saldo",
                "COLLUMN"=> "CONSULTASALDO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.2",
                "NAME"   => "Consulta Extrato",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Consulta Extrato",
                "COLLUMN"=> "CONSULTAEXTRATO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.3",
                "NAME"   => "Recarrega Cartão",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Recarrega Cartão",
                "COLLUMN"=> "RECARREGACARTAO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.4",
                "NAME"   => "Bloqueia Cartão",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Bloqueia Cartão",
                "COLLUMN"=> "BLOQUEACARTAO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.5",
                "NAME"   => "Restrição Alimentar",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Restrição Alimentar",
                "COLLUMN"=> "RESTRICAOALIMENTAR",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.6",
                "NAME"   => "Atualiza Cadastro",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Atualiza Cadastro",
                "COLLUMN"=> "ATUALIZACADASTRO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.7",
                "NAME"   => "Altera Senha",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Altera Senha",
                "COLLUMN"=> "TROCASENHA",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.8",
                "NAME"   => "Visualiza Cadastro",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Visualiza Cadastro",
                "COLLUMN"=> "VISUALIZACARDAPIO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.9",
                "NAME"   => "Limita Valor",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Limita Valor",
                "COLLUMN"=> "RESTRICAOVALOR",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.10",
                "NAME"   => "Fale Conosco",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Fale Conosco",
                "COLLUMN"=> "FALECONOSCO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.11",
                "NAME"   => "Recarga Automática de Cartão",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Recarga Automática de Cartão",
                "COLLUMN"=> "RECARGAAUTOCARTAO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.12",
                "NAME"   => "Edita/Cadastra Cartão",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Edita/Cadastra Cartão",
                "COLLUMN"=> "EDITACARTAO",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "9.2.2.13",
                "NAME"   => "Notificações no aplicativo No Cash",
                "PATH"   => "Unidade->Tipos de Consumidor relacionados->Notificações no aplicativo No Cash",
                "COLLUMN"=> "NOTIFICACAOAPP",
                "TABLE"  => "TIPOCONSCLI",
                "PARENT" => "9.2.2"
            ),
            (object) array(
                "ID"     => "10",
                "NAME"   => "Cadastro de Consumidor",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "10.1",
                "NAME"   => "Formulário",
                "PATH"   => "Cadastro de Consumidor->Formulário",
                "PARENT" => "10"
            ),
            (object) array(
                "ID"     => "10.1.3",
                "NAME"   => "Cliente",
                "PATH"   => "Cadastro de Consumidor->Formulário->Cliente",
                "COLLUMN"=> "NRINSJURCLIE & NMRAZSOCCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.4",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Consumidor->Formulário->Código",
                "COLLUMN"=> "CDCONSUMIDOR",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.5",
                "NAME"   => "Identificação",
                "PATH"   => "Cadastro de Consumidor->Formulário->Identificação",
                "COLLUMN"=> "CDIDCONSUMID",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.6",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Consumidor->Formulário->Nome",
                "COLLUMN"=> "NMCONSUMIDOR",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.7",
                "NAME"   => "Sexo",
                "PATH"   => "Cadastro de Consumidor->Formulário->Sexo",
                "COLLUMN"=> "IDSEXOCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.8",
                "NAME"   => "Data de Nascimento",
                "PATH"   => "Cadastro de Consumidor->Formulário->Data de Nascimento",
                "COLLUMN"=> "DTNASCCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.9",
                "NAME"   => "Email",
                "PATH"   => "Cadastro de Consumidor->Formulário->Email",
                "COLLUMN"=> "DSEMAILCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.10",
                "NAME"   => "Ativo",
                "PATH"   => "Cadastro de Consumidor->Formulário->Ativo",
                "COLLUMN"=> "IDSITCONSUMI",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.11",
                "NAME"   => "Vendedor",
                "PATH"   => "Cadastro de Consumidor->Formulário->Vendedor",
                "COLLUMN"=> "NMRAZSOCVEN",
                "TABLE"  => "VENDEDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.12",
                "NAME"   => "Código Externo",
                "PATH"   => "Cadastro de Consumidor->Formulário->Código Externo",
                "COLLUMN"=> "CDEXCONSUMID",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.13",
                "NAME"   => "Crachá Mestre",
                "PATH"   => "Cadastro de Consumidor->Formulário->Crachá Mestre",
                "COLLUMN"=> "IDCRACHAMESTRE",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.14",
                "NAME"   => "Tipo de Venda",
                "PATH"   => "Cadastro de Consumidor->Formulário->Tipo de Venda",
                "COLLUMN"=> "IDTPVENDACONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.15",
                "NAME"   => "Tipo de Consumidor",
                "PATH"   => "Cadastro de Consumidor->Formulário->Tipo de Consumidor",
                "COLLUMN"=> "NMTIPOCONS",
                "TABLE"  => "TIPOCONS",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.16",
                "NAME"   => "Centro de Custo",
                "PATH"   => "Cadastro de Consumidor->Formulário->Centro de Custo",
                "COLLUMN"=> "NMCCUSCLIE",
                "TABLE"  => "CCUSCLIE",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.1.17",
                "NAME"   => "Senha",
                "PATH"   => "Cadastro de Consumidor->Formulário->Senha",
                "COLLUMN"=> "CDSENHACONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.1"
            ),
            (object) array(
                "ID"     => "10.2",
                "NAME"   => "Dados do Responsável",
                "PATH"   => "Cadastro de Consumidor->Dados do Responsável",
                "PARENT" => "10"
            ),
            (object) array(
                "ID"     => "10.2.1",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Consumidor->Dados do Responsável->Nome",
                "COLLUMN"=> "NMRESPCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.2"
            ),
            (object) array(
                "ID"     => "10.2.2",
                "NAME"   => "CPF",
                "PATH"   => "Cadastro de Consumidor->Dados do Responsável->CPF",
                "COLLUMN"=> "NRCPFRESPCON",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.2"
            ),
            (object) array(
                "ID"     => "10.2.3",
                "NAME"   => "Identidade",
                "PATH"   => "Cadastro de Consumidor->Dados do Responsável->Identidade",
                "COLLUMN"=> "NRRGCONSUMID",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.2"
            ),
            (object) array(
                "ID"     => "10.2.4",
                "NAME"   => "Usuário",
                "PATH"   => "Cadastro de Consumidor->Dados do Responsável->Usuário",
                "COLLUMN"=> "NMLOGINCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.2"
            ),
            (object) array(
                "ID"     => "10.2.5",
                "NAME"   => "Alterar Senha de acesso ao Site",
                "PATH"   => "Cadastro de Consumidor->Dados do Responsável->Alterar Senha de acesso ao Site",
                "PARENT" => "10.2"
            ),
            (object) array(
                "ID"     => "10.3",
                "NAME"   => "Endereço",
                "PATH"   => "Cadastro de Consumidor->Endereço",
                "PARENT" => "10"
            ),
            (object) array(
                "ID"     => "10.3.1",
                "NAME"   => "País",
                "PATH"   => "Cadastro de Consumidor->Endereço->País",
                "COLLUMN"=> "NMPAIS",
                "TABLE"  => "PAIS",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.2",
                "NAME"   => "Estado",
                "PATH"   => "Cadastro de Consumidor->Endereço->Estado",
                "COLLUMN"=> "NMESTADO",
                "TABLE"  => "ESTADO",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.3",
                "NAME"   => "Município",
                "PATH"   => "Cadastro de Consumidor->Endereço->Município",
                "COLLUMN"=> "NMMUNICIPIO",
                "TABLE"  => "MUNICIPIO",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.4",
                "NAME"   => "Bairro",
                "PATH"   => "Cadastro de Consumidor->Endereço->Bairro",
                "COLLUMN"=> "NMBAIRRO",
                "TABLE"  => "BAIRRO",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.5",
                "NAME"   => "CEP",
                "PATH"   => "Cadastro de Consumidor->Endereço->CEP",
                "COLLUMN"=> "NRCEPCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.6",
                "NAME"   => "Rua",
                "PATH"   => "Cadastro de Consumidor->Endereço->Rua",
                "COLLUMN"=> "DSENDECONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.7",
                "NAME"   => "Telefone",
                "PATH"   => "Cadastro de Consumidor->Endereço->Telefone",
                "COLLUMN"=> "NRTELECONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.8",
                "NAME"   => "Ramal",
                "PATH"   => "Cadastro de Consumidor->Endereço->Ramal",
                "COLLUMN"=> "NRRAMAL1CONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.3.9",
                "NAME"   => "Celular",
                "PATH"   => "Cadastro de Consumidor->Endereço->Celular",
                "COLLUMN"=> "NRCELULARCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.3"
            ),
            (object) array(
                "ID"     => "10.4",
                "NAME"   => "Parâmetros",
                "PATH"   => "Cadastro de Consumidor->Parâmetros",
                "PARENT" => "10"
            ),
            (object) array(
                "ID"     => "10.4.1",
                "NAME"   => "Permite Consumo de Produto Extra",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Permite Consumo de Produto Extra",
                "COLLUMN"=> "IDPERCONSPRODEX",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.4.2",
                "NAME"   => "Permite Consumo no Lanche da Manhã",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Permite Consumo no Lanche da Manhã",
                "COLLUMN"=> "IDTPSELMANHA",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.4.3",
                "NAME"   => "Permite Consumo no Lanche da Tarde",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Permite Consumo no Lanche da Tarde",
                "COLLUMN"=> "IDTPSELTARDE",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.4.4",
                "NAME"   => "Permite Consumo no Almoço",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Permite Consumo no Almoço",
                "COLLUMN"=> "IDTPSEALMOCO",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.4.5",
                "NAME"   => "Atualiza CPF do Cadastro de Consumidor Durante a venda",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Atualiza CPF do Cadastro de Consumidor Durante a venda",
                "COLLUMN"=> "IDATUCPFCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.4.6",
                "NAME"   => "Imprime CPF",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Imprime CPF",
                "COLLUMN"=> "IDIMPCPFCUPOM",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.4.7",
                "NAME"   => "Cadastro Confirmado",
                "PATH"   => "Cadastro de Consumidor->Parâmetros->Cadastro Confirmado",
                "COLLUMN"=> "IDCADCONFLIBCON",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.4"
            ),
            (object) array(
                "ID"     => "10.5",
                "NAME"   => "Saldo",
                "PATH"   => "Cadastro de Consumidor->Saldo",
                "PARENT" => "10"
            ),
            (object) array(
                "ID"     => "10.5.1",
                "NAME"   => "Verificar saldo do Consumidor",
                "PATH"   => "Cadastro de Consumidor->Saldo->Verificar saldo do Consumidor",
                "COLLUMN"=> "IDVERSALDCON",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.2",
                "NAME"   => "Emitir aviso ao operador quando o saldo for",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Débito Consumidor",
                "COLLUMN"=> "VRAVIDEBCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.3",
                "NAME"   => "Bloquear lançamentos quando o saldo for",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Débito Consumidor",
                "COLLUMN"=> "VRLIMDEBCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.4",
                "NAME"   => "Valor máximo de Consumo",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Débito Consumidor",
                "COLLUMN"=> "VRMAXDEBCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.5",
                "NAME"   => "Valor subsidiado (Básico)",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Débito Consumidor",
                "COLLUMN"=> "VRSUBSBASICO",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.6",
                "NAME"   => "Emitir aviso ao operador quando o saldo for",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Crédito Pessoal",
                "COLLUMN"=> "VRAVICREDCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.7",
                "NAME"   => "Bloquear lançamentos quando o saldo for",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Crédito Pessoal",
                "COLLUMN"=> "VRLIMCREDCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.8",
                "NAME"   => "Valor máximo de Consumo",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Crédito Pessoal",
                "COLLUMN"=> "VRMAXCREDCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.9",
                "NAME"   => "Saldo mensal concedido pela empresa",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Crédito Pessoal",
                "COLLUMN"=> "VRMESUBCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.5.10",
                "NAME"   => "Percentual de subsídio em folha",
                "PATH"   => "Cadastro de Consumidor->Saldo->Venda Crédito Pessoal",
                "COLLUMN"=> "VRPESUBCONS",
                "TABLE"  => "CONSUMIDOR",
                "PARENT" => "10.5"
            ),
            (object) array(
                "ID"     => "10.6",
                "NAME"   => "Unidades Associadas",
                "PATH"   => "Cadastro de Consumidor->Unidades Associadas",
                "PARENT" => "10"
            ),
            (object) array(
                "ID"     => "10.6.1",
                "NAME"   => "Unidades Associadas ao Consumidor",
                "PATH"   => "Cadastro de Consumidor->Unidades Associadas->Unidades Associadas ao Consumidor",
                "PARENT" => "10.6"
            ),
            (object) array(
                "ID"     => "11",
                "NAME"   => "Parâmetros App. Consumidor",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "11.1",
                "NAME"   => "Geral",
                "PATH"   => "Parâmetros App. Consumidor->Geral",
                "PARENT" => "11"
            ),
            (object) array(
                "ID"     => "11.1.1",
                "NAME"   => "Plataforma de Pagamento Utilizada",
                "PATH"   => "Parâmetros App. Consumidor->Geral->Plataforma de Pagamento Utilizada",
                "COLLUMN"=> "IDPLATAFORMAPAG",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "11.1"
            ),
            (object) array(
                "ID"     => "11.1.2",
                "NAME"   => "Permitir Pagamento na Retirada dos Produtos na Loja",
                "PATH"   => "Parâmetros App. Consumidor->Geral->Permitir Pagamento na Retirada dos Produtos na Loja",
                "COLLUMN"=> "IDPERMITEPAGRETLOJA",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "11.1"
            ),
            (object) array(
                "ID"     => "11.2",
                "NAME"   => "Unidade",
                "PATH"   => "Parâmetros App. Consumidor->Unidade",
                "PARENT" => "11"
            ),
            (object) array(
                "ID"     => "11.2.1",
                "NAME"   => "Parâmetros",
                "PATH"   => "Parâmetros App. Consumidor->Unidade->Parâmetros",
                "PARENT" => "11.2"
            ),
            (object) array(
                "ID"     => "11.2.1.1",
                "NAME"   => "Plataforma de Pagamento Utilizada",
                "PATH"   => "Parâmetros App. Consumidor->Unidade->Parâmetros->Plataforma de Pagamento Utilizada",
                "COLLUMN"=> "IDPLATAFORMAPAG",
                "TABLE"  => "PARAVEND",
                "PARENT" => "11.2.1"
            ),
            (object) array(
                "ID"     => "11.2.1.2",
                "NAME"   => "Permitir Pagamento na Retirada dos Produtos na Loja",
                "PATH"   => "Parâmetros App. Consumidor->Unidade->Parâmetros->Permitir Pagamento na Retirada dos Produtos na Loja",
                "COLLUMN"=> "IDPERMITEPAGRETLOJA",
                "TABLE"  => "PARAVEND",
                "PARENT" => "11.2.1"
            ),
            (object) array(
                "ID"     => "12",
                "NAME"   => "Controle de acesso ao caixa",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "12.1",
                "NAME"   => "Trocar Operador",
                "PATH"   => "Controle de acesso ao caixa->Trocar Operador",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.2",
                "NAME"   => "Devolução Item",
                "PATH"   => "Controle de acesso ao caixa->Devolução Item",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.3",
                "NAME"   => "Cancela Cupom",
                "PATH"   => "Controle de acesso ao caixa->Cancela Cupom",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.4",
                "NAME"   => "Cancela Último Item",
                "PATH"   => "Controle de acesso ao caixa->Cancela Último Item",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.5",
                "NAME"   => "Cancela Item Genérico",
                "PATH"   => "Controle de acesso ao caixa->Cancela Item Genérico",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.6",
                "NAME"   => "Cancela Mesa/Comanda",
                "PATH"   => "Controle de acesso ao caixa->Cancela Mesa/Comanda",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.7",
                "NAME"   => "Consulta Saldo",
                "PATH"   => "Controle de acesso ao caixa->Consulta Saldo",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.8",
                "NAME"   => "Cupom com Desconto",
                "PATH"   => "Controle de acesso ao caixa->Cupom com Desconto",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.9",
                "NAME"   => "Produto Combinado",
                "PATH"   => "Controle de acesso ao caixa->Produto Combinado",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.10",
                "NAME"   => "Consulta Preço",
                "PATH"   => "Controle de acesso ao caixa->Consulta Preço",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.11",
                "NAME"   => "Relatórios Fiscais",
                "PATH"   => "Controle de acesso ao caixa->Relatórios Fiscais",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.12",
                "NAME"   => "Administração TEF",
                "PATH"   => "Controle de acesso ao caixa->Administração TEF",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.13",
                "NAME"   => "Sangria",
                "PATH"   => "Controle de acesso ao caixa->Sangria",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.14",
                "NAME"   => "Suprimento",
                "PATH"   => "Controle de acesso ao caixa->Suprimento",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.15",
                "NAME"   => "Leitura X",
                "PATH"   => "Controle de acesso ao caixa->Leitura X",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.16",
                "NAME"   => "Redução Z",
                "PATH"   => "Controle de acesso ao caixa->Redução Z",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.17",
                "NAME"   => "Abrir Gaveta",
                "PATH"   => "Controle de acesso ao caixa->Abrir Gaveta",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.18",
                "NAME"   => "Observação do Pedido",
                "PATH"   => "Controle de acesso ao caixa->Observação do Pedido",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.19",
                "NAME"   => "Fechar Caixa",
                "PATH"   => "Controle de acesso ao caixa->Fechar Caixa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.20",
                "NAME"   => "Bloquear Caixa",
                "PATH"   => "Controle de acesso ao caixa->Bloquear Caixa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.21",
                "NAME"   => "Liberar Mesa",
                "PATH"   => "Controle de acesso ao caixa->Liberar Mesa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.22",
                "NAME"   => "Retirar Consumação",
                "PATH"   => "Controle de acesso ao caixa->Retirar Consumação",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.23",
                "NAME"   => "Retirar Couvert",
                "PATH"   => "Controle de acesso ao caixa->Retirar Couvert",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),

            (object) array(
                "ID"     => "12.24",
                "NAME"   => "Retirar Taxa de Serviço",
                "PATH"   => "Controle de acesso ao caixa->Retirar Taxa de Serviço",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.25",
                "NAME"   => "Agrupar Mesas",
                "PATH"   => "Controle de acesso ao caixa->Agrupar Mesas",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.26",
                "NAME"   => "Cancelar Agrupamento/Separar Mesa",
                "PATH"   => "Controle de acesso ao caixa->Cancelar Agrupamento/Separar Mesa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.27",
                "NAME"   => "Transferir Mesa",
                "PATH"   => "Controle de acesso ao caixa->Transferir Mesa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.28",
                "NAME"   => "Transferir Produto",
                "PATH"   => "Controle de acesso ao caixa->Transferir Produto",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.29",
                "NAME"   => "Relatório de Produtos/Vendedor",
                "PATH"   => "Controle de acesso ao caixa->Relatório de Produtos/Vendedor",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.30",
                "NAME"   => "Pesquisar Produtos",
                "PATH"   => "Controle de acesso ao caixa->Pesquisar Produtos",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.31",
                "NAME"   => "Importar Dados",
                "PATH"   => "Controle de acesso ao caixa->Posição Mesa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.32",
                "NAME"   => "Posição Mesa",
                "PATH"   => "Controle de acesso ao caixa->Posição Mesa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.33",
                "NAME"   => "Reservar Mesa",
                "PATH"   => "Controle de acesso ao caixa->Reservar Mesa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.34",
                "NAME"   => "Alterar Nr. Pessoas",
                "PATH"   => "Controle de acesso ao caixa->Alterar Nr. Pessoas",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.35",
                "NAME"   => "Parcial Conta",
                "PATH"   => "Controle de acesso ao caixa->Parcial Conta",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.36",
                "NAME"   => "Abertura de Caixa",
                "PATH"   => "Controle de acesso ao caixa->Abertura de Caixa",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.37",
                "NAME"   => "Multiplicador Produto",
                "PATH"   => "Controle de acesso ao caixa->Multiplicador Produto",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.38",
                "NAME"   => "Troca de Mercadoria",
                "PATH"   => "Controle de acesso ao caixa->Troca de Mercadoria",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.39",
                "NAME"   => "Cupom com Acréscimo",
                "PATH"   => "Controle de acesso ao caixa->Cupom com Acréscimo",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.40",
                "NAME"   => "Transferência de Saldo (Cred. Pessoal)",
                "PATH"   => "Controle de acesso ao caixa->Transferência de Saldo (Cred. Pessoal)",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.41",
                "NAME"   => "Bloquear/Desbloquear Produto",
                "PATH"   => "Controle de acesso ao caixa->Bloquear/Desbloquear Produto",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.42",
                "NAME"   => "Reimpressão de Vendas NFCe/SAT",
                "PATH"   => "Controle de acesso ao caixa->Reimpressão de Vendas NFCe/SAT",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.43",
                "NAME"   => "Bloqueio de Dispositivo",
                "PATH"   => "Controle de acesso ao caixa->Bloqueio de Dispositivo",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID"     => "12.44",
                "NAME"   => "Mensagem de Produção",
                "PATH"   => "Controle de acesso ao caixa->Mensagem de Produção",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "12"
            ),
            (object) array(
                "ID" => "13",
                "NAME" => "Configuração Terminal de Caixa",
                "PATH" => null,
                "PARENT" => null
            ),
            (object) array(
                "ID" => "13.1",
                "NAME" => "Grupos de Produtos",
                "PATH" => "Configurações do Cadastro de Caixa->Grupos de Produtos",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE" => "GRUPOPER",
                "PARENT" => "13"
            ),
            (object) array(
                "ID" => "13.1.1",
                "NAME" => "Produtos",
                "PATH" => "Configurações do Cadastro de Caixa->Grupos de Produtos->Produtos",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE" => "GRUPOPER",
                "PARENT" => "13.1"
            ),
            (object) array(
                "ID" => "13.1.1.1",
                "NAME" => "Limite de produtos selecionados dentro da promoção combinada",
                "PATH" => "Configurações do Cadastro de Caixa->Grupos de Produtos->Produtos->Limite de produtos selecionados dentro da promoção combinada",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE" => "GRUPOPER",
                "PARENT" => "13.1.1"
            ),
            (object) array(
                "ID" => "14",
                "NAME" => "Configuração Menu de Produtos Combinados",
                "PATH" => null,
                "PARENT" => null
            ),
            (object) array(
                "ID" => "14.1",
                "NAME" => "Grupo de Produtos Combinados",
                "PATH" => "Configuração Menu de Produtos Combinados->Grupo de Produtos Combinados",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE" => "GRUPOPER",
                "PARENT" => "14"
            ),
            (object) array(
                "ID" => "14.1.1",
                "NAME" => "Limite de seleção",
                "PATH" => "Configuração Menu de Produtos Combinados->Grupo de Produtos Combinados->Limite de seleção",
                "COLLUMN"=> "DSSENHACAIXA",
                "TABLE" => "GRUPOPER",
                "PARENT" => "14.1"
            ),
            (object) array(
                "ID" => "15",
                "NAME" => "Modelo Impressora",
                "PATH" => null,
                "PARENT" => null
            ),
            (object) array(
                "ID" => "15.1",
                "NAME" => "Código",
                "PATH" => "Modelo Impressora->Código",
                "COLLUMN"=> "IDMODEIMPRES",
                "TABLE" => "IMPRESSORA",
                "PARENT" => "15"
            ),
            (object) array(
                "ID" => "15.2",
                "NAME" => "Modelo",
                "PATH" => "Modelo Impressora->Modelo",
                "COLLUMN"=> "NMIMPRESSORA",
                "TABLE" => "IMPRESSORA",
                "PARENT" => "15"
            ),
            (object) array(
                "ID" => "16",
                "NAME" => "Cadastro de Integração",
                "PATH" => null,
                "PARENT" => null
            ),
            (object) array(
                "ID" => "16.1",
                "NAME" => "Integrações",
                "PATH" => "Cadastro de Integração->Integrações",
                "PARENT" => "16"
            ),
            (object) array(
                "ID" => "16.1.1",
                "NAME" => "Código",
                "PATH" => "Cadastro de Integração->Integrações->Código",
                "COLLUMN"=> "CDINTEGRACAO",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.2",
                "NAME" => "Identificador",
                "PATH" => "Cadastro de Integração->Integrações->Identificador",
                "COLLUMN"=> "IDINTEGRACAO",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.3",
                "NAME" => "Nome",
                "PATH" => "Cadastro de Integração->Integrações->Nome",
                "COLLUMN"=> "NMINTEGRACAO",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.4",
                "NAME" => "Timezone UF",
                "PATH" => "Cadastro de Integração->Integrações->Timezone UF",
                "COLLUMN"=> "IDUFTIMEZONE",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.5",
                "NAME" => "Token Geral",
                "PATH" => "Cadastro de Integração->Integrações->Token Geral",
                "COLLUMN"=> "IDTOKENINTGERAL",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.6",
                "NAME" => "Senha Geral",
                "PATH" => "Cadastro de Integração->Integrações->Senha Geral",
                "COLLUMN"=> "IDSENHATOKENGERAL",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.7",
                "NAME" => "Habilita Integração",
                "PATH" => "Cadastro de Integração->Integrações->Habilita Integração",
                "COLLUMN"=> "IDHABINTE",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.1.8",
                "NAME" => "Habilita Rastreio de Motoqueiro",
                "PATH" => "Cadastro de Integração->Integrações->Habilita Rastreio de Motoqueiro",
                "COLLUMN"=> "IDRASTREIAENTREGA",
                "TABLE" => "INTEGRACAO",
                "PARENT" => "16.1"
            ),
            (object) array(
                "ID" => "16.2",
                "NAME" => "Tipo de Recebimento",
                "PATH" => "Cadastro de Integração->Tipo de Recebimento",
                "PARENT" => "16"
            ),
            (object) array(
                "ID" => "16.2.1",
                "NAME" => "Código Interno",
                "PATH" => "Cadastro de Integração->Tipo de Recebimento->Código Interno",
                "COLLUMN"=> "CDTIPORECE",
                "TABLE" => "TIPORECEINTE",
                "PARENT" => "16.2"
            ),
            (object) array(
                "ID" => "16.2.2",
                "NAME" => "Tipo de Recebimento",
                "PATH" => "Cadastro de Integração->Tipo de Recebimento->Tipo de Recebimento",
                "COLLUMN"=> "NMTIPORECE",
                "TABLE" => "TIPORECEINTE",
                "PARENT" => "16.2"
            ),
            (object) array(
                "ID" => "16.2.3",
                "NAME" => "Código Externo",
                "PATH" => "Cadastro de Integração->Tipo de Recebimento->Código Externo",
                "COLLUMN"=> "CDTPRECEINTE",
                "TABLE" => "TIPORECEINTE",
                "PARENT" => "16.2"
            ),
            (object) array(
                "ID" => "16.3",
                "NAME" => "Unidade",
                "PATH" => "Cadastro de Integração->Unidade",
                "PARENT" => "16"
            ),
            (object) array(
                "ID" => "16.3.1",
                "NAME" => "Unidade",
                "PATH" => "Cadastro de Integração->Unidade->Unidade",
                "PARENT" => "16.3"
            ),
            (object) array(
                "ID" => "16.3.1.1",
                "NAME" => "Código",
                "PATH" => "Cadastro de Integração->Unidade->Código",
                "COLLUMN"=> "CDFILIAL",
                "TABLE" => "FILIAL",
                "PARENT" => "16.3.1"
            ),
            (object) array(
                "ID" => "16.3.1.2",
                "NAME" => "Unidade",
                "PATH" => "Cadastro de Integração->Unidade->Unidade",
                "COLLUMN"=> "NMFILIAL",
                "TABLE" => "FILIAL",
                "PARENT" => "16.3.1"
            ),
            (object) array(
                "ID" => "16.3.2",
                "NAME" => "Token",
                "PATH" => "Cadastro de Integração->Unidade->Token",
                "PARENT" => "16.3"
            ),
            (object) array(
                "ID" => "16.3.2.1",
                "NAME" => "Token",
                "PATH" => "Cadastro de Integração->Unidade->Token->Token",
                "COLLUMN"=> "IDTOKEN",
                "TABLE" => "INTEGRACAOFILI",
                "PARENT" => "16.3.2"
            ),
            (object) array(
                "ID" => "16.3.2.2",
                "NAME" => "Descrição",
                "PATH" => "Cadastro de Integração->Unidade->Token->Descrição",
                "COLLUMN"=> "DSTOKENFILI",
                "TABLE" => "INTEGRACAOFILI",
                "PARENT" => "16.3.2"
            ),
            (object) array(
                "ID" => "16.3.2.3",
                "NAME" => "Retira Taxa de Entrega do Cupom",
                "PATH" => "Cadastro de Integração->Unidade->Token->Retira Taxa de Entrega do Cupom",
                "COLLUMN"=> "IDRETTXENTR",
                "TABLE" => "INTEGRACAOFILI",
                "PARENT" => "16.3.2"
            ),
            (object) array(
                "ID" => "16.3.2.4",
                "NAME" => "Utiliza Entregadores Terceirizados",
                "PATH" => "Cadastro de Integração->Unidade->Token->Utiliza Entregadores Terceirizados",
                "COLLUMN"=> "IDUTLENTRETERC",
                "TABLE" => "INTEGRACAOFILI",
                "PARENT" => "16.3.2"
            ),
            (object) array(
                "ID"     => "17",
                "NAME"   => "Log de Controle de Acesso",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "18",
                "NAME"   => "Cadastro de Tipo de Loja",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "18.1",
                "NAME"   => "Tipo de Loja",
                "PATH"   => "Cadastro de Tipo de Loja",
                "PARENT" => "18"
            ),
            (object) array(
                "ID"     => "18.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Tipo de Loja->Tipo de Loja",
                "COLLUMN"=> "CDTIPOLOJA",
                "TABLE"  => "TIPOLOJA",
                "PARENT" => "18.1"
            ),
            (object) array(
                "ID"     => "18.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Tipo de Loja->Tipo de Loja",
                "COLLUMN"=> "NMTIPOLOJA",
                "TABLE"  => "TIPOLOJA",
                "PARENT" => "18.1"
            ),
            (object) array(
                "ID"     => "18.2",
                "NAME"   => "Lojas do Tipo",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "PARENT" => "18"
            ),
            (object) array(
                "ID"     => "18.2.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "FILILOJATIPO",
                "PARENT" => "18.2"
            ),
            (object) array(
                "ID"     => "18.2.2",
                "NAME"   => "Unidade",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "FILILOJATIPO",
                "PARENT" => "18.2"
            ),
            (object) array(
                "ID"     => "18.2.3",
                "NAME"   => "Código da Loja",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "COLLUMN"=> "CDLOJA",
                "TABLE"  => "FILILOJATIPO",
                "PARENT" => "18.2"
            ),
            (object) array(
                "ID"     => "18.2.4",
                "NAME"   => "Loja",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "COLLUMN"=> "NMLOJA",
                "TABLE"  => "FILILOJATIPO",
                "PARENT" => "18.2"
            ),
            (object) array(
                "ID"     => "18.2.5",
                "NAME"   => "Código de Tipo",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "COLLUMN"=> "CDTIPOLOJA",
                "TABLE"  => "FILILOJATIPO",
                "PARENT" => "18.2"
            ),
            (object) array(
                "ID"     => "18.2.6",
                "NAME"   => "Tipo",
                "PATH"   => "Cadastro de Tipo de Loja->Lojas do Tipo",
                "COLLUMN"=> "NMTIPOLOJA",
                "TABLE"  => "FILILOJATIPO",
                "PARENT" => "18.2"
            ),
            (object) array(
                "ID"     => "19",
                "NAME"   => "Consolidação Automática",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "19.1",
                "NAME"   => "Loja",
                "PATH"   => "Consolidação Automática",
                "PARENT" => "19"
            ),
            (object) array(
                "ID"     => "19.1.1",
                "NAME"   => "Loja",
                "PATH"   => "Consolidação Automática->Loja",
                "COLLUMN"=> "CDLOJA",
                "TABLE"  => "LOJA",
                "PARENT" => "19.1"
            ),
            (object) array(
                "ID"     => "19.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Consolidação Automática->Loja",
                "COLLUMN"=> "NMLOJA",
                "TABLE"  => "LOJA",
                "PARENT" => "19.1"
            ),
            (object) array(
                "ID"     => "19.2",
                "NAME"   => "Consolidação Automática",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "PARENT" => "19"
            ),
            (object) array(
                "ID"     => "19.2.1",
                "NAME"   => "Data Inicial Apuração",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "COLLUMN"=> "DTINICONSVENAUT",
                "TABLE"  => "PARAMCONSVENAUT",
                "PARENT" => "19.2"
            ),
            (object) array(
                "ID"     => "19.2.2",
                "NAME"   => "Horário",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "COLLUMN"=> "HRCONSVENAUT",
                "TABLE"  => "PARAMCONSVENAUT",
                "PARENT" => "19.2"
            ),
            (object) array(
                "ID"     => "19.2.3",
                "NAME"   => "Frequência",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "COLLUMN"=> "IDFREQCONSVEN",
                "TABLE"  => "PARAMCONSVENAUT",
                "PARENT" => "19.2"
            ),
            (object) array(
                "ID"     => "19.2.4",
                "NAME"   => "Diretório Arquivos PHP",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "COLLUMN"=> "DSDIRARQPHP",
                "TABLE"  => "PARAMCONSVENAUT",
                "PARENT" => "19.2"
            ),
            (object) array(
                "ID"     => "19.2.5",
                "NAME"   => "Diretório Instalação PHP.exe",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "COLLUMN"=> "DSDIRINSTALAPHP",
                "TABLE"  => "PARAMCONSVENAUT",
                "PARENT" => "19.2"
            ),
            (object) array(
                "ID"     => "19.2.6",
                "NAME"   => "Status Conciliação",
                "PATH"   => "Consolidação Automática->Consolidação Automática",
                "COLLUMN"=> "DSSTATUSULTCONS",
                "TABLE"  => "PARAMCONSVENAUT",
                "PARENT" => "19.2"
            ),
            (object) array(
                "ID"     => "20",
                "NAME"   => "Meta",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "20.1",
                "NAME"   => "Unidade",
                "PATH"   => "Meta->Unidade",
                "PARENT" => "20"
            ),
            (object) array(
                "ID"     => "20.1.1",
                "NAME"   => "Código",
                "PATH"   => "Meta->Unidade->Código",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "PARAMMETA",
                "PARENT" => "20.1"
            ),
            (object) array(
                "ID"     => "20.1.2",
                "NAME"   => "Unidade",
                "PATH"   => "Meta->Unidade->Unidade",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "PARAMMETA",
                "PARENT" => "20.1"
            ),
            (object) array(
                "ID"     => "20.2",
                "NAME"   => "Meta por Mês",
                "PATH"   => "Meta->Meta por Mês",
                "PARENT" => "20"
            ),
            (object) array(
                "ID"     => "20.3",
                "NAME"   => "Meta por Mês/Data",
                "PATH"   => "Meta->Meta por Mês",
                "PARENT" => "20"
            ),
            (object) array(
                "ID"     => "20.4",
                "NAME"   => "Meta Período Especial",
                "PATH"   => "Meta->Meta por Mês",
                "PARENT" => "20"
            ),
            (object) array(
                "ID"     => "21",
                "NAME"   => "Cadastro de Fabricante",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "21.1",
                "NAME"   => "Cadastro de Fabricante",
                "PATH"   => "Cadastro de Fabricante->Cadastro de Fabricante",
                "PARENT" => "21"
            ),
            (object) array(
                "ID"     => "21.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Fabricante->Cadastro de Fabricante->Código",
                "COLLUMN"=> "CDMARCA",
                "TABLE"  => "MARCAFABRIC",
                "PARENT" => "21.1"
            ),
            (object) array(
                "ID"     => "21.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Fabricante->Cadastro de Fabricante->Nome",
                "COLLUMN"=> "NMMARCA",
                "TABLE"  => "MARCAFABRIC",
                "PARENT" => "21.1"
            ),
            (object) array(
                "ID"     => "21.2",
                "NAME"   => "Marcas",
                "PATH"   => "Cadastro de Fabricante->Marcas",
                "PARENT" => "21"
            ),
            (object) array(
                "ID"     => "22",
                "NAME"   => "Tipo de Sangria",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "22.1",
                "NAME"   => "Código",
                "PATH"   => "Tipo de Sangria->Tipo de Sangria",
                "COLLUMN"=> "CDTPSANGRIA",
                "TABLE"  => "TIPOSANGRIA",
                "PARENT" => "22"
            ),
            (object) array(
                "ID"     => "22.2",
                "NAME"   => "Nome",
                "PATH"   => "Tipo de Sangria->Tipo de Sangria",
                "COLLUMN"=> "NMTPSANGRIA",
                "TABLE"  => "TIPOSANGRIA",
                "PARENT" => "22"
            ),
            (object) array(
                "ID"     => "22.3",
                "NAME"   => "Tipo de Sangria",
                "PATH"   => "Tipo de Sangria->Tipo de Sangria",
                "COLLUMN"=> "TPSANGRIA",
                "TABLE"  => "TIPOSANGRIA",
                "PARENT" => "22"
            ),
            (object) array(
                "ID"     => "23",
                "NAME"   => "Cadastro de ECF",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "23.1",
                "NAME"   => "ECF",
                "PATH"   => "Cadastro de ECF->ECF",
                "PARENT" => "23"
            ),
            (object) array(
                "ID"     => "23.1.1",
                "NAME"   => "Caixa",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "CDCAIXA",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NMCAIXA",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.3",
                "NAME"   => "N° ECF",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NRECF",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.4",
                "NAME"   => "N° Série",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NRSERIE",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.5",
                "NAME"   => "Fabricante",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NMFABRIC",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.6",
                "NAME"   => "Modelo",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NRMODELO",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.7",
                "NAME"   => "N° Ativo",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NRATIVO",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.8",
                "NAME"   => "N° Lacre",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NRLACRE",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.9",
                "NAME"   => "Tipo ECF",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "CDTIPOECF",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.10",
                "NAME"   => "N° Aplicativo",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "NRAPLICATIVO",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "23.1.11",
                "NAME"   => "Dt. Validade",
                "PATH"   => "Cadastro de ECF->ECF",
                "COLLUMN"=> "DTVALIDADE",
                "TABLE"  => "CADASTROECF",
                "PARENT" => "23.1"
            ),
            (object) array(
                "ID"     => "24",
                "NAME"   => "Grupo de operadores",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "24.1",
                "NAME"   => "Grupo de operadores",
                "PATH"   => NULL,
                "PARENT" => "24"
            ),
            (object) array(
                "ID"     => "24.1.1",
                "NAME"   => "Grupo de operadores",
                "PATH"   => "Grupo de operadores",
                "PARENT" => "24.1"
            ),
            (object) array(
                "ID"     => "24.1.1.1",
                "NAME"   => "Código",
                "PATH"   => "Grupo de operadores->Grupo de operadores",
                "COLLUMN"=> "CDGRUPOPER",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "24.1.1"
            ),
            (object) array(
                "ID"     => "24.1.1.2",
                "NAME"   => "Descrição",
                "PATH"   => "Grupo de operadores->Grupo de operadores",
                "COLLUMN"=> "DSGRUPOPER",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "24.1.1"
            ),
            (object) array(
                "ID"     => "24.1.1.3",
                "NAME"   => "Utiliza Controle Senha",
                "PATH"   => "Grupo de operadores->Grupo de operadores",
                "COLLUMN"=> "IDUTCTRSENOP",
                "TABLE"  => "GRUPOPER",
                "PARENT" => "24.1.1"
            ),
            (object) array(
                "ID"     => "24.1.2",
                "NAME"   => "Operadores do Grupo",
                "PATH"   => "Grupo de operadores",
                "PARENT" => "24.1"
            ),
            (object) array(
                "ID"     => "24.1.2.1",
                "NAME"   => "Código",
                "PATH"   => "Grupo de operadores->Operadores do Grupo",
                "COLLUMN"=> "CDOPERADOR",
                "TABLE"  => "OPERGRUPOP",
                "PARENT" => "24.1.2"
            ),
            (object) array(
                "ID"     => "24.1.2.2",
                "NAME"   => "Nome",
                "PATH"   => "Grupo de operadores->Operadores do Grupo",
                "COLLUMN"=> "NMOPERADOR",
                "TABLE"  => "OPERGRUPOP",
                "PARENT" => "24.1.2"
            ),
            (object) array(
                "ID"     => "24.2",
                "NAME"   => "Permissões por Grupo de operadores",
                "PATH"   => NULL,
                "PARENT" => "24"
            ),
            (object) array(
                "ID"     => "24.2.1",
                "NAME"   => "Código",
                "PATH"   => "Grupo de operadores->Permissões por Grupo de operadores",
                "COLLUMN"=> "CDGRUPOPER",
                "TABLE"  => "AUTGRUPOP",
                "PARENT" => "24.2"
            ),
            (object) array(
                "ID"     => "24.2.2",
                "NAME"   => "Descrição",
                "PATH"   => "Grupo de operadores->Permissões por Grupo de operadores",
                "COLLUMN"=> "DSGRUPOPER",
                "TABLE"  => "AUTGRUPOP",
                "PARENT" => "24.2"
            ),
            (object) array(
                "ID"     => "24.2.3",
                "NAME"   => "Tipo de Autorização",
                "PATH"   => "Grupo de operadores->Permissões por Grupo de operadores",
                "COLLUMN"=> "DESCAUTGRUPOP",
                "TABLE"  => "AUTGRUPOP",
                "PARENT" => "24.2"
            ),
            (object) array(
                "ID"     => "25",
                "NAME"   => "Configuração Menu de Produtos Combinados",
                "PATH"   => null,
                "PARENT" => null
            ),
            (object) array(
                "ID"     => "25.1",
                "NAME"   => "Configuração Menu de Produtos Combinados",
                "PATH"   => "Configuração Menu de Produtos Combinados",
                "PARENT" => "25"
            ),
            (object) array(
                "ID"     => "25.1.1",
                "NAME"   => "Código",
                "PATH"   => "Configuração Menu de Produtos Combinados->Configuração Menu de Produtos Combinados->Código",
                "COLLUMN"=> "NRCONFTELA",
                "TABLE"  => "CONFTELA",
                "PARENT" => "25.1"
            ),
            (object) array(
                "ID"     => "25.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Configuração Menu de Produtos Combinados->Configuração Menu de Produtos Combinados->Nome",
                "COLLUMN"=> "NMCONFTELA",
                "TABLE"  => "CONFTELA",
                "PARENT" => "25.1"
            ),
            (object) array(
                "ID"     => "25.2",
                "NAME"   => "Grupo de de Produtos Combinados",
                "PATH"   => "Configuração Menu de Produtos Combinados",
                "PARENT" => "25"
            ),
            (object) array(
                "ID"     => "25.2.1",
                "NAME"   => "Código",
                "PATH"   => "Configuração Menu de Produtos Combinados->Grupo de de Produtos Combinados",
                "COLLUMN"=> "NRBUTTON",
                "TABLE"  => "ITMENUCONFTE",
                "PARENT" => "25.2"
            ),
            (object) array(
                "ID"     => "25.2.2",
                "NAME"   => "Nome",
                "PATH"   => "Configuração Menu de Produtos Combinados->Grupo de de Produtos Combinados",
                "COLLUMN"=> "DSBUTTON",
                "TABLE"  => "ITMENUCONFTE",
                "PARENT" => "25.2"
            ),
            (object) array(
                "ID"     => "25.2.3",
                "NAME"   => "Limite de Seleção",
                "PATH"   => "Configuração Menu de Produtos Combinados->Grupo de de Produtos Combinados",
                "COLLUMN"=> "NRLIMPRODCOM",
                "TABLE"  => "ITMENUCONFTE",
                "PARENT" => "25.2"
            ),
            (object) array(
                "ID"     => "25.2.4",
                "NAME"   => "Cor do Botão",
                "PATH"   => "Configuração Menu de Produtos Combinados->Grupo de de Produtos Combinados",
                "COLLUMN"=> "NRCOLORBACK",
                "TABLE"  => "ITMENUCONFTE",
                "PARENT" => "25.2"
            ),
            (object) array(
                "ID"     => "26",
                "NAME"   => "Tabela de Preço",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "26.1",
                "NAME"   => "Vigência",
                "PATH"   => NULL,
                "PARENT" => "26"
            ),
            (object) array(
                "ID"     => "26.1.1",
                "NAME"   => "Código",
                "PATH"   => "Tabela de Preço->Vigência",
                "COLLUMN"=> "CDTABEPREC",
                "TABLE"  => "TABEVEND",
                "PARENT" => "26.1"
            ),
            (object) array(
                "ID"     => "26.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Tabela de Preço->Vigência",
                "COLLUMN"=> "NMTABEPREC",
                "TABLE"  => "TABEVEND",
                "PARENT" => "26.1"
            ),
            (object) array(
                "ID"     => "26.1.3",
                "NAME"   => "Início Vigência",
                "PATH"   => "Tabela de Preço->Vigência",
                "COLLUMN"=> "DTINIVGPREC",
                "TABLE"  => "TABEVEND",
                "PARENT" => "26.1"
            ),
            (object) array(
                "ID"     => "26.1.4",
                "NAME"   => "Fim Vigência",
                "PATH"   => "Tabela de Preço->Vigência",
                "COLLUMN"=> "DTFINVGPREC",
                "TABLE"  => "TABEVEND",
                "PARENT" => "26.1"
            ),
            (object) array(
                "ID"     => "26.1.5",
                "NAME"   => "Status",
                "PATH"   => "Tabela de Preço->Vigência",
                "COLLUMN"=> "IDSITVGPREC",
                "TABLE"  => "TABEVEND",
                "PARENT" => "26.1"
            ),
            (object) array(
                "ID"     => "26.1.6",
                "NAME"   => "Situação",
                "PATH"   => "Tabela de Preço->Vigência",
                "COLLUMN"=> "STATUS_VIGENCIA",
                "TABLE"  => "TABEVEND",
                "PARENT" => "26.1"
            ),
            (object) array(
                "ID"     => "26.2",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "26"
            ),
            (object) array(
                "ID"     => "26.2.1",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "26.2"
            ),
            (object) array(
                "ID"     => "26.2.1.1",
                "NAME"   => "Código",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.3",
                "NAME"   => "Preço",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "VRPRECITEM",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.4",
                "NAME"   => "Preço Sugerido",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "VRPRESUGITEM",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.5",
                "NAME"   => "Preço Subsidiado",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "VRPRECITEMCL",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.6",
                "NAME"   => "Preço Calculado",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "VRCUSTITEM",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.7",
                "NAME"   => "Hora Inicial",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "HRINIVENPROD",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.1.8",
                "NAME"   => "Hora Final",
                "PATH"   => "Tabela de Preço->Produtos->Produtos",
                "COLLUMN"=> "HRFIMVENPROD",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "26.2.1"
            ),
            (object) array(
                "ID"     => "26.2.2",
                "NAME"   => "Preço Diferenciado",
                "PATH"   => "Tabela de Preço->Produtos->Preço Diferenciado",
                "PARENT" => "26.2"
            ),
            (object) array(
                "ID"     => "26.2.3",
                "NAME"   => "Composição",
                "PATH"   => "Tabela de Preço->Produtos->Composição",
                "PARENT" => "26.2"
            ),
            (object) array(
                "ID"     => "27",
                "NAME"   => "Tabela de Preço Geral",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "27.1",
                "NAME"   => "Vigência",
                "PATH"   => NULL,
                "PARENT" => "27"
            ),
            (object) array(
                "ID"     => "27.1.1",
                "NAME"   => "Código",
                "PATH"   => "Tabela de Preço Geral->Vigência",
                "COLLUMN"=> "CDTABEPREC",
                "TABLE"  => "ITEMPRECODIAGER",
                "PARENT" => "27.1"
            ),
            (object) array(
                "ID"     => "27.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Tabela de Preço Geral ->Vigência",
                "COLLUMN"=> "NMTABEPREC",
                "TABLE"  => "ITEMPRECODIAGER",
                "PARENT" => "27.1"
            ),
            (object) array(
                "ID"     => "27.1.3",
                "NAME"   => "Início Vigência",
                "PATH"   => "Tabela de Preço Geral->Vigência",
                "COLLUMN"=> "DTINIVGPREC",
                "TABLE"  => "ITEMPRECODIAGER",
                "PARENT" => "27.1"
            ),
            (object) array(
                "ID"     => "27.1.4",
                "NAME"   => "Fim Vigência",
                "PATH"   => "Tabela de Preço Geral->Vigência",
                "COLLUMN"=> "DTFINVGPREC",
                "TABLE"  => "ITEMPRECODIAGER",
                "PARENT" => "27.1"
            ),
            (object) array(
                "ID"     => "27.1.5",
                "NAME"   => "Status",
                "PATH"   => "Tabela de Preço Geral->Vigência",
                "COLLUMN"=> "IDSITVGPREC",
                "TABLE"  => "ITEMPRECODIAGER",
                "PARENT" => "27.1"
            ),
            (object) array(
                "ID"     => "27.1.6",
                "NAME"   => "Situação",
                "PATH"   => "Tabela de Preço Geral->Vigência",
                "COLLUMN"=> "STATUS_VIGENCIA",
                "TABLE"  => "ITEMPRECODIAGER",
                "PARENT" => "27.1"
            ),
            (object) array(
                "ID"     => "27.2",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "27"
            ),
            (object) array(
                "ID"     => "27.2.1",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "27.2"
            ),
            (object) array(
                "ID"     => "27.2.1.1",
                "NAME"   => "Código",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.3",
                "NAME"   => "Preço",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "VRPRECITEM",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.4",
                "NAME"   => "Preço Sugerido",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "VRPRESUGITEM",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.5",
                "NAME"   => "Preço Subsidiado",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "VRPRECITEMCL",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.6",
                "NAME"   => "Preço Calculado",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "VRCUSTITEM",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.7",
                "NAME"   => "Hora Inicial",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "HRINIVENPROD",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.1.8",
                "NAME"   => "Hora Final",
                "PATH"   => "Tabela de Preço Geral->Produtos->Produtos",
                "COLLUMN"=> "HRFIMVENPROD",
                "TABLE"  => "ITEMPRECO",
                "PARENT" => "27.2.1"
            ),
            (object) array(
                "ID"     => "27.2.2",
                "NAME"   => "Preço Diferenciado",
                "PATH"   => "Tabela de Preço Geral->Produtos->Preço Diferenciado",
                "PARENT" => "27.2"
            ),
            (object) array(
                "ID"     => "27.2.3",
                "NAME"   => "Composição",
                "PATH"   => "Tabela de Preço Geral->Produtos->Composição",
                "PARENT" => "27.2"
            ),
            (object) array(
                "ID"     => "27.3",
                "NAME"   => "Unidades",
                "PATH"   => NULL,
                "PARENT" => "27"
            ),
            (object) array(
                "ID"     => "27.3.1",
                "NAME"   => "Unidade",
                "PATH"   => "Tabela de Preço Geral->Produtos->Unidades",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "FILIAL",
                "PARENT" => "27.3"
            ),
            (object) array(
                "ID"     => "27.3.2",
                "NAME"   => "Nome",
                "PATH"   => "Tabela de Preço Geral->Produtos->Unidades",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "FILIAL",
                "PARENT" => "27.3"
            ),
            (object) array(
                "ID"     => "28",
                "NAME"   => "Cadastro de Observação",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "28.1",
                "NAME"   => "Cadastro de Observação",
                "PATH"   => NULL,
                "PARENT" => "28"
            ),
            (object) array(
                "ID"     => "28.1.1",
                "NAME"   => "Cadastro de Observação",
                "PATH"   => "Cadastro de Observações",
                "COLLUMN"=> "CDGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "28.1"
            ),
            (object) array(
                "ID"     => "28.1.2",
                "NAME"   => "Cadastro de Observação",
                "PATH"   => "Cadastro de Observações",
                "COLLUMN"=> "DSGRPOCOR",
                "TABLE"  => "GRUPOCOR",
                "PARENT" => "28.1"
            ),
            (object) array(
                "ID"     => "28.2",
                "NAME"   => "Observações",
                "PATH"   => NULL,
                "PARENT" => "28"
            ),
            (object) array(
                "ID"     => "28.2.1",
                "NAME"   => "Observações",
                "PATH"   => "Cadastro de Observações->Observações",
                "PARENT" => "28.2"
            ),
            (object) array(
                "ID"     => "28.2.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "CDOCORR",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "DSOCORR",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.3",
                "NAME"   => "Código Externo de Observação",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "CDEXTOBSPROD",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.4",
                "NAME"   => "Tipo de Obs.",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "IDCONTROLAOBS",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.5",
                "NAME"   => "Apelido da Observação no aplicativo do consumidor",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "DSAPELIDOOBS",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.6",
                "NAME"   => "Exibe Observação no aplicativo do consumidor",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "IDEXIOBSAPPCONS",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.7",
                "NAME"   => "Nome da Observação (Inglês)",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "DSOCORRINGLES",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.8",
                "NAME"   => "Nome da Observação (Espanhol)",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "DSOCORRESPANH",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.9",
                "NAME"   => "Produto",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "CDPRODUTO",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.10",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.11",
                "NAME"   => "Destaca no KDS",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "IDSINAL",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.1.12",
                "NAME"   => "Ordem (Odhen Interface)",
                "PATH"   => "Cadastro de Observações->Observações",
                "COLLUMN"=> "NRORDOBSGRPOCOR",
                "TABLE"  => "OCORRENCIA",
                "PARENT" => "28.2.1"
            ),
            (object) array(
                "ID"     => "28.2.2",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "28.2"
            ),
            (object) array(
                "ID"     => "28.2.2.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Observações->Produtos",
                "COLLUMN"=> "CDARVPROD",
                "TABLE"  => "PRODOCORRE",
                "PARENT" => "28.2.2"
            ),
            (object) array(
                "ID"     => "28.2.2.2",
                "NAME"   => "Produtos",
                "PATH"   => "Cadastro de Observações->Produtos",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODOCORRE",
                "PARENT" => "28.2.2"
            ),
            (object) array(
                "ID"     => "28.3",
                "NAME"   => "Observação por produto",
                "PATH"   => NULL,
                "PARENT" => "28"
            ),
            (object) array(
                "ID"     => "28.3.1",
                "NAME"   => "Observação por produto",
                "PATH"   => NULL,
                "PARENT" => "28.3"
            ),
            (object) array(
                "ID"     => "28.3.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Observações->Observação por produto",
                "COLLUMN"=> "CDPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "28.3.1"
            ),
            (object) array(
                "ID"     => "28.3.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Observações->Observação por produto",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODUTO",
                "PARENT" => "28.3.1"
            ),
            (object) array(
                "ID"     => "28.3.1.3",
                "NAME"   => "Quantidade Mínima de Observações",
                "PATH"   => "Cadastro de Observações->Observação por produto",
                "COLLUMN"=> "NRQTDMINOBS",
                "TABLE"  => "PRODUTO",
                "PARENT" => "28.3.1"
            ),
            (object) array(
                "ID"     => "28.3.2",
                "NAME"   => "Observações",
                "PATH"   => NULL,
                "PARENT" => "28.3"
            ),
            (object) array(
                "ID"     => "28.3.2.1",
                "NAME"   => "Observações do Produto",
                "PATH"   => "Cadastro de Observações->Observações",
                "PARENT" => "28.3.2"
            ),
            (object) array(
                "ID"     => "28.4",
                "NAME"   => "Cadastro de Observações Obrigatórias",
                "PATH"   => "Cadastro de Observações",
                "PARENT" => "28"
            ),
            (object) array(
                "ID"     => "29",
                "NAME"   => "Cadastro de Grupo Promocional",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "29.1",
                "NAME"   => "Grupo Promocional",
                "PATH"   => NULL,
                "PARENT" => "29"
            ),
            (object) array(
                "ID"     => "29.1.1",
                "NAME"   => "Código",
                "PATH"   => "Grupo Promocional",
                "COLLUMN"=> "CDGRUPROMOC",
                "TABLE"  => "GRUPROMOC",
                "PARENT" => "29.1"
            ),
            (object) array(
                "ID"     => "29.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Grupo Promocional",
                "COLLUMN"=> "NMGRUPROMOC",
                "TABLE"  => "GRUPROMOC",
                "PARENT" => "29.1"
            ),
            (object) array(
                "ID"     => "29.1.3",
                "NAME"   => "Modo de Exibição TAA",
                "PATH"   => "Grupo Promocional",
                "COLLUMN"=> "NMMODOEXIBETAA",
                "TABLE"  => "GRUPROMOC",
                "PARENT" => "29.1"
            ),
            (object) array(
                "ID"     => "29.1.4",
                "NAME"   => "Descrição do grupo TAA",
                "PATH"   => "Grupo Promocional",
                "COLLUMN"=> "DSGROUPTAA",
                "TABLE"  => "GRUPROMOC",
                "PARENT" => "29.1"
            ),
            (object) array(
                "ID"     => "29.2",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "29"
            ),
            (object) array(
                "ID"     => "29.2.1",
                "NAME"   => "Código",
                "PATH"   => "Produtos",
                "COLLUMN"=> "CDPRODUTO",
                "TABLE"  => "PRODGRUPROMOC",
                "PARENT" => "29.2"
            ),
            (object) array(
                "ID"     => "29.2.2",
                "NAME"   => "Nome",
                "PATH"   => "Produtos",
                "COLLUMN"=> "NMPRODUTO",
                "TABLE"  => "PRODGRUPROMOC",
                "PARENT" => "29.2"
            ),
            (object) array(
                "ID"     => "30",
                "NAME"   => "Bloqueio de Produto",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "31",
                "NAME"   => "Campanha Promocional",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "31.1",
                "NAME"   => "Campanha Promocional",
                "PATH"   => "Campanha Promocional",
                "PARENT" => "31"
            ),
            (object) array(
                "ID"     => "31.2",
                "NAME"   => "Combinações de Produtos",
                "PATH"   => "Campanha Promocional",
                "PARENT" => "31"
            ),
            (object) array(
                "ID"     => "31.3",
                "NAME"   => "Unidades Participantes",
                "PATH"   => "Campanha Promocional",
                "PARENT" => "31"
            ),
            (object) array(
                "ID"     => "32",
                "NAME"   => "Família de Produtos",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "32.1",
                "NAME"   => "Família de Produtos",
                "PATH"   => NULL,
                "PARENT" => "32"
            ),
            (object) array(
                "ID"     => "32.1.1",
                "NAME"   => "Código",
                "PATH"   => "Família de Produtos",
                "COLLUMN"=> "CDFAMILISALD",
                "TABLE"  => "FAMILIASALDO",
                "PARENT" => "32.1"
            ),
            (object) array(
                "ID"     => "32.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Família de Produtos",
                "COLLUMN"=> "NMFAMILISALD",
                "TABLE"  => "FAMILIASALDO",
                "PARENT" => "32.1"
            ),
            (object) array(
                "ID"     => "32.2",
                "NAME"   => "Família de Produtos por Unidade",
                "PATH"   => NULL,
                "PARENT" => "32"
            ),
            (object) array(
                "ID"     => "32.2.1",
                "NAME"   => "Família de Produtos por Unidade",
                "PATH"   => NULL,
                "PARENT" => "32.2"
            ),
            (object) array(
                "ID"     => "32.2.1.1",
                "NAME"   => "Família",
                "PATH"   => "Família de Produtos->Família de Produtos por Unidade",
                "COLLUMN"=> "LABELFAMILIA",
                "TABLE"  => "FAMSALDOFILI",
                "PARENT" => "32.2.1"
            ),
            (object) array(
                "ID"     => "32.2.1.2",
                "NAME"   => "Ordem",
                "PATH"   => "Família de Produtos->Família de Produtos por Unidade",
                "COLLUMN"=> "NRORDAPRSALD",
                "TABLE"  => "FAMSALDOFILI",
                "PARENT" => "32.2.1"
            ),
            (object) array(
                "ID"     => "32.2.1.3",
                "NAME"   => "Saldo Negativo",
                "PATH"   => "Família de Produtos->Família de Produtos por Unidade",
                "COLLUMN"=> "IDSALDNEGFAM",
                "TABLE"  => "FAMSALDOFILI",
                "PARENT" => "32.2.1"
            ),
            (object) array(
                "ID"     => "32.2.1.4",
                "NAME"   => "Permite Carga de Crédito",
                "PATH"   => "Família de Produtos->Família de Produtos por Unidade",
                "COLLUMN"=> "IDPERMCARGACRED",
                "TABLE"  => "FAMSALDOFILI",
                "PARENT" => "32.2.1"
            ),
            (object) array(
                "ID"     => "32.2.1.5",
                "NAME"   => "Valor Cons. Diário",
                "PATH"   => "Família de Produtos->Família de Produtos por Unidade",
                "COLLUMN"=> "VRCONSDIAFAM",
                "TABLE"  => "FAMSALDOFILI",
                "PARENT" => "32.2.1"
            ),
            (object) array(
                "ID"     => "32.2.2",
                "NAME"   => "Produtos",
                "PATH"   => NULL,
                "PARENT" => "32.2"
            ),
            (object) array(
                "ID"     => "33",
                "NAME"   => "Desconto por Quantidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "34",
                "NAME"   => "Cadastro de Cupons Promocional",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "34.1",
                "NAME"   => "Cupons Promocional",
                "PATH"   => NULL,
                "PARENT" => "34"
            ),
            (object) array(
                "ID"     => "34.1.1",
                "NAME"   => "Cupom",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "CDCUPOMDESCFOS",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.2",
                "NAME"   => "Descrição",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "DSCUPOMDESCFOS",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.3",
                "NAME"   => "Tipo de Desconto",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "IDTIPODESC",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.4",
                "NAME"   => "Valor do Cupom",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "VRDESCCUPOM",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.5",
                "NAME"   => "Cupom de uso único",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "IDUSOUNICO",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.6",
                "NAME"   => "Início de Vigência",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "DTINIVIGENCIA",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.7",
                "NAME"   => "Fim  de Vigência",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "DTFIMVIGENCIA",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.1.8",
                "NAME"   => "Status",
                "PATH"   => "Cupom Promocional",
                "COLLUMN"=> "IDATIVO",
                "TABLE"  => "CUPOMDESCFOS",
                "PARENT" => "34.1"
            ),
            (object) array(
                "ID"     => "34.2",
                "NAME"   => "Unidades Participantes",
                "PATH"   => NULL,
                "PARENT" => "34"
            ),
            (object) array(
                "ID"     => "34.3",
                "NAME"   => "Produtos Participates",
                "PATH"   => NULL,
                "PARENT" => "34"
            ),
            (object) array(
                "ID"     => "35",
                "NAME"   => "Campanha Compre e Ganhe",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "35.1",
                "NAME"   => "Campanha",
                "PATH"   => NULL,
                "PARENT" => "35"
            ),
            (object) array(
                "ID"     => "35.1.1",
                "NAME"   => "Código",
                "PATH"   => "Campanha",
                "COLLUMN"=> "CDCAMPCOMPGANHE",
                "TABLE"  => "VGCAMPCOMPGANHE",
                "PARENT" => "35.1"
            ),
            (object) array(
                "ID"     => "35.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Campanha",
                "COLLUMN"=> "DSCAMPCOMPGANHE",
                "TABLE"  => "VGCAMPCOMPGANHE",
                "PARENT" => "35.1"
            ),
            (object) array(
                "ID"     => "35.1.3",
                "NAME"   => "Compre e Ganhe(UN)",
                "PATH"   => "Campanha",
                "COLLUMN"=> "QTCOMPGANHE",
                "TABLE"  => "VGCAMPCOMPGANHE",
                "PARENT" => "35.1"
            ),
            (object) array(
                "ID"     => "35.1.4",
                "NAME"   => "Situação",
                "PATH"   => "Campanha",
                "COLLUMN"=> "IDATIVO",
                "TABLE"  => "VGCAMPCOMPGANHE",
                "PARENT" => "35.1"
            ),
            (object) array(
                "ID"     => "35.1.5",
                "NAME"   => "Início Vigência",
                "PATH"   => "Campanha",
                "COLLUMN"=> "DTINIVGCAMPCG",
                "TABLE"  => "VGCAMPCOMPGANHE",
                "PARENT" => "35.1"
            ),
            (object) array(
                "ID"     => "35.1.6",
                "NAME"   => "Fim Vigência",
                "PATH"   => "Campanha",
                "COLLUMN"=> "DTFINVGCAMPCG",
                "TABLE"  => "VGCAMPCOMPGANHE",
                "PARENT" => "35.1"
            ),
            (object) array(
                "ID"     => "35.2",
                "NAME"   => "Unidades Participantes",
                "PATH"   => "Campanha Compre e Ganhe",
                "PARENT" => "35"
            ),
            (object) array(
                "ID"     => "35.3",
                "NAME"   => "Produtos (Compre)",
                "PATH"   => "Campanha Compre e Ganhe",
                "PARENT" => "35"
            ),
            (object) array(
                "ID"     => "35.4",
                "NAME"   => "Brindes (Ganhe)",
                "PATH"   => "Campanha Compre e Ganhe",
                "PARENT" => "35"
            ),
            (object) array(
                "ID"     => "36",
                "NAME"   => "Tipo de Consumidor por Cliente",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "36.1",
                "NAME"   => "Cliente",
                "PATH"   => NULL,
                "PARENT" => "36"
            ),
            (object) array(
                "ID"     => "36.1.1",
                "NAME"   => "Inscrição",
                "PATH"   => "Tipo de Consumidor por Cliente->Cliente",
                "COLLUMN"=> "NRINSJURCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "36.1"
            ),
            (object) array(
                "ID"     => "36.1.2",
                "NAME"   => "Razão Social",
                "PATH"   => "Tipo de Consumidor por Cliente->Cliente",
                "COLLUMN"=> "NMRAZSOCCLIE",
                "TABLE"  => "CLIENTE",
                "PARENT" => "36.1"
            ),
            (object) array(
                "ID"     => "36.2",
                "NAME"   => "Tipos de Consumidores",
                "PATH"   => NULL,
                "PARENT" => "36"
            ),
            (object) array(
                "ID"     => "37",
                "NAME"   => "Restrição Alimentar de Consumidor",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "37.1",
                "NAME"   => "Restrição",
                "PATH"   => NULL,
                "PARENT" => "37"
            ),
            (object) array(
                "ID"     => "37.2",
                "NAME"   => "Produto Restrição",
                "PATH"   => NULL,
                "PARENT" => "37"
            ),
            (object) array(
                "ID"     => "38",
                "NAME"   => "Código Externo Cliente",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "39",
                "NAME"   => "Tipo de Consumidor",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "40",
                "NAME"   => "Centro de Custo por Cliente",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "41",
                "NAME"   => "Cadastro de Vendedor (Garçom)",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "41.1",
                "NAME"   => "Vendedor",
                "PATH"   => NULL,
                "PARENT" => "41"
            ),
            (object) array(
                "ID"     => "41.1.1",
                "NAME"   => "Endereço",
                "PATH"   => "Cadastro de Vendedor (Garçom)->Vendedor",
                "PARENT" => "41.1"
            ),
            (object) array(
                "ID"     => "41.1.2",
                "NAME"   => "Telefones",
                "PATH"   => "Cadastro de Vendedor (Garçom)->Vendedor",
                "PARENT" => "41.1"
            ),
            (object) array(
                "ID"     => "41.1.3",
                "NAME"   => "Cobra Taxa de Serviço",
                "PATH"   => "Cadastro de Vendedor (Garçom)->Vendedor",
                "PARENT" => "41.1"
            ),
            (object) array(
                "ID"     => "41.1.4",
                "NAME"   => "Entregador",
                "PATH"   => "Cadastro de Vendedor (Garçom)->Vendedor",
                "PARENT" => "41.1"
            ),
            (object) array(
                "ID"     => "42",
                "NAME"   => "Ambiente/Mesa",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "42.1",
                "NAME"   => "Ambiente",
                "PATH"   => NULL,
                "PARENT" => "42"
            ),
            (object) array(
                "ID"     => "42.1.1",
                "NAME"   => "Código",
                "PATH"   => "Ambiente/Mesa->Ambiente",
                "COLLUMN"=> "CDSALA",
                "TABLE"  => "SALA",
                "PARENT" => "42.1"
            ),
            (object) array(
                "ID"     => "42.1.2",
                "NAME"   => "Sigla",
                "PATH"   => "Ambiente/Mesa->Ambiente",
                "COLLUMN"=> "SGSALA",
                "TABLE"  => "SALA",
                "PARENT" => "42.1"
            ),
            (object) array(
                "ID"     => "42.1.3",
                "NAME"   => "Descrição",
                "PATH"   => "Ambiente/Mesa->Ambiente",
                "COLLUMN"=> "NMSALA",
                "TABLE"  => "SALA",
                "PARENT" => "42.1"
            ),
            (object) array(
                "ID"     => "42.1.4",
                "NAME"   => "Nr. de Mesas",
                "PATH"   => "Ambiente/Mesa->Ambiente",
                "COLLUMN"=> "NRVAGASSALA",
                "TABLE"  => "SALA",
                "PARENT" => "42.1"
            ),
            (object) array(
                "ID"     => "42.2",
                "NAME"   => "Lojas",
                "PATH"   => NULL,
                "PARENT" => "42"
            ),
            (object) array(
                "ID"     => "43",
                "NAME"   => "Cadastro de Tipo de Campanha Fidelidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "43.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Tipo de Campanha",
                "COLLUMN"=> "CDTPCAMPANHA",
                "TABLE"  => "TPCAMPANHA",
                "PARENT" => "43"
            ),
            (object) array(
                "ID"     => "43.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Tipo de Campanha",
                "COLLUMN"=> "NMTPCAMPANHA",
                "TABLE"  => "TPCAMPANHA",
                "PARENT" => "43"
            ),
            (object) array(
                "ID"     => "44",
                "NAME"   => "Cadastro de Benefícios Fidelidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "45",
                "NAME"   => "Cadastro de Campanhas Fidelidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "45.1",
                "NAME"   => "Cadastro de Campanhas Fidelidade",
                "PATH"   => NULL,
                "PARENT" => "45"
            ),
            (object) array(
                "ID"     => "45.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "CDCAMPANHA",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.2",
                "NAME"   => "Nome Campanha",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "DSCAMPANHA",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.3",
                "NAME"   => "Mecânica de Pontuação",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "IDCAMPANHA",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.4",
                "NAME"   => "Tipo de Campanha",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "NMTPCAMPANHA",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.5",
                "NAME"   => "Inicio da Vigência",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "DTINIVIGCAMP",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.6",
                "NAME"   => "Fim da Vigência",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "DTFIMVIGCAMP",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.7",
                "NAME"   => "A Cada (R$)",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "VRPESOCAMP",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.8",
                "NAME"   => "Ganha-se (Pontos)",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "VRPONTOCAMP",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.9",
                "NAME"   => "Vendas de (R$)",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "VRVENDAINIDOTZ",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.10",
                "NAME"   => "Vendas até (R$)",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "VRVENDAFINDOTZ",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.11",
                "NAME"   => "Código Dotz",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "CDPROMOCAODOTZ",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.12",
                "NAME"   => "Validade Pontos (Dias)",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "NRDIASVALPONTO",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.13",
                "NAME"   => "Utiliza Voucher",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "IDUTILVOUCHER",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.14",
                "NAME"   => "Nr Pontos Voucher",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "VRPONTOVOUCHER",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.1.15",
                "NAME"   => "Validade Voucher (Dias)",
                "PATH"   => "Cadastro de Campanhas Fidelidade",
                "COLLUMN"=> "NRDIAVALVOUCHER",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "45.1"
            ),
            (object) array(
                "ID"     => "45.2",
                "NAME"   => "Unidades Participantes",
                "PATH"   => NULL,
                "PARENT" => "45"
            ),
            (object) array(
                "ID"     => "45.3",
                "NAME"   => "Produto Participante",
                "PATH"   => NULL,
                "PARENT" => "45"
            ),
            (object) array(
                "ID"     => "45.4",
                "NAME"   => "Brinde",
                "PATH"   => NULL,
                "PARENT" => "45"
            ),
            (object) array(
                "ID"     => "46",
                "NAME"   => "Manutenção de Benefícios Fidelidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "47",
                "NAME"   => "Bloquear Cartão Fidelidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "48",
                "NAME"   => "Cadastro de Consumidores Fidelidade para Doação",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "48.1",
                "NAME"   => "Campanha",
                "PATH"   => NULL,
                "PARENT" => "48"
            ),
            (object) array(
                "ID"     => "48.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Consumidores Fidelidade para Doação->Campanha",
                "COLLUMN"=> "CDCAMPANHA",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "48.1"
            ),
            (object) array(
                "ID"     => "48.1.2",
                "NAME"   => "Campanha",
                "PATH"   => "Cadastro de Consumidores Fidelidade para Doação->Campanha",
                "COLLUMN"=> "DSCAMPANHA",
                "TABLE"  => "CAMPANHA",
                "PARENT" => "48.1"
            ),
            (object) array(
                "ID"     => "48.2",
                "NAME"   => "Cartões Disponíveis para Doação",
                "PATH"   => NULL,
                "PARENT" => "48"
            ),
            (object) array(
                "ID"     => "48.3",
                "NAME"   => "Cartões Doados",
                "PATH"   => NULL,
                "PARENT" => "48"
            ),
            (object) array(
                "ID"     => "49",
                "NAME"   => "Teste de Cartões Fidelidade Válidos",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "50",
                "NAME"   => "Manutenção Programa de Fidelidade",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "51",
                "NAME"   => "Tabelas Gerais - Vendas",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "51.1",
                "NAME"   => "Tabelas Gerais - Vendas",
                "PATH"   => NULL,
                "PARENT" => "51"
            ),
            (object) array(
                "ID"     => "51.2",
                "NAME"   => "Erros de Validação",
                "PATH"   => NULL,
                "PARENT" => "51"
            ),
            (object) array(
                "ID"     => "51.3",
                "NAME"   => "Glossário",
                "PATH"   => NULL,
                "PARENT" => "51"
            ),
            (object) array(
                "ID"     => "52",
                "NAME"   => "Tipo de Questionário",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "53",
                "NAME"   => "Banco de Questões",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "54",
                "NAME"   => "Questionário",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "54.1",
                "NAME"   => "Questionário",
                "PATH"   => NULL,
                "PARENT" => "54"
            ),
            (object) array(
                "ID"     => "54.1.1",
                "NAME"   => "Código",
                "PATH"   => "Questionário",
                "COLLUMN"=> "NRQUESTIONARIO",
                "TABLE"  => "QUESTIONARIO",
                "PARENT" => "54.1"
            ),
            (object) array(
                "ID"     => "54.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Questionário",
                "COLLUMN"=> "NMQUESTIONARIO",
                "TABLE"  => "QUESTIONARIO",
                "PARENT" => "54.1"
            ),
            (object) array(
                "ID"     => "54.1.3",
                "NAME"   => "Tipo",
                "PATH"   => "Questionário",
                "COLLUMN"=> "NMTIPOQUESTIONARIO",
                "TABLE"  => "QUESTIONARIO",
                "PARENT" => "54.1"
            ),
            (object) array(
                "ID"     => "54.2",
                "NAME"   => "Questões",
                "PATH"   => NULL,
                "PARENT" => "54"
            ),
            (object) array(
                "ID"     => "55",
                "NAME"   => "Local de Pesquisa",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "56",
                "NAME"   => "Programação da Pesquisa",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "57",
                "NAME"   => "Parâmetros Odhen Go",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "57.1",
                "NAME"   => "Geral",
                "PATH"   => NULL,
                "PARENT" => "57"
            ),
            (object) array(
                "ID"     => "57.1.1",
                "NAME"   => "Cliente Padrão",
                "PATH"   => "Parâmetros Odhen Go->Geral->Geral",
                "COLLUMN"=> "NMRAZSOCCLIE",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "57.1"
            ),
            (object) array(
                "ID"     => "57.1.2",
                "NAME"   => "Senha S3",
                "PATH"   => "Parâmetros Odhen Go->Geral->Cliente Padrão para Vendas",
                "COLLUMN"=> "CDSENHAOGOSHA512",
                "TABLE"  => "PARAMGERAL",
                "PARENT" => "57.1"
            ),
            (object) array(
                "ID"     => "57.2",
                "NAME"   => "Unidade",
                "PATH"   => NULL,
                "PARENT" => "57"
            ),
            (object) array(
                "ID"     => "57.2.1",
                "NAME"   => "Unidade",
                "PATH"   => NULL,
                "PARENT" => "57.2"
            ),
            (object) array(
                "ID"     => "57.2.1.1",
                "NAME"   => "Código",
                "PATH"   => "Parâmetros Odhen Go->Unidade",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "PARAMODHGO",
                "PARENT" => "57.2.1"
            ),
            (object) array(
                "ID"     => "57.2.1.2",
                "NAME"   => "Unidade",
                "PATH"   => "Parâmetros Odhen Go->Unidade",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "PARAMODHGO",
                "PARENT" => "57.2.1"
            ),
            (object) array(
                "ID"     => "57.2.1.3",
                "NAME"   => "Identificador do Consumidor",
                "PATH"   => "Parâmetros Odhen Go->Unidade",
                "COLLUMN"=> "IDTPIDENTIFICACONS",
                "TABLE"  => "PARAMODHGO",
                "PARENT" => "57.2.1"
            ),
            (object) array(
                "ID"     => "57.2.1.4",
                "NAME"   => "Versão Sugerida",
                "PATH"   => "Parâmetros Odhen Go->Unidade",
                "COLLUMN"=> "IDVERSAOSUGERIDA",
                "TABLE"  => "PARAMODHGO",
                "PARENT" => "57.2.1"
            ),
            (object) array(
                "ID"     => "57.2.2",
                "NAME"   => "Caixas Odhen Go",
                "PATH"   => NULL,
                "PARENT" => "57.2"
            ),
            (object) array(
                "ID"     => "57.3",
                "NAME"   => "Arquivos Inteligencia Artificial",
                "PATH"   => NULL,
                "PARENT" => "57"
            ),
            (object) array(
                "ID"     => "58",
                "NAME"   => "Parametrização de Mensagens KDS",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "58.1",
                "NAME"   => "Parametrização de Mensagens KDS",
                "PATH"   => NULL,
                "PARENT" => "58"
            ),
            (object) array(
                "ID"     => "58.1.1",
                "NAME"   => "Código",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "CDMENSAGEM",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1"
            ),
            (object) array(
                "ID"     => "58.1.2",
                "NAME"   => "Mensagem",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "DSMENSAGEM",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1"
            ),
            (object) array(
                "ID"     => "58.1.3",
                "NAME"   => "Hora",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "NRHORA",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1"
            ),
            (object) array(
                "ID"     => "58.1.4",
                "NAME"   => "Arquivo",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "NMARQUIVO",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1"
            ),
            (object) array(
                "ID"     => "58.1.5",
                "NAME"   => "Repetição de Mensagem",
                "PATH"   => NULL,
                "PARENT" => "58.1"
            ),
            (object) array(
                "ID"     => "58.1.5.1",
                "NAME"   => "Intervalo de Repetições (Minutos)",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "MINUTOS",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1.5"
            ),
            (object) array(
                "ID"     => "58.1.5.2",
                "NAME"   => "Intervalo de Repetições (Tempo Total HH:MM)",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "NRREPTINTERV",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1.5"
            ),
            (object) array(
                "ID"     => "58.1.5.3",
                "NAME"   => "Quantidade de Repetições Durante o Dia",
                "PATH"   => "Parametrização de Mensagens KDS",
                "COLLUMN"=> "NRQTDREPTINTERV",
                "TABLE"  => "KDSMENSAGEM",
                "PARENT" => "58.1.5"
            ),
            (object) array(
                "ID"     => "58.2",
                "NAME"   => "Dias da Semana",
                "PATH"   => NULL,
                "PARENT" => "58"
            ),
            (object) array(
                "ID"     => "58.3",
                "NAME"   => "Setores",
                "PATH"   => NULL,
                "PARENT" => "58"
            ),
            (object) array(
                "ID"     => "59",
                "NAME"   => "Parametrização Relatório DRE",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "59.1",
                "NAME"   => "Geral",
                "PATH"   => NULL,
                "PARENT" => "59"
            ),
            (object) array(
                "ID"     => "59.1.1",
                "NAME"   => "Retirada Vendas (Consolidação)",
                "PATH"   => "Parametrização Relatório DRE->Geral",
                "COLLUMN"=> "NMTIPORETIVENDA",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1"
            ),
            (object) array(
                "ID"     => "59.1.2",
                "NAME"   => "Retirada Consumo Funcionários",
                "PATH"   => "Parametrização Relatório DRE->Geral",
                "COLLUMN"=> "NMTIPORETIFUNC",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1"
            ),
            (object) array(
                "ID"     => "59.1.3",
                "NAME"   => "Retirada Desperdício",
                "PATH"   => "Parametrização Relatório DRE->Geral",
                "COLLUMN"=> "NMTIPORETIDESPERDICIO",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1"
            ),
            (object) array(
                "ID"     => "59.1.4",
                "NAME"   => "Class. Fin. Compras",
                "PATH"   => "Parametrização Relatório DRE->Geral",
                "COLLUMN"=> "DSCLASSFINACOMPRA",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1"
            ),
            (object) array(
                "ID"     => "59.1.5",
                "NAME"   => "Parametrização para Taxa Administrativa do Cartão",
                "PATH"   => NULL,
                "PARENT" => "59.1"
            ),
            (object) array(
                "ID"     => "59.1.5.1",
                "NAME"   => "Classificação Financeira",
                "PATH"   => "Parametrização Relatório DRE->Geral->Parametrização para Taxa Administrativa do Cartão",
                "COLLUMN"=> "DSCLASSFINADRE",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1.5"
            ),
            (object) array(
                "ID"     => "59.1.5.2",
                "NAME"   => "Ajustes",
                "PATH"   => "Parametrização Relatório DRE->Geral->Parametrização para Taxa Administrativa do Cartão",
                "COLLUMN"=> "CDAJUCTPAGDRE",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1.5"
            ),
            (object) array(
                "ID"     => "59.1.6",
                "NAME"   => "Parametrização Despesas",
                "PATH"   => NULL,
                "PARENT" => "59.1"
            ),
            (object) array(
                "ID"     => "59.1.6.1",
                "NAME"   => "Class. Fin. Compras",
                "PATH"   => "Parametrização Relatório DRE->Geral->Parametrização Despesas",
                "COLLUMN"=> "DSCLASSFINADESPESAS",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1.6"
            ),
            (object) array(
                "ID"     => "59.1.6.2",
                "NAME"   => "Ajustes Despesas",
                "PATH"   => "Parametrização Relatório DRE->Geral->Parametrização Despesas",
                "COLLUMN"=> "CDAJUDESPESAS",
                "TABLE"  => "PARAMDRE",
                "PARENT" => "59.1.6"
            ),
            (object) array(
                "ID"     => "59.2",
                "NAME"   => "Classificação Financeira",
                "PATH"   => NULL,
                "PARENT" => "59"
            ),
            (object) array(
                "ID"     => "59.2.1",
                "NAME"   => "Código",
                "PATH"   => "Classificação Financeira",
                "COLLUMN"=> "CDCLASSFINA",
                "TABLE"  => "CLASSFINANC",
                "PARENT" => "59.2"
            ),
            (object) array(
                "ID"     => "59.2.2",
                "NAME"   => "Classificação Financeira",
                "PATH"   => "Classificação Financeira",
                "COLLUMN"=> "DSCLASSFINA",
                "TABLE"  => "CLASSFINANC",
                "PARENT" => "59.2"
            ),
            (object) array(
                "ID"     => "59.2.3",
                "NAME"   => "Categoria",
                "PATH"   => "Classificação Financeira",
                "COLLUMN"=> "IDTPCLASS",
                "TABLE"  => "CLASSFINANC",
                "PARENT" => "59.2"
            ),
            (object) array(
                "ID"     => "59.2.4",
                "NAME"   => "Visualiza",
                "PATH"   => "Classificação Financeira",
                "COLLUMN"=> "IDVISUDRE",
                "TABLE"  => "CLASSFINANC",
                "PARENT" => "59.2"
            ),
            (object) array(
                "ID"     => "59.2.5",
                "NAME"   => "Ordem",
                "PATH"   => "Classificação Financeira",
                "COLLUMN"=> "IDORDEMDRE",
                "TABLE"  => "CLASSFINANC",
                "PARENT" => "59.2"
            ),
            (object) array(
                "ID"     => "60",
                "NAME"   => "Parâmetros de Integração e Aplicativos",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "60.1",
                "NAME"   => "Projeto",
                "PATH"   => NULL,
                "PARENT" => "60"
            ),
            (object) array(
                "ID"     => "60.2",
                "NAME"   => "E-mail do Responsável Técnico",
                "PATH"   => NULL,
                "PARENT" => "60"
            ),
            (object) array(
                "ID"     => "60.3",
                "NAME"   => "Unidades Participantes",
                "PATH"   => NULL,
                "PARENT" => "60"
            ),
            (object) array(
                "ID"     => "60.4",
                "NAME"   => "Mapeamento do Produto",
                "PATH"   => NULL,
                "PARENT" => "60"
            ),
            (object) array(
                "ID"     => "61",
                "NAME"   => "Cadastro de Cargo",
                "PATH"   => NULL,
                "PARENT" => NULL
            ),
            (object) array(
                "ID"     => "61.1",
                "NAME"   => "Cadastro de Cargo",
                "PATH"   => NULL,
                "PARENT" => "61"
            ),
            (object) array(
                "ID"     => "61.1.1",
                "NAME"   => "Código",
                "PATH"   => "Cadastro de Cargo",
                "COLLUMN"=> "CDCARGO",
                "TABLE"  => "CARGOVENDAS",
                "PARENT" => "61.1"
            ),
            (object) array(
                "ID"     => "61.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Cadastro de Cargo",
                "COLLUMN"=> "NMCARGO",
                "TABLE"  => "CARGOVENDAS",
                "PARENT" => "61.1"
            ),
            (object) array(
                "ID"     => "61.2",
                "NAME"   => "Operador",
                "PATH"   => NULL,
                "PARENT" => "61"
            ),
            (object) array(
                "ID"     => "61.2.1",
                "NAME"   => "Operador",
                "PATH"   => NULL,
                "PARENT" => "61.2"
            ),
            (object) array(
                "ID"     => "61.2.1.1",
                "NAME"   => "Código",
                "PATH"   => "Operador",
                "COLLUMN"=> "CDOPERADOR",
                "TABLE"  => "CARGOVENDASOPERADOR",
                "PARENT" => "61.2.1"
            ),
            (object) array(
                "ID"     => "61.2.1.2",
                "NAME"   => "Nome",
                "PATH"   => "Operador",
                "COLLUMN"=> "NMOPERADOR",
                "TABLE"  => "CARGOVENDASOPERADOR",
                "PARENT" => "61.2.1"
            ),
            (object) array(
                "ID"     => "61.2.2",
                "NAME"   => "Unidade",
                "PATH"   => NULL,
                "PARENT" => "61.2"
            ),
            (object) array(
                "ID"     => "61.2.2.1",
                "NAME"   => "Unidade",
                "PATH"   => "Operador",
                "COLLUMN"=> "CDFILIAL",
                "TABLE"  => "CARGOVENDASFILIAL",
                "PARENT" => "61.2.2"
            ),
            (object) array(
                "ID"     => "61.2.2.2",
                "NAME"   => "Nome",
                "PATH"   => "Operador",
                "COLLUMN"=> "NMFILIAL",
                "TABLE"  => "CARGOVENDASFILIAL",
                "PARENT" => "61.2.2"
            )
        );


        $response->addDataSet(new DataSet('findParametrization', $data));
    }
}
?>